import {Meteor} from 'meteor/meteor';
import {Template} from 'meteor/templating';
import {ReactiveVar} from 'meteor/reactive-var';
import {Tracker} from 'meteor/tracker';

//import permissions module from lib folder
const permissions = require('../lib/permissions');

console.log("client main.js loaded"); //for test purposes
import './main.html';

const ANONUSERID_SESSION_KEY = "anonUserId"; //quoted b/c otherwise WS thinks it's a var
const CURRENTUSER_SESSION_KEY = "currentUser";

/*
This currently isn't working; it was the most recent thing I was trying to do.
The idea with the persistent session is that a logged-out user can only see
a limited number of images, and these images should be pulled from the least-voted on fies.
 */
//working on the persistent session
Tracker.autorun(function(){

    if (Meteor.userId()) {
        Session.set(CURRENTUSER_SESSION_KEY, Meteor.userId());
    }
    else {
        Session.set(CURRENTUSER_SESSION_KEY, anonUserId());
    }
    console.log("tracker setting current user session: "+Session.get(CURRENTUSER_SESSION_KEY));
});


Template.uploadedFiles.helpers({

    //test if the current user is the owner
    //I believe this is to hide things on the client side
    isMeteorUserId: function (userId) {
        //console.log("inside isMeteorUserId " + userId);
        return userId === Meteor.userId();
    },

    //Displays the images themselves
    uploadedFiles: function () {

        //this line is the original one that's just returning all the images
        //More specifically it is creating a cursor for FilesCollection - 4/12/17
        return Images.find();


        /*
        This was more persistent session code, currently commented out because we
        couldn't get it working and it was crashing the app, which I needed to demo.
         */

        // //Added 4/21/17
        // if (Meteor.userId()) {
        //
        //    let ImagesCursor = Images.find();
        //     console.log("ImagesCursor count: "+ImagesCursor.count());
        //     return ImagesCursor;
        // }
        // else { //everything in this block is when user isn't logged in
        //     //console.log(anonUserImageList);
        //
        //
        //     let fileIdsToDisplay;
        //     let anonId = Session.get(ANONUSERID_SESSION_KEY);
        //     console.log("anonId (aka voterId): " + anonId);
        //
        //     /* getting list of images; if there already is a list of fileIds in the
        //     database that's what you'd be getting; it's finding the one where the
        //     anonId matched */
        //     const fileIdResult = AnonUserImageList.findOne({anonId: anonId});
        //     console.log("fileIdResult: " + fileIdResult); //added 4/24/17
        //
        //     if (fileIdResult) {
        //         fileIdsToDisplay = fileIdResult.fileIds;
        //         console.log("Found existing file_IdsToDisplay: " + fileIdsToDisplay);
        //     }
        //     else { //if the find in fileIdResult doesn't return anything
        //         fileIdsToDisplay = [];
        //
        //
        //         //we should be returning all the images here, but instead
        //         //we aren't getting anything for some reason 4/28/17
        //         let ImagesCursor = Images.find();//{}, {limit: 5/*, sort: {"meta.vote.count": 1}*/});
        //
        //         console.log("ImagesCursor count: "+ImagesCursor.count());
        //
        //         ImagesCursor.forEach(
        //             function (doc) {
        //                 console.log(doc);
        //                 this.push(doc._id);
        //             }, fileIdsToDisplay
        //         );
        //         console.log("New file_Ids: " + fileIdsToDisplay);
        //         //insert back into the collection
        //         AnonUserImageList.insert({anonId: anonId, fileIds: fileIdsToDisplay});
        //     }
        //
        //     return Images.find({_id: {$in: fileIdsToDisplay}});
        // }
    },

    /*
     Dave [Professor David Brown] was thinking that we would know only the fileId and not the userId,
     forgetting that this code is actually running on the client. Probably
     silly to pass the fileId and look up the userId we already know from the file.
     */
    isMine: function (fileId) {
        //console.log("Invoked Template.uploadedFiles.helpers.isMine");
        const image = Images.findOne(fileId)
        if (image) {
            return Meteor.userId() == image.userId;
        }
        return false;
    },

    votedUp: function (fileId) {
        //the vote that was cast
        const vote = currentUserVote(fileId);
        return vote == 1;
    },

    votedDown: function (fileId) {
        //the vote that was cast
        const vote = currentUserVote(fileId);
        return vote == -1;
    }


}); //end uploadedFiles.helpers


//added 4/28/17
Template.anonUser.helpers({
    id: function () {
        console.log("anonUser helper was called");
        //could be anonymous, but this would be overidden by a logged in user
        return Session.get(CURRENTUSER_SESSION_KEY);
    }
});

//added 4/28/17
//This creates the "userId", called anonUserId, for a user who isn't logged in
function anonUserId() {
    if (!Session.get(ANONUSERID_SESSION_KEY)) {
        console.log("inside voterId helper func not logged in");
        //create one
        Session.setPersistent(ANONUSERID_SESSION_KEY, "anon+" + makeid());
    }
    return Session.get(ANONUSERID_SESSION_KEY);
}

//create a random string for above anonUserId function
function makeid()
{
    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

    for( var i=0; i < 16; i++ )
        text += possible.charAt(Math.floor(Math.random() * possible.length));

    return text;
}

function currentUserVote(fileId) {
    //get the meta property of the image
    const meta = Images.findOne(fileId).meta;

    //if the meta has a vote, gets the userId of the current user
    //this works because it's running on the client (in browser)
    const vote = meta.vote ? meta.vote.users[Session.get("anonUserId")] : undefined;

    return vote;
}


//abstracting Meteor.userId() to add anonUserId so that logged-out users can vote
function voterId() {

    console.log("still calling old voterId") //for debugging

    return Session.get("anonUserId");
}


Template.uploadedFiles.events({
    //Edit the title - Click on the title to edit
    'click .anondocTitle.editable': function (event) {
        const span = $(event.target);

        //first trim trims what's in the span
        //second trim is if someone puts spaces in the title, it will trim it to an empty string (response)
        newTitle = prompt("Please enter your title.", span.html().trim()).trim();

        //if newTitle == null, cancel button was pressed
        if (newTitle == null) {
            return;
        }
        ;

        //getting fileId from the browser's document object model,
        //specifically data-fileid property of the span
        //(these are always retrieved as lowercase)
        const fileId = span.data("fileid");
        //console.log("Updating " + fileId + " Setting title " + newTitle);

        //retrieving just the meta object of this file
        const fileMeta = Images.findOne(fileId).meta;
        //console.log(fileMeta);

        //set the new title
        if (newTitle) {
            fileMeta.title = newTitle;
        } else {
            delete fileMeta.title;
        }

        //update the file collection
        Images.update(fileId, {
            $set: {meta: fileMeta}
        });
    },

    //Upvote button clicked
    'click .event-upvote': function (event) {
        const button = $(event.target);

        const fileId = button.data("fileid");

        //if the vote was 1, then change it to 0
        const value = currentUserVote(fileId) == 1 ? 0 : 1;

        console.log("Upvote button clicked");

        vote(fileId, value);
    },


    //Downvote button clicked
    'click .event-downvote': function (event) {
        const button = $(event.target);

        const fileId = button.data("fileid");

        //if the vote was -1, then change it to 0
        const value = currentUserVote(fileId) == -1 ? 0 : -1;

        console.log("Downvote button clicked");

        vote(fileId, value);
    }

});


//Displays # of uploaded images of current user
//Returning an instance of FilesCursor, which includes a count method
//(See Meteor-Files documentation online)
Template.uploadedFilesMine.helpers({
    uploadedFilesMine: function () {
        return Images.find({userId: Meteor.userId()});
    }
});


//After user chooses the image from their computer, this uploads it to the site
Template.uploadForm.onCreated(function () {
    this.currentUpload = new ReactiveVar(false);
});


//I don't really know what this template helper does - 2/15/17
//(b/c upload seems to have worked even when it was commented out)
//Might just return the image that's currently being uploaded so that works
Template.uploadForm.helpers({

    canUpload: Meteor.userId(),
    magic: "abrakadabra!",

    currentUpload: function () {
        return Template.instance().currentUpload.get();
    }
});



/*Added with the ostrio:files meteor package
* The package itself is called Meteor-files
*/
//~The uploading mechanism~
Template.uploadForm.events({
    //change thing with id fileInput
    'change #fileInput': function (e, template) {

        //this goes to the browser console
        // console.log("Processing change file input");
        //  console.log("userId = " + Meteor.userId());

        if (e.currentTarget.files && e.currentTarget.files[0]) {
            // We upload only one file, in case
            // there was multiple files selected
            var file = e.currentTarget.files[0];
            if (file) {
                var uploadInstance = Images.insert({
                    file: file,
                    streams: 'dynamic',
                    chunkSize: 'dynamic'
                }, false);

                uploadInstance.on('start', function () {
                    template.currentUpload.set(this);
                });

                uploadInstance.on('end', function (error, fileObj) {
                    if (error) {
                        alert('Error during upload: ' + error.reason);
                    } else {
                        alert('File "' + fileObj.name + '" successfully uploaded; user ID = ' + fileObj.userId + " ; Meteor.userid = " + Meteor.userId());
                    }
                    template.currentUpload.set(false);
                });

                uploadInstance.start();
            }
        }
    },
});

/*
I added the iron:router package, but didn't end up using it in the end.
iron:router is used to make multiple pages, rather than a single-page app.
 */
//Removes the iron:router splash info from the bottom of the page
Router.configure({
    layoutTemplate: 'ApplicationLayout',
    //template: 'noRoutesTemplate',
});

//voting logic
function vote(fileId, value) {

    //retrieving just the meta object of this file
    const fileMeta = Images.findOne(fileId).meta;
    //console.log(fileMeta);

    //the empty vote, when nothing's happened
    //if there's no vote property object, create one
    if (!fileMeta.vote) {
        fileMeta.vote = {total: 0, users: {}, count: 0}
    }
    //zero value cancels existing vote
    if (value == 0) {
        delete fileMeta.vote.users[Session.get("anonUserId")];
    }
    //checks if userId is a truthy value
    else {
        fileMeta.vote.users[Session.get("anonUserId")] = value;
    }

    var total = 0;
    var count = 0;    //This is for the sort hopefully 4/14/17

    //calculate number of total votes based on number of
    //users who have voted?
    for (var v in fileMeta.vote.users) {
        total += fileMeta.vote.users[v];
        //keep track of total number of times document has been voted on 4/14/17
        count++;
    }

    fileMeta.vote.total = total;
    fileMeta.vote.count = count;

    //console.log("Voting: " + fileMeta);

    //update the file collection
    Images.update(fileId, {
        $set: {meta: fileMeta}
    });
}