(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var WebApp = Package.webapp.WebApp;
var main = Package.webapp.main;
var WebAppInternals = Package.webapp.WebAppInternals;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var _ = Package.underscore._;
var check = Package.check.check;
var Match = Package.check.Match;
var Random = Package.random.Random;
var ECMAScript = Package.ecmascript.ECMAScript;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;

/* Package-scope variables */
var __coffeescriptShare, FilesCollection;

var require = meteorInstall({"node_modules":{"meteor":{"ostrio:files":{"files.coffee.js":["meteor/ostrio:cookies","./event-emitter.jsx",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/ostrio_files/files.coffee.js                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
module.export({                                                                                                        // 1
  FilesCollection: function () {                                                                                       // 1
    return FilesCollection;                                                                                            // 1
  }                                                                                                                    // 1
});                                                                                                                    // 1
var Cookies = void 0;                                                                                                  // 1
module.import('meteor/ostrio:cookies', {                                                                               // 1
  "Cookies": function (v) {                                                                                            // 1
    Cookies = v;                                                                                                       // 1
  }                                                                                                                    // 1
}, 0);                                                                                                                 // 1
var EventEmitter, FileCursor, FilesCursor, NOOP, Throttle, bound, events, fileType, fixJSONParse, fixJSONStringify, formatFleURL, fs, nodePath, request, writeStream;
                                                                                                                       //
NOOP = function () {};                                                                                                 // 2
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 4
  /*                                                                                                                   // 5
  @summary Require NPM packages                                                                                        //
   */fs = Npm.require('fs-extra');                                                                                     //
  events = Npm.require('events');                                                                                      // 9
  request = Npm.require('request');                                                                                    // 10
  Throttle = Npm.require('throttle');                                                                                  // 11
  fileType = Npm.require('file-type');                                                                                 // 12
  nodePath = Npm.require('path'); /*                                                                                   // 13
                                  @var {Object} bound - Meteor.bindEnvironment (Fiber wrapper)                         //
                                   */                                                                                  //
  bound = Meteor.bindEnvironment(function (callback) {                                                                 // 18
    return callback();                                                                                                 // 18
  }); /*                                                                                                               // 18
      @private                                                                                                         //
      @locus Server                                                                                                    //
      @class writeStream                                                                                               //
      @param path      {String} - Path to file on FS                                                                   //
      @param maxLength {Number} - Max amount of chunks in stream                                                       //
      @param file      {Object} - fileRef Object                                                                       //
      @summary writableStream wrapper class, makes sure chunks is written in given order. Implementation of queue stream.
       */                                                                                                              //
                                                                                                                       //
  writeStream = function () {                                                                                          // 29
    function writeStream(path1, maxLength, file1, permissions) {                                                       // 30
      var self;                                                                                                        // 31
      this.path = path1;                                                                                               // 30
      this.maxLength = maxLength;                                                                                      // 30
      this.file = file1;                                                                                               // 30
      this.permissions = permissions;                                                                                  // 30
                                                                                                                       //
      if (!this.path || !_.isString(this.path)) {                                                                      // 31
        return;                                                                                                        // 32
      }                                                                                                                // 43
                                                                                                                       //
      self = this;                                                                                                     // 34
      this.fd = null;                                                                                                  // 35
      fs.open(this.path, 'w+', this.permissions, function (error, fd) {                                                // 36
        return bound(function () {                                                                                     // 47
          if (error) {                                                                                                 // 37
            throw new Meteor.Error(500, '[FilesCollection] [writeStream] [Exception:]', error);                        // 38
          } else {                                                                                                     // 37
            self.fd = fd;                                                                                              // 40
          }                                                                                                            // 52
        });                                                                                                            // 36
      });                                                                                                              // 36
      this.ended = false;                                                                                              // 42
      this.aborted = false;                                                                                            // 43
      this.writtenChunks = 0;                                                                                          // 44
    } /*                                                                                                               // 30
      @memberOf writeStream                                                                                            //
      @name write                                                                                                      //
      @param {Number} num - Chunk position in stream                                                                   //
      @param {Buffer} chunk - Chunk binary data                                                                        //
      @param {Function} callback - Callback                                                                            //
      @summary Write chunk in given order                                                                              //
      @returns {Boolean} - True if chunk is sent to stream, false if chunk is set into queue                           //
       */                                                                                                              //
                                                                                                                       //
    writeStream.prototype.write = function (num, chunk, callback) {                                                    // 71
      var _stream, self;                                                                                               // 56
                                                                                                                       //
      if (!this.aborted && !this.ended) {                                                                              // 56
        self = this;                                                                                                   // 57
                                                                                                                       //
        if (this.fd) {                                                                                                 // 58
          _stream = fs.createWriteStream(this.path, {                                                                  // 59
            flags: 'r+',                                                                                               // 60
            mode: this.permissions,                                                                                    // 61
            highWaterMark: 0,                                                                                          // 62
            fd: this.fd,                                                                                               // 63
            autoClose: true,                                                                                           // 64
            start: (num - 1) * this.file.chunkSize                                                                     // 65
          });                                                                                                          // 59
                                                                                                                       //
          _stream.on('error', function (error) {                                                                       // 67
            return bound(function () {                                                                                 // 85
              console.error("[FilesCollection] [writeStream] [ERROR:]", error);                                        // 68
              self.abort();                                                                                            // 69
            });                                                                                                        // 67
          });                                                                                                          // 67
                                                                                                                       //
          _stream.write(chunk, function () {                                                                           // 71
            return bound(function () {                                                                                 // 91
              ++self.writtenChunks;                                                                                    // 72
              callback && callback();                                                                                  // 73
            });                                                                                                        // 71
          });                                                                                                          // 71
        } else {                                                                                                       // 58
          Meteor.setTimeout(function () {                                                                              // 76
            self.write(num, chunk, callback);                                                                          // 77
          }, 25);                                                                                                      // 76
        }                                                                                                              // 56
      }                                                                                                                // 101
                                                                                                                       //
      return false;                                                                                                    // 80
    }; /*                                                                                                              // 55
       @memberOf writeStream                                                                                           //
       @name end                                                                                                       //
       @param {Function} callback - Callback                                                                           //
       @summary Finishes writing to writableStream, only after all chunks in queue is written                          //
       @returns {Boolean} - True if stream is fulfilled, false if queue is in progress                                 //
        */                                                                                                             //
                                                                                                                       //
    writeStream.prototype.end = function (callback) {                                                                  // 114
      var self;                                                                                                        // 90
                                                                                                                       //
      if (!this.aborted && !this.ended) {                                                                              // 90
        if (this.writtenChunks === this.maxLength) {                                                                   // 91
          self = this;                                                                                                 // 92
          fs.close(this.fd, function () {                                                                              // 93
            return bound(function () {                                                                                 // 120
              self.ended = true;                                                                                       // 94
              callback && callback(true);                                                                              // 95
            });                                                                                                        // 93
          });                                                                                                          // 93
          return true;                                                                                                 // 97
        } else {                                                                                                       // 91
          self = this;                                                                                                 // 99
          Meteor.setTimeout(function () {                                                                              // 100
            self.end(callback);                                                                                        // 101
          }, 25);                                                                                                      // 100
        }                                                                                                              // 90
      } else {                                                                                                         // 90
        callback && callback(false);                                                                                   // 105
      }                                                                                                                // 134
                                                                                                                       //
      return false;                                                                                                    // 106
    }; /*                                                                                                              // 89
       @memberOf writeStream                                                                                           //
       @name abort                                                                                                     //
       @param {Function} callback - Callback                                                                           //
       @summary Aborts writing to writableStream, removes created file                                                 //
       @returns {Boolean} - True                                                                                       //
        */                                                                                                             //
                                                                                                                       //
    writeStream.prototype.abort = function (callback) {                                                                // 147
      this.aborted = true;                                                                                             // 116
      fs.unlink(this.path, callback || NOOP);                                                                          // 117
      return true;                                                                                                     // 118
    }; /*                                                                                                              // 115
       @memberOf writeStream                                                                                           //
       @name stop                                                                                                      //
       @summary Stop writing to writableStream                                                                         //
       @returns {Boolean} - True                                                                                       //
        */                                                                                                             //
                                                                                                                       //
    writeStream.prototype.stop = function () {                                                                         // 161
      this.aborted = true;                                                                                             // 127
      this.ended = true;                                                                                               // 128
      return true;                                                                                                     // 129
    };                                                                                                                 // 126
                                                                                                                       //
    return writeStream;                                                                                                // 167
  }();                                                                                                                 // 169
} else {                                                                                                               // 4
  EventEmitter = require('./event-emitter.jsx').EventEmitter;                                                          // 131
} /*                                                                                                                   // 172
  @private                                                                                                             //
  @locus Anywhere                                                                                                      //
  @class FileCursor                                                                                                    //
  @param _fileRef    {Object} - Mongo-Style selector (http://docs.meteor.com/api/collections.html#selectors)           //
  @param _collection {FilesCollection} - FilesCollection Instance                                                      //
  @summary Internal class, represents each record in `FilesCursor.each()` or document returned from `.findOne()` method
   */                                                                                                                  //
                                                                                                                       //
FileCursor = function () {                                                                                             // 141
  function FileCursor(_fileRef, _collection) {                                                                         // 142
    var self;                                                                                                          // 143
    this._fileRef = _fileRef;                                                                                          // 142
    this._collection = _collection;                                                                                    // 142
    self = this;                                                                                                       // 143
    self = _.extend(self, this._fileRef);                                                                              // 144
  } /*                                                                                                                 // 142
    @locus Anywhere                                                                                                    //
    @memberOf FileCursor                                                                                               //
    @name remove                                                                                                       //
    @param callback {Function} - Triggered asynchronously after item is removed or failed to be removed                //
    @summary Remove document                                                                                           //
    @returns {FileCursor}                                                                                              //
     */                                                                                                                //
                                                                                                                       //
  FileCursor.prototype.remove = function (callback) {                                                                  // 203
    if (this._collection.debug) {                                                                                      // 155
      console.info('[FilesCollection] [FileCursor] [remove()]');                                                       // 155
    }                                                                                                                  // 206
                                                                                                                       //
    if (this._fileRef) {                                                                                               // 156
      this._collection.remove(this._fileRef._id, callback);                                                            // 157
    } else {                                                                                                           // 156
      callback && callback(new Meteor.Error(404, 'No such file'));                                                     // 159
    }                                                                                                                  // 211
                                                                                                                       //
    return this;                                                                                                       // 160
  }; /*                                                                                                                // 154
     @locus Anywhere                                                                                                   //
     @memberOf FileCursor                                                                                              //
     @name link                                                                                                        //
     @param version {String} - Name of file's subversion                                                               //
     @summary Returns downloadable URL to File                                                                         //
     @returns {String}                                                                                                 //
      */                                                                                                               //
                                                                                                                       //
  FileCursor.prototype.link = function (version) {                                                                     // 225
    if (this._collection.debug) {                                                                                      // 171
      console.info("[FilesCollection] [FileCursor] [link(" + version + ")]");                                          // 171
    }                                                                                                                  // 228
                                                                                                                       //
    if (this._fileRef) {                                                                                               // 172
      return this._collection.link(this._fileRef, version);                                                            // 230
    } else {                                                                                                           // 172
      return '';                                                                                                       // 232
    }                                                                                                                  // 233
  }; /*                                                                                                                // 170
     @locus Anywhere                                                                                                   //
     @memberOf FileCursor                                                                                              //
     @name get                                                                                                         //
     @param property {String} - Name of sub-object property                                                            //
     @summary Returns current document as a plain Object, if `property` is specified - returns value of sub-object property
     @returns {Object|mix}                                                                                             //
      */                                                                                                               //
                                                                                                                       //
  FileCursor.prototype.get = function (property) {                                                                     // 246
    if (this._collection.debug) {                                                                                      // 183
      console.info("[FilesCollection] [FileCursor] [get(" + property + ")]");                                          // 183
    }                                                                                                                  // 249
                                                                                                                       //
    if (property) {                                                                                                    // 184
      return this._fileRef[property];                                                                                  // 185
    } else {                                                                                                           // 184
      return this._fileRef;                                                                                            // 187
    }                                                                                                                  // 254
  }; /*                                                                                                                // 182
     @locus Anywhere                                                                                                   //
     @memberOf FileCursor                                                                                              //
     @name fetch                                                                                                       //
     @summary Returns document as plain Object in Array                                                                //
     @returns {[Object]}                                                                                               //
      */                                                                                                               //
                                                                                                                       //
  FileCursor.prototype.fetch = function () {                                                                           // 266
    if (this._collection.debug) {                                                                                      // 197
      console.info('[FilesCollection] [FileCursor] [fetch()]');                                                        // 197
    }                                                                                                                  // 269
                                                                                                                       //
    return [this._fileRef];                                                                                            // 198
  }; /*                                                                                                                // 196
     @locus Anywhere                                                                                                   //
     @memberOf FileCursor                                                                                              //
     @name with                                                                                                        //
     @summary Returns reactive version of current FileCursor, useful to use with `{{#with}}...{{/with}}` block template helper
     @returns {[Object]}                                                                                               //
      */                                                                                                               //
                                                                                                                       //
  FileCursor.prototype["with"] = function () {                                                                         // 282
    var self;                                                                                                          // 208
                                                                                                                       //
    if (this._collection.debug) {                                                                                      // 208
      console.info('[FilesCollection] [FileCursor] [with()]');                                                         // 208
    }                                                                                                                  // 286
                                                                                                                       //
    self = this;                                                                                                       // 209
    return _.extend(self, this._collection.collection.findOne(this._fileRef._id));                                     // 210
  };                                                                                                                   // 207
                                                                                                                       //
  return FileCursor;                                                                                                   // 291
}(); /*                                                                                                                // 293
     @private                                                                                                          //
     @locus Anywhere                                                                                                   //
     @class FilesCursor                                                                                                //
     @param _selector   {String|Object}   - Mongo-Style selector (http://docs.meteor.com/api/collections.html#selectors)
     @param options     {Object}          - Mongo-Style selector Options (http://docs.meteor.com/api/collections.html#selectors)
     @param _collection {FilesCollection} - FilesCollection Instance                                                   //
     @summary Implementation of Cursor for FilesCollection                                                             //
      */                                                                                                               //
                                                                                                                       //
FilesCursor = function () {                                                                                            // 221
  function FilesCursor(_selector, options, _collection) {                                                              // 222
    this._selector = _selector != null ? _selector : {};                                                               // 222
    this._collection = _collection;                                                                                    // 222
    this._current = -1;                                                                                                // 223
    this.cursor = this._collection.collection.find(this._selector, options);                                           // 224
  } /*                                                                                                                 // 222
    @locus Anywhere                                                                                                    //
    @memberOf FilesCursor                                                                                              //
    @name get                                                                                                          //
    @summary Returns all matching document(s) as an Array. Alias of `.fetch()`                                         //
    @returns {[Object]}                                                                                                //
     */                                                                                                                //
                                                                                                                       //
  FilesCursor.prototype.get = function () {                                                                            // 323
    if (this._collection.debug) {                                                                                      // 234
      console.info("[FilesCollection] [FilesCursor] [get()]");                                                         // 234
    }                                                                                                                  // 326
                                                                                                                       //
    return this.cursor.fetch();                                                                                        // 235
  }; /*                                                                                                                // 233
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name hasNext                                                                                                     //
     @summary Returns `true` if there is next item available on Cursor                                                 //
     @returns {Boolean}                                                                                                //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.hasNext = function () {                                                                        // 339
    if (this._collection.debug) {                                                                                      // 245
      console.info('[FilesCollection] [FilesCursor] [hasNext()]');                                                     // 245
    }                                                                                                                  // 342
                                                                                                                       //
    return this._current < this.cursor.count() - 1;                                                                    // 246
  }; /*                                                                                                                // 244
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name next                                                                                                        //
     @summary Returns next item on Cursor, if available                                                                //
     @returns {Object|undefined}                                                                                       //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.next = function () {                                                                           // 355
    if (this._collection.debug) {                                                                                      // 256
      console.info('[FilesCollection] [FilesCursor] [next()]');                                                        // 256
    }                                                                                                                  // 358
                                                                                                                       //
    if (this.hasNext()) {                                                                                              // 257
      return this.cursor.fetch()[++this._current];                                                                     // 258
    }                                                                                                                  // 361
  }; /*                                                                                                                // 255
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name hasPrevious                                                                                                 //
     @summary Returns `true` if there is previous item available on Cursor                                             //
     @returns {Boolean}                                                                                                //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.hasPrevious = function () {                                                                    // 373
    if (this._collection.debug) {                                                                                      // 268
      console.info('[FilesCollection] [FilesCursor] [hasPrevious()]');                                                 // 268
    }                                                                                                                  // 376
                                                                                                                       //
    return this._current !== -1;                                                                                       // 269
  }; /*                                                                                                                // 267
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name previous                                                                                                    //
     @summary Returns previous item on Cursor, if available                                                            //
     @returns {Object|undefined}                                                                                       //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.previous = function () {                                                                       // 389
    if (this._collection.debug) {                                                                                      // 279
      console.info('[FilesCollection] [FilesCursor] [previous()]');                                                    // 279
    }                                                                                                                  // 392
                                                                                                                       //
    if (this.hasPrevious()) {                                                                                          // 280
      return this.cursor.fetch()[--this._current];                                                                     // 281
    }                                                                                                                  // 395
  }; /*                                                                                                                // 278
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name fetch                                                                                                       //
     @summary Returns all matching document(s) as an Array.                                                            //
     @returns {[Object]}                                                                                               //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.fetch = function () {                                                                          // 407
    if (this._collection.debug) {                                                                                      // 291
      console.info('[FilesCollection] [FilesCursor] [fetch()]');                                                       // 291
    }                                                                                                                  // 410
                                                                                                                       //
    return this.cursor.fetch();                                                                                        // 292
  }; /*                                                                                                                // 290
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name first                                                                                                       //
     @summary Returns first item on Cursor, if available                                                               //
     @returns {Object|undefined}                                                                                       //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.first = function () {                                                                          // 423
    var ref;                                                                                                           // 302
                                                                                                                       //
    if (this._collection.debug) {                                                                                      // 302
      console.info('[FilesCollection] [FilesCursor] [first()]');                                                       // 302
    }                                                                                                                  // 427
                                                                                                                       //
    this._current = 0;                                                                                                 // 303
    return (ref = this.fetch()) != null ? ref[this._current] : void 0;                                                 // 304
  }; /*                                                                                                                // 301
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name last                                                                                                        //
     @summary Returns last item on Cursor, if available                                                                //
     @returns {Object|undefined}                                                                                       //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.last = function () {                                                                           // 441
    var ref;                                                                                                           // 314
                                                                                                                       //
    if (this._collection.debug) {                                                                                      // 314
      console.info('[FilesCollection] [FilesCursor] [last()]');                                                        // 314
    }                                                                                                                  // 445
                                                                                                                       //
    this._current = this.count() - 1;                                                                                  // 315
    return (ref = this.fetch()) != null ? ref[this._current] : void 0;                                                 // 316
  }; /*                                                                                                                // 313
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name count                                                                                                       //
     @summary Returns the number of documents that match a query                                                       //
     @returns {Number}                                                                                                 //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.count = function () {                                                                          // 459
    if (this._collection.debug) {                                                                                      // 326
      console.info('[FilesCollection] [FilesCursor] [count()]');                                                       // 326
    }                                                                                                                  // 462
                                                                                                                       //
    return this.cursor.count();                                                                                        // 327
  }; /*                                                                                                                // 325
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name remove                                                                                                      //
     @param callback {Function} - Triggered asynchronously after item is removed or failed to be removed               //
     @summary Removes all documents that match a query                                                                 //
     @returns {FilesCursor}                                                                                            //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.remove = function (callback) {                                                                 // 476
    if (this._collection.debug) {                                                                                      // 338
      console.info('[FilesCollection] [FilesCursor] [remove()]');                                                      // 338
    }                                                                                                                  // 479
                                                                                                                       //
    this._collection.remove(this._selector, callback);                                                                 // 339
                                                                                                                       //
    return this;                                                                                                       // 340
  }; /*                                                                                                                // 337
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name forEach                                                                                                     //
     @param callback {Function} - Function to call. It will be called with three arguments: the `file`, a 0-based index, and cursor itself
     @param context {Object} - An object which will be the value of `this` inside `callback`                           //
     @summary Call `callback` once for each matching document, sequentially and synchronously.                         //
     @returns {undefined}                                                                                              //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.forEach = function (callback, context) {                                                       // 495
    if (context == null) {                                                                                             // 496
      context = {};                                                                                                    // 351
    }                                                                                                                  // 498
                                                                                                                       //
    if (this._collection.debug) {                                                                                      // 352
      console.info('[FilesCollection] [FilesCursor] [forEach()]');                                                     // 352
    }                                                                                                                  // 501
                                                                                                                       //
    this.cursor.forEach(callback, context);                                                                            // 353
  }; /*                                                                                                                // 351
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name each                                                                                                        //
     @summary Returns an Array of FileCursor made for each document on current cursor                                  //
              Useful when using in {{#each FilesCursor#each}}...{{/each}} block template helper                        //
     @returns {[FileCursor]}                                                                                           //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.each = function () {                                                                           // 515
    var self;                                                                                                          // 365
    self = this;                                                                                                       // 365
    return this.map(function (file) {                                                                                  // 366
      return new FileCursor(file, self._collection);                                                                   // 367
    });                                                                                                                // 366
  }; /*                                                                                                                // 364
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name map                                                                                                         //
     @param callback {Function} - Function to call. It will be called with three arguments: the `file`, a 0-based index, and cursor itself
     @param context {Object} - An object which will be the value of `this` inside `callback`                           //
     @summary Map `callback` over all matching documents. Returns an Array.                                            //
     @returns {Array}                                                                                                  //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.map = function (callback, context) {                                                           // 534
    if (context == null) {                                                                                             // 535
      context = {};                                                                                                    // 378
    }                                                                                                                  // 537
                                                                                                                       //
    if (this._collection.debug) {                                                                                      // 379
      console.info('[FilesCollection] [FilesCursor] [map()]');                                                         // 379
    }                                                                                                                  // 540
                                                                                                                       //
    return this.cursor.map(callback, context);                                                                         // 380
  }; /*                                                                                                                // 378
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name current                                                                                                     //
     @summary Returns current item on Cursor, if available                                                             //
     @returns {Object|undefined}                                                                                       //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.current = function () {                                                                        // 553
    if (this._collection.debug) {                                                                                      // 390
      console.info('[FilesCollection] [FilesCursor] [current()]');                                                     // 390
    }                                                                                                                  // 556
                                                                                                                       //
    if (this._current < 0) {                                                                                           // 391
      this._current = 0;                                                                                               // 391
    }                                                                                                                  // 559
                                                                                                                       //
    return this.fetch()[this._current];                                                                                // 392
  }; /*                                                                                                                // 389
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name observe                                                                                                     //
     @param callbacks {Object} - Functions to call to deliver the result set as it changes                             //
     @summary Watch a query. Receive callbacks as the result set changes.                                              //
     @url http://docs.meteor.com/api/collections.html#Mongo-Cursor-observe                                             //
     @returns {Object} - live query handle                                                                             //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.observe = function (callbacks) {                                                               // 574
    if (this._collection.debug) {                                                                                      // 404
      console.info('[FilesCollection] [FilesCursor] [observe()]');                                                     // 404
    }                                                                                                                  // 577
                                                                                                                       //
    return this.cursor.observe(callbacks);                                                                             // 405
  }; /*                                                                                                                // 403
     @locus Anywhere                                                                                                   //
     @memberOf FilesCursor                                                                                             //
     @name observeChanges                                                                                              //
     @param callbacks {Object} - Functions to call to deliver the result set as it changes                             //
     @summary Watch a query. Receive callbacks as the result set changes. Only the differences between the old and new documents are passed to the callbacks.
     @url http://docs.meteor.com/api/collections.html#Mongo-Cursor-observeChanges                                      //
     @returns {Object} - live query handle                                                                             //
      */                                                                                                               //
                                                                                                                       //
  FilesCursor.prototype.observeChanges = function (callbacks) {                                                        // 592
    if (this._collection.debug) {                                                                                      // 417
      console.info('[FilesCollection] [FilesCursor] [observeChanges()]');                                              // 417
    }                                                                                                                  // 595
                                                                                                                       //
    return this.cursor.observeChanges(callbacks);                                                                      // 418
  };                                                                                                                   // 416
                                                                                                                       //
  return FilesCursor;                                                                                                  // 599
}(); /*                                                                                                                // 601
     @var {Function} fixJSONParse - Fix issue with Date parse                                                          //
      */                                                                                                               //
                                                                                                                       //
fixJSONParse = function (obj) {                                                                                        // 423
  var i, j, key, len, v, value;                                                                                        // 424
                                                                                                                       //
  for (key in meteorBabelHelpers.sanitizeForInObject(obj)) {                                                           // 424
    value = obj[key];                                                                                                  // 611
                                                                                                                       //
    if (_.isString(value) && !!~value.indexOf('=--JSON-DATE--=')) {                                                    // 425
      value = value.replace('=--JSON-DATE--=', '');                                                                    // 426
      obj[key] = new Date(parseInt(value));                                                                            // 427
    } else if (_.isObject(value)) {                                                                                    // 425
      obj[key] = fixJSONParse(value);                                                                                  // 429
    } else if (_.isArray(value)) {                                                                                     // 428
      for (i = j = 0, len = value.length; j < len; i = ++j) {                                                          // 431
        v = value[i];                                                                                                  // 619
                                                                                                                       //
        if (_.isObject(v)) {                                                                                           // 432
          obj[key][i] = fixJSONParse(v);                                                                               // 433
        } else if (_.isString(v) && !!~v.indexOf('=--JSON-DATE--=')) {                                                 // 432
          v = v.replace('=--JSON-DATE--=', '');                                                                        // 435
          obj[key][i] = new Date(parseInt(v));                                                                         // 436
        }                                                                                                              // 625
      }                                                                                                                // 430
    }                                                                                                                  // 627
  }                                                                                                                    // 424
                                                                                                                       //
  return obj;                                                                                                          // 437
}; /*                                                                                                                  // 423
   @var {Function} fixJSONStringify - Fix issue with Date stringify                                                    //
    */                                                                                                                 //
                                                                                                                       //
fixJSONStringify = function (obj) {                                                                                    // 442
  var i, j, key, len, v, value;                                                                                        // 443
                                                                                                                       //
  for (key in meteorBabelHelpers.sanitizeForInObject(obj)) {                                                           // 443
    value = obj[key];                                                                                                  // 640
                                                                                                                       //
    if (_.isDate(value)) {                                                                                             // 444
      obj[key] = '=--JSON-DATE--=' + +value;                                                                           // 445
    } else if (_.isObject(value)) {                                                                                    // 444
      obj[key] = fixJSONStringify(value);                                                                              // 447
    } else if (_.isArray(value)) {                                                                                     // 446
      for (i = j = 0, len = value.length; j < len; i = ++j) {                                                          // 449
        v = value[i];                                                                                                  // 647
                                                                                                                       //
        if (_.isObject(v)) {                                                                                           // 450
          obj[key][i] = fixJSONStringify(v);                                                                           // 451
        } else if (_.isDate(v)) {                                                                                      // 450
          obj[key][i] = '=--JSON-DATE--=' + +v;                                                                        // 453
        }                                                                                                              // 652
      }                                                                                                                // 448
    }                                                                                                                  // 654
  }                                                                                                                    // 443
                                                                                                                       //
  return obj;                                                                                                          // 454
}; /*                                                                                                                  // 442
   @locus Anywhere                                                                                                     //
   @class FilesCollection                                                                                              //
   @param config           {Object}   - [Both]   Configuration object with next properties:                            //
   @param config.debug     {Boolean}  - [Both]   Turn on/of debugging and extra logging                                //
   @param config.ddp       {Object}   - [Client] Custom DDP connection. Object returned form `DDP.connect()`           //
   @param config.schema    {Object}   - [Both]   Collection Schema                                                     //
   @param config.public    {Boolean}  - [Both]   Store files in folder accessible for proxy servers, for limits, and more - read docs
   @param config.strict    {Boolean}  - [Server] Strict mode for partial content, if is `true` server will return `416` response code, when `range` is not specified, otherwise server return `206`
   @param config.protected {Function} - [Both]   If `true` - files will be served only to authorized users, if `function()` - you're able to check visitor's permissions in your own way function's context has:
     - `request` - On server only                                                                                      //
     - `response` - On server only                                                                                     //
     - `user()`                                                                                                        //
     - `userId`                                                                                                        //
   @param config.chunkSize      {Number}  - [Both] Upload chunk size, default: 524288 bytes (0,5 Mb)                   //
   @param config.permissions    {Number}  - [Server] Permissions which will be set to uploaded files (octal), like: `511` or `0o755`. Default: 0644
   @param config.parentDirPermissions {Number}  - [Server] Permissions which will be set to parent directory of uploaded files (octal), like: `611` or `0o777`. Default: 0755
   @param config.storagePath    {String|Function}  - [Server] Storage path on file system                              //
   @param config.cacheControl   {String}  - [Server] Default `Cache-Control` header                                    //
   @param config.responseHeaders {Object|Function} - [Server] Custom response headers, if function is passed, must return Object
   @param config.throttle       {Number}  - [Server] bps throttle threshold                                            //
   @param config.downloadRoute  {String}  - [Both]   Server Route used to retrieve files                               //
   @param config.collection     {Mongo.Collection} - [Both] Mongo Collection Instance                                  //
   @param config.collectionName {String}  - [Both]   Collection name                                                   //
   @param config.namingFunction {Function}- [Both]   Function which returns `String`                                   //
   @param config.integrityCheck {Boolean} - [Server] Check file's integrity before serving to users                    //
   @param config.onAfterUpload  {Function}- [Server] Called right after file is ready on FS. Use to transfer file somewhere else, or do other thing with file directly
   @param config.onAfterRemove  {Function} - [Server] Called right after file is removed. Removed objects is passed to callback
   @param config.continueUploadTTL {Number} - [Server] Time in seconds, during upload may be continued, default 3 hours (10800 seconds)
   @param config.onBeforeUpload {Function}- [Both]   Function which executes on server after receiving each chunk and on client right before beginning upload. Function context is `File` - so you are able to check for extension, mime-type, size and etc.
   return `true` to continue                                                                                           //
   return `false` or `String` to abort upload                                                                          //
   @param config.onInitiateUpload {Function} - [Server] Function which executes on server right before upload is begin and right after `onBeforeUpload` hook. This hook is fully asynchronous.
   @param config.onBeforeRemove {Function} - [Server] Executes before removing file on server, so you can check permissions. Return `true` to allow action and `false` to deny.
   @param config.allowClientCode  {Boolean}  - [Both]   Allow to run `remove` from client                              //
   @param config.downloadCallback {Function} - [Server] Callback triggered each time file is requested, return truthy value to continue download, or falsy to abort
   @param config.interceptDownload {Function} - [Server] Intercept download request, so you can serve file from third-party resource, arguments {http: {request: {...}, response: {...}}, fileRef: {...}}
   @param config.onbeforeunloadMessage {String|Function} - [Client] Message shown to user when closing browser's window or tab while upload process is running
   @summary Create new instance of FilesCollection                                                                     //
    */                                                                                                                 //
                                                                                                                       //
module.runModuleSetters(FilesCollection = function () {                                                                // 496
  var FileUpload, UploadInstance;                                                                                      // 497
                                                                                                                       //
  FilesCollection.prototype.__proto__ = function () {                                                                  // 704
    if (Meteor.isServer) {                                                                                             // 497
      return events.EventEmitter.prototype;                                                                            // 706
    } else {                                                                                                           // 497
      return EventEmitter.prototype;                                                                                   // 708
    }                                                                                                                  // 709
  }();                                                                                                                 // 497
                                                                                                                       //
  function FilesCollection(config) {                                                                                   // 498
    var _URL, _methods, _preCollectionCursor, cookie, self, setTokenCookie, storagePath, unsetTokenCookie;             // 499
                                                                                                                       //
    if (Meteor.isServer) {                                                                                             // 499
      events.EventEmitter.call(this);                                                                                  // 500
    } else {                                                                                                           // 499
      EventEmitter.call(this);                                                                                         // 502
    }                                                                                                                  // 718
                                                                                                                       //
    if (config) {                                                                                                      // 503
      storagePath = config.storagePath, this.ddp = config.ddp, this.collection = config.collection, this.collectionName = config.collectionName, this.downloadRoute = config.downloadRoute, this.schema = config.schema, this.chunkSize = config.chunkSize, this.namingFunction = config.namingFunction, this.debug = config.debug, this.onbeforeunloadMessage = config.onbeforeunloadMessage, this.permissions = config.permissions, this.parentDirPermissions = config.parentDirPermissions, this.allowClientCode = config.allowClientCode, this.onBeforeUpload = config.onBeforeUpload, this.onInitiateUpload = config.onInitiateUpload, this.integrityCheck = config.integrityCheck, this["protected"] = config["protected"], this["public"] = config["public"], this.strict = config.strict, this.downloadCallback = config.downloadCallback, this.cacheControl = config.cacheControl, this.responseHeaders = config.responseHeaders, this.throttle = config.throttle, this.onAfterUpload = config.onAfterUpload, this.onAfterRemove = config.onAfterRemove, this.interceptDownload = config.interceptDownload, this.onBeforeRemove = config.onBeforeRemove, this.continueUploadTTL = config.continueUploadTTL;
    }                                                                                                                  // 721
                                                                                                                       //
    self = this;                                                                                                       // 505
    cookie = new Cookies();                                                                                            // 506
                                                                                                                       //
    if (this.debug == null) {                                                                                          // 724
      this.debug = false;                                                                                              // 507
    }                                                                                                                  // 726
                                                                                                                       //
    if (this["public"] == null) {                                                                                      // 727
      this["public"] = false;                                                                                          // 508
    }                                                                                                                  // 729
                                                                                                                       //
    if (this["protected"] == null) {                                                                                   // 730
      this["protected"] = false;                                                                                       // 509
    }                                                                                                                  // 732
                                                                                                                       //
    if (this.chunkSize == null) {                                                                                      // 733
      this.chunkSize = 1024 * 512;                                                                                     // 510
    }                                                                                                                  // 735
                                                                                                                       //
    this.chunkSize = Math.floor(this.chunkSize / 8) * 8;                                                               // 511
                                                                                                                       //
    if (this["public"] && !this.downloadRoute) {                                                                       // 513
      throw new Meteor.Error(500, "[FilesCollection." + this.collectionName + "]: \"downloadRoute\" must be precisely provided on \"public\" collections! Note: \"downloadRoute\" must be equal or be inside of your web/proxy-server (relative) root.");
    }                                                                                                                  // 739
                                                                                                                       //
    if (this.collection == null) {                                                                                     // 740
      this.collection = new Mongo.Collection(this.collectionName);                                                     // 516
    }                                                                                                                  // 742
                                                                                                                       //
    if (this.collectionName == null) {                                                                                 // 743
      this.collectionName = this.collection._name;                                                                     // 517
    }                                                                                                                  // 745
                                                                                                                       //
    check(this.collectionName, String);                                                                                // 518
                                                                                                                       //
    if (this.downloadRoute == null) {                                                                                  // 747
      this.downloadRoute = '/cdn/storage';                                                                             // 519
    }                                                                                                                  // 749
                                                                                                                       //
    this.downloadRoute = this.downloadRoute.replace(/\/$/, '');                                                        // 520
                                                                                                                       //
    if (this.collectionName == null) {                                                                                 // 751
      this.collectionName = 'MeteorUploadFiles';                                                                       // 521
    }                                                                                                                  // 753
                                                                                                                       //
    if (this.namingFunction == null) {                                                                                 // 754
      this.namingFunction = false;                                                                                     // 522
    }                                                                                                                  // 756
                                                                                                                       //
    if (this.onBeforeUpload == null) {                                                                                 // 757
      this.onBeforeUpload = false;                                                                                     // 523
    }                                                                                                                  // 759
                                                                                                                       //
    if (this.allowClientCode == null) {                                                                                // 760
      this.allowClientCode = true;                                                                                     // 524
    }                                                                                                                  // 762
                                                                                                                       //
    if (this.ddp == null) {                                                                                            // 763
      this.ddp = Meteor;                                                                                               // 525
    }                                                                                                                  // 765
                                                                                                                       //
    if (this.onInitiateUpload == null) {                                                                               // 766
      this.onInitiateUpload = false;                                                                                   // 526
    }                                                                                                                  // 768
                                                                                                                       //
    if (this.interceptDownload == null) {                                                                              // 769
      this.interceptDownload = false;                                                                                  // 527
    }                                                                                                                  // 771
                                                                                                                       //
    if (storagePath == null) {                                                                                         // 772
      storagePath = function () {                                                                                      // 528
        return "assets" + nodePath.sep + "app" + nodePath.sep + "uploads" + nodePath.sep + this.collectionName;        // 774
      };                                                                                                               // 528
    }                                                                                                                  // 776
                                                                                                                       //
    if (_.isString(storagePath)) {                                                                                     // 530
      this.storagePath = function () {                                                                                 // 531
        return storagePath;                                                                                            // 779
      };                                                                                                               // 531
    } else {                                                                                                           // 530
      this.storagePath = function () {                                                                                 // 533
        var sp;                                                                                                        // 534
        sp = storagePath.apply(this, arguments);                                                                       // 534
                                                                                                                       //
        if (!_.isString(sp)) {                                                                                         // 535
          throw new Meteor.Error(400, "[FilesCollection." + self.collectionName + "] \"storagePath\" function must return a String!");
        }                                                                                                              // 787
                                                                                                                       //
        sp = sp.replace(/\/$/, '');                                                                                    // 537
                                                                                                                       //
        if (Meteor.isServer) {                                                                                         // 538
          return nodePath.normalize(sp);                                                                               // 790
        } else {                                                                                                       // 538
          return sp;                                                                                                   // 792
        }                                                                                                              // 793
      };                                                                                                               // 533
    }                                                                                                                  // 795
                                                                                                                       //
    if (Meteor.isClient) {                                                                                             // 540
      if (this.onbeforeunloadMessage == null) {                                                                        // 797
        this.onbeforeunloadMessage = 'Upload in a progress... Do you want to abort?';                                  // 541
      }                                                                                                                // 799
                                                                                                                       //
      delete this.strict;                                                                                              // 542
      delete this.throttle;                                                                                            // 543
      delete this.permissions;                                                                                         // 544
      delete this.parentDirPermissions;                                                                                // 545
      delete this.cacheControl;                                                                                        // 546
      delete this.onAfterUpload;                                                                                       // 547
      delete this.onAfterRemove;                                                                                       // 548
      delete this.onBeforeRemove;                                                                                      // 549
      this.onInitiateUpload = false;                                                                                   // 550
      delete this.integrityCheck;                                                                                      // 551
      delete this.downloadCallback;                                                                                    // 552
      delete this.interceptDownload;                                                                                   // 553
      delete this.continueUploadTTL;                                                                                   // 554
      delete this.responseHeaders;                                                                                     // 555
                                                                                                                       //
      setTokenCookie = function () {                                                                                   // 557
        Meteor.setTimeout(function () {                                                                                // 558
          if (!cookie.has('x_mtok') && Meteor.connection._lastSessionId || cookie.has('x_mtok') && cookie.get('x_mtok') !== Meteor.connection._lastSessionId) {
            cookie.set('x_mtok', Meteor.connection._lastSessionId, {                                                   // 560
              path: '/'                                                                                                // 560
            });                                                                                                        // 560
          }                                                                                                            // 820
        }, 25);                                                                                                        // 558
      };                                                                                                               // 557
                                                                                                                       //
      unsetTokenCookie = function () {                                                                                 // 565
        if (cookie.has('x_mtok')) {                                                                                    // 566
          cookie.remove('x_mtok', '/');                                                                                // 566
        }                                                                                                              // 826
      };                                                                                                               // 565
                                                                                                                       //
      if (typeof Accounts !== "undefined" && Accounts !== null) {                                                      // 569
        Meteor.startup(function () {                                                                                   // 570
          setTokenCookie();                                                                                            // 571
        });                                                                                                            // 570
        Accounts.onLogin(function () {                                                                                 // 573
          setTokenCookie();                                                                                            // 574
        });                                                                                                            // 573
        Accounts.onLogout(function () {                                                                                // 576
          unsetTokenCookie();                                                                                          // 577
        });                                                                                                            // 576
      }                                                                                                                // 838
                                                                                                                       //
      check(this.onbeforeunloadMessage, Match.OneOf(String, Function));                                                // 580
      _URL = window.URL || window.webkitURL || window.mozURL || window.msURL || window.oURL || false;                  // 582
                                                                                                                       //
      if ((typeof window !== "undefined" && window !== null ? window.Worker : void 0) && (typeof window !== "undefined" && window !== null ? window.Blob : void 0) && _URL) {
        this._supportWebWorker = true;                                                                                 // 584
        this._webWorkerUrl = _URL.createObjectURL(new Blob(['!function(a){"use strict";a.onmessage=function(b){var c=b.data.f.slice(b.data.cs*(b.data.cc-1),b.data.cs*b.data.cc);if(b.data.ib===!0)postMessage({bin:c,chunkId:b.data.cc});else{var d;a.FileReader?(d=new FileReader,d.onloadend=function(a){postMessage({bin:(d.result||a.srcElement||a.target).split(",")[1],chunkId:b.data.cc,s:b.data.s})},d.onerror=function(a){throw(a.target||a.srcElement).error},d.readAsDataURL(c)):a.FileReaderSync?(d=new FileReaderSync,postMessage({bin:d.readAsDataURL(c).split(",")[1],chunkId:b.data.cc})):postMessage({bin:null,chunkId:b.data.cc,error:"File API is not supported in WebWorker!"})}}}(this);'], {
          type: 'application/javascript'                                                                               // 585
        }));                                                                                                           // 585
      } else if (typeof window !== "undefined" && window !== null ? window.Worker : void 0) {                          // 583
        this._supportWebWorker = true;                                                                                 // 587
        this._webWorkerUrl = Meteor.absoluteUrl('packages/ostrio_files/worker.min.js');                                // 588
      } else {                                                                                                         // 586
        this._supportWebWorker = false;                                                                                // 590
      }                                                                                                                // 540
    } else {                                                                                                           // 540
      if (this.strict == null) {                                                                                       // 853
        this.strict = true;                                                                                            // 593
      }                                                                                                                // 855
                                                                                                                       //
      if (this.throttle == null) {                                                                                     // 856
        this.throttle = false;                                                                                         // 594
      }                                                                                                                // 858
                                                                                                                       //
      if (this.permissions == null) {                                                                                  // 859
        this.permissions = parseInt('644', 8);                                                                         // 595
      }                                                                                                                // 861
                                                                                                                       //
      if (this.parentDirPermissions == null) {                                                                         // 862
        this.parentDirPermissions = parseInt('755', 8);                                                                // 596
      }                                                                                                                // 864
                                                                                                                       //
      if (this.cacheControl == null) {                                                                                 // 865
        this.cacheControl = 'public, max-age=31536000, s-maxage=31536000';                                             // 597
      }                                                                                                                // 867
                                                                                                                       //
      if (this.onAfterUpload == null) {                                                                                // 868
        this.onAfterUpload = false;                                                                                    // 598
      }                                                                                                                // 870
                                                                                                                       //
      if (this.onAfterRemove == null) {                                                                                // 871
        this.onAfterRemove = false;                                                                                    // 599
      }                                                                                                                // 873
                                                                                                                       //
      if (this.onBeforeRemove == null) {                                                                               // 874
        this.onBeforeRemove = false;                                                                                   // 600
      }                                                                                                                // 876
                                                                                                                       //
      if (this.integrityCheck == null) {                                                                               // 877
        this.integrityCheck = true;                                                                                    // 601
      }                                                                                                                // 879
                                                                                                                       //
      if (this._currentUploads == null) {                                                                              // 880
        this._currentUploads = {};                                                                                     // 602
      }                                                                                                                // 882
                                                                                                                       //
      if (this.downloadCallback == null) {                                                                             // 883
        this.downloadCallback = false;                                                                                 // 603
      }                                                                                                                // 885
                                                                                                                       //
      if (this.continueUploadTTL == null) {                                                                            // 886
        this.continueUploadTTL = 10800;                                                                                // 604
      }                                                                                                                // 888
                                                                                                                       //
      if (this.responseHeaders == null) {                                                                              // 889
        this.responseHeaders = function (responseCode, fileRef, versionRef) {                                          // 605
          var headers;                                                                                                 // 606
          headers = {};                                                                                                // 606
                                                                                                                       //
          switch (responseCode) {                                                                                      // 607
            case '206':                                                                                                // 607
              headers['Pragma'] = 'private';                                                                           // 609
              headers['Trailer'] = 'expires';                                                                          // 610
              headers['Transfer-Encoding'] = 'chunked';                                                                // 611
              break;                                                                                                   // 608
                                                                                                                       //
            case '400':                                                                                                // 607
              headers['Cache-Control'] = 'no-cache';                                                                   // 613
              break;                                                                                                   // 612
                                                                                                                       //
            case '416':                                                                                                // 607
              headers['Content-Range'] = "bytes */" + versionRef.size;                                                 // 615
          }                                                                                                            // 607
                                                                                                                       //
          headers['Connection'] = 'keep-alive';                                                                        // 617
          headers['Content-Type'] = versionRef.type || 'application/octet-stream';                                     // 618
          headers['Accept-Ranges'] = 'bytes';                                                                          // 619
          return headers;                                                                                              // 620
        };                                                                                                             // 605
      }                                                                                                                // 910
                                                                                                                       //
      if (this["public"] && !storagePath) {                                                                            // 622
        throw new Meteor.Error(500, "[FilesCollection." + this.collectionName + "] \"storagePath\" must be set on \"public\" collections! Note: \"storagePath\" must be equal on be inside of your web/proxy-server (absolute) root.");
      }                                                                                                                // 913
                                                                                                                       //
      if (this.debug) {                                                                                                // 625
        console.info('[FilesCollection.storagePath] Set to:', this.storagePath({}));                                   // 625
      }                                                                                                                // 916
                                                                                                                       //
      fs.mkdirs(this.storagePath({}), {                                                                                // 627
        mode: this.parentDirPermissions                                                                                // 627
      }, function (error) {                                                                                            // 627
        if (error) {                                                                                                   // 628
          throw new Meteor.Error(401, "[FilesCollection." + self.collectionName + "] Path \"" + self.storagePath({}) + "\" is not writable!", error);
        }                                                                                                              // 922
      });                                                                                                              // 627
      check(this.strict, Boolean);                                                                                     // 632
      check(this.throttle, Match.OneOf(false, Number));                                                                // 633
      check(this.permissions, Number);                                                                                 // 634
      check(this.storagePath, Function);                                                                               // 635
      check(this.cacheControl, String);                                                                                // 636
      check(this.onAfterRemove, Match.OneOf(false, Function));                                                         // 637
      check(this.onAfterUpload, Match.OneOf(false, Function));                                                         // 638
      check(this.integrityCheck, Boolean);                                                                             // 639
      check(this.onBeforeRemove, Match.OneOf(false, Function));                                                        // 640
      check(this.downloadCallback, Match.OneOf(false, Function));                                                      // 641
      check(this.interceptDownload, Match.OneOf(false, Function));                                                     // 642
      check(this.continueUploadTTL, Number);                                                                           // 643
      check(this.responseHeaders, Match.OneOf(Object, Function));                                                      // 644
      this._preCollection = new Mongo.Collection('__pre_' + this.collectionName);                                      // 646
                                                                                                                       //
      this._preCollection._ensureIndex({                                                                               // 647
        createdAt: 1                                                                                                   // 647
      }, {                                                                                                             // 647
        expireAfterSeconds: this.continueUploadTTL,                                                                    // 647
        background: true                                                                                               // 647
      });                                                                                                              // 647
                                                                                                                       //
      _preCollectionCursor = this._preCollection.find({}, {                                                            // 648
        fields: {                                                                                                      // 649
          _id: 1,                                                                                                      // 650
          isFinished: 1                                                                                                // 651
        }                                                                                                              // 650
      });                                                                                                              // 648
                                                                                                                       //
      _preCollectionCursor.observe({                                                                                   // 653
        changed: function (doc) {                                                                                      // 654
          if (doc.isFinished) {                                                                                        // 655
            if (self.debug) {                                                                                          // 656
              console.info("[FilesCollection] [_preCollectionCursor.observe] [changed]: " + doc._id);                  // 656
            }                                                                                                          // 955
                                                                                                                       //
            self._preCollection.remove({                                                                               // 657
              _id: doc._id                                                                                             // 657
            }, NOOP);                                                                                                  // 657
          }                                                                                                            // 959
        },                                                                                                             // 654
        removed: function (doc) {                                                                                      // 659
          var ref;                                                                                                     // 662
                                                                                                                       //
          if (self.debug) {                                                                                            // 662
            console.info("[FilesCollection] [_preCollectionCursor.observe] [removed]: " + doc._id);                    // 662
          }                                                                                                            // 965
                                                                                                                       //
          if ((ref = self._currentUploads) != null ? ref[doc._id] : void 0) {                                          // 663
            self._currentUploads[doc._id].stop();                                                                      // 664
                                                                                                                       //
            self._currentUploads[doc._id].end();                                                                       // 665
                                                                                                                       //
            if (!doc.isFinished) {                                                                                     // 667
              if (self.debug) {                                                                                        // 668
                console.info("[FilesCollection] [_preCollectionCursor.observe] [removeUnfinishedUpload]: " + doc._id);
              }                                                                                                        // 972
                                                                                                                       //
              self._currentUploads[doc._id].abort();                                                                   // 669
            }                                                                                                          // 974
                                                                                                                       //
            delete self._currentUploads[doc._id];                                                                      // 671
          }                                                                                                            // 976
        }                                                                                                              // 654
      });                                                                                                              // 654
                                                                                                                       //
      this._createStream = function (_id, path, opts) {                                                                // 674
        return self._currentUploads[_id] = new writeStream(path, opts.fileLength, opts, self.permissions);             // 675
      };                                                                                                               // 674
                                                                                                                       //
      this._continueUpload = function (_id) {                                                                          // 679
        var contUpld, ref, ref1;                                                                                       // 680
                                                                                                                       //
        if ((ref = self._currentUploads) != null ? (ref1 = ref[_id]) != null ? ref1.file : void 0 : void 0) {          // 680
          if (!self._currentUploads[_id].aborted && !self._currentUploads[_id].ended) {                                // 681
            return self._currentUploads[_id].file;                                                                     // 682
          } else {                                                                                                     // 681
            self._createStream(_id, self._currentUploads[_id].file.file.path, self._currentUploads[_id].file);         // 684
                                                                                                                       //
            return self._currentUploads[_id].file;                                                                     // 685
          }                                                                                                            // 680
        } else {                                                                                                       // 680
          contUpld = self._preCollection.findOne({                                                                     // 687
            _id: _id                                                                                                   // 687
          });                                                                                                          // 687
                                                                                                                       //
          if (contUpld) {                                                                                              // 688
            self._createStream(_id, contUpld.file.path, contUpld.file);                                                // 689
          }                                                                                                            // 997
                                                                                                                       //
          return contUpld;                                                                                             // 690
        }                                                                                                              // 999
      };                                                                                                               // 679
    }                                                                                                                  // 1001
                                                                                                                       //
    if (!this.schema) {                                                                                                // 692
      this.schema = {                                                                                                  // 693
        size: {                                                                                                        // 694
          type: Number                                                                                                 // 694
        },                                                                                                             // 694
        name: {                                                                                                        // 695
          type: String                                                                                                 // 695
        },                                                                                                             // 695
        type: {                                                                                                        // 696
          type: String                                                                                                 // 696
        },                                                                                                             // 696
        path: {                                                                                                        // 697
          type: String                                                                                                 // 697
        },                                                                                                             // 697
        isVideo: {                                                                                                     // 698
          type: Boolean                                                                                                // 698
        },                                                                                                             // 698
        isAudio: {                                                                                                     // 699
          type: Boolean                                                                                                // 699
        },                                                                                                             // 699
        isImage: {                                                                                                     // 700
          type: Boolean                                                                                                // 700
        },                                                                                                             // 700
        isText: {                                                                                                      // 701
          type: Boolean                                                                                                // 701
        },                                                                                                             // 701
        isJSON: {                                                                                                      // 702
          type: Boolean                                                                                                // 702
        },                                                                                                             // 702
        isPDF: {                                                                                                       // 703
          type: Boolean                                                                                                // 703
        },                                                                                                             // 703
        extension: {                                                                                                   // 704
          type: String,                                                                                                // 705
          optional: true                                                                                               // 706
        },                                                                                                             // 705
        _storagePath: {                                                                                                // 707
          type: String                                                                                                 // 707
        },                                                                                                             // 707
        _downloadRoute: {                                                                                              // 708
          type: String                                                                                                 // 708
        },                                                                                                             // 708
        _collectionName: {                                                                                             // 709
          type: String                                                                                                 // 709
        },                                                                                                             // 709
        "public": {                                                                                                    // 710
          type: Boolean,                                                                                               // 711
          optional: true                                                                                               // 712
        },                                                                                                             // 711
        meta: {                                                                                                        // 713
          type: Object,                                                                                                // 714
          blackbox: true,                                                                                              // 715
          optional: true                                                                                               // 716
        },                                                                                                             // 714
        userId: {                                                                                                      // 717
          type: String,                                                                                                // 718
          optional: true                                                                                               // 719
        },                                                                                                             // 718
        updatedAt: {                                                                                                   // 720
          type: Date,                                                                                                  // 721
          optional: true                                                                                               // 722
        },                                                                                                             // 721
        versions: {                                                                                                    // 723
          type: Object,                                                                                                // 724
          blackbox: true                                                                                               // 725
        }                                                                                                              // 724
      };                                                                                                               // 694
    }                                                                                                                  // 1069
                                                                                                                       //
    check(this.debug, Boolean);                                                                                        // 727
    check(this.schema, Object);                                                                                        // 728
    check(this["public"], Boolean);                                                                                    // 729
    check(this["protected"], Match.OneOf(Boolean, Function));                                                          // 730
    check(this.chunkSize, Number);                                                                                     // 731
    check(this.downloadRoute, String);                                                                                 // 732
    check(this.namingFunction, Match.OneOf(false, Function));                                                          // 733
    check(this.onBeforeUpload, Match.OneOf(false, Function));                                                          // 734
    check(this.onInitiateUpload, Match.OneOf(false, Function));                                                        // 735
    check(this.allowClientCode, Boolean);                                                                              // 736
    check(this.ddp, Match.Any);                                                                                        // 737
                                                                                                                       //
    if (this["public"] && this["protected"]) {                                                                         // 739
      throw new Meteor.Error(500, "[FilesCollection." + this.collectionName + "]: Files can not be public and protected at the same time!");
    }                                                                                                                  // 1083
                                                                                                                       //
    this._checkAccess = function (http) {                                                                              // 742
      var fileRef, rc, ref, ref1, result, text, user, userId;                                                          // 743
                                                                                                                       //
      if (self["protected"]) {                                                                                         // 743
        ref = self._getUser(http), user = ref.user, userId = ref.userId;                                               // 744
                                                                                                                       //
        if (_.isFunction(self["protected"])) {                                                                         // 746
          if (http != null ? (ref1 = http.params) != null ? ref1._id : void 0 : void 0) {                              // 747
            fileRef = self.collection.findOne(http.params._id);                                                        // 748
          }                                                                                                            // 1091
                                                                                                                       //
          result = http ? self["protected"].call(_.extend(http, {                                                      // 750
            user: user,                                                                                                // 750
            userId: userId                                                                                             // 750
          }), fileRef || null) : self["protected"].call({                                                              // 750
            user: user,                                                                                                // 750
            userId: userId                                                                                             // 750
          }, fileRef || null);                                                                                         // 750
        } else {                                                                                                       // 746
          result = !!userId;                                                                                           // 752
        }                                                                                                              // 1101
                                                                                                                       //
        if (http && result === true || !http) {                                                                        // 754
          return true;                                                                                                 // 755
        } else {                                                                                                       // 754
          rc = _.isNumber(result) ? result : 401;                                                                      // 757
                                                                                                                       //
          if (self.debug) {                                                                                            // 758
            console.warn('[FilesCollection._checkAccess] WARN: Access denied!');                                       // 758
          }                                                                                                            // 1108
                                                                                                                       //
          if (http) {                                                                                                  // 759
            text = 'Access denied!';                                                                                   // 760
            http.response.writeHead(rc, {                                                                              // 761
              'Content-Length': text.length,                                                                           // 762
              'Content-Type': 'text/plain'                                                                             // 763
            });                                                                                                        // 762
            http.response.end(text);                                                                                   // 764
          }                                                                                                            // 1116
                                                                                                                       //
          return false;                                                                                                // 765
        }                                                                                                              // 743
      } else {                                                                                                         // 743
        return true;                                                                                                   // 767
      }                                                                                                                // 1121
    };                                                                                                                 // 742
                                                                                                                       //
    this._methodNames = {                                                                                              // 769
      _Abort: "_FilesCollectionAbort_" + this.collectionName,                                                          // 770
      _Write: "_FilesCollectionWrite_" + this.collectionName,                                                          // 771
      _Start: "_FilesCollectionStart_" + this.collectionName,                                                          // 772
      _Remove: "_FilesCollectionRemove_" + this.collectionName                                                         // 773
    };                                                                                                                 // 770
                                                                                                                       //
    if (Meteor.isServer) {                                                                                             // 775
      this.on('_handleUpload', this._handleUpload);                                                                    // 776
      this.on('_finishUpload', this._finishUpload);                                                                    // 777
      WebApp.connectHandlers.use(function (request, response, next) {                                                  // 779
        var _file, body, handleError, http, params, uri, uris, version;                                                // 780
                                                                                                                       //
        if (!!~request._parsedUrl.path.indexOf(self.downloadRoute + "/" + self.collectionName + "/__upload")) {        // 780
          if (request.method === 'POST') {                                                                             // 781
            handleError = function (error) {                                                                           // 783
              console.warn("[FilesCollection] [Upload] [HTTP] Exception:", error);                                     // 784
              response.writeHead(500);                                                                                 // 785
              response.end(JSON.stringify({                                                                            // 786
                error: error                                                                                           // 786
              }));                                                                                                     // 786
            };                                                                                                         // 783
                                                                                                                       //
            body = '';                                                                                                 // 789
            request.on('data', function (data) {                                                                       // 790
              return bound(function () {                                                                               // 1145
                body += data;                                                                                          // 791
              });                                                                                                      // 790
            });                                                                                                        // 790
            request.on('end', function () {                                                                            // 794
              return bound(function () {                                                                               // 1150
                var _continueUpload, e, error, opts, ref, ref1, ref2, ref3, result, user;                              // 795
                                                                                                                       //
                try {                                                                                                  // 795
                  if (request.headers['x-mtok'] && ((ref = Meteor.server.sessions) != null ? ref[request.headers['x-mtok']] : void 0)) {
                    user = {                                                                                           // 797
                      userId: (ref1 = Meteor.server.sessions[request.headers['x-mtok']]) != null ? ref1.userId : void 0
                    };                                                                                                 // 797
                  } else {                                                                                             // 796
                    user = self._getUser({                                                                             // 799
                      request: request,                                                                                // 799
                      response: response                                                                               // 799
                    });                                                                                                // 799
                  }                                                                                                    // 1162
                                                                                                                       //
                  if (request.headers['x-start'] !== '1') {                                                            // 801
                    opts = {                                                                                           // 802
                      fileId: request.headers['x-fileid']                                                              // 802
                    };                                                                                                 // 802
                                                                                                                       //
                    if (request.headers['x-eof'] === '1') {                                                            // 803
                      opts.eof = true;                                                                                 // 804
                    } else {                                                                                           // 803
                      if (typeof Buffer.from === 'function') {                                                         // 806
                        try {                                                                                          // 807
                          opts.binData = Buffer.from(body, 'base64');                                                  // 808
                        } catch (error1) {                                                                             // 807
                          e = error1;                                                                                  // 809
                          opts.binData = new Buffer(body, 'base64');                                                   // 810
                        }                                                                                              // 806
                      } else {                                                                                         // 806
                        opts.binData = new Buffer(body, 'base64');                                                     // 812
                      }                                                                                                // 1179
                                                                                                                       //
                      opts.chunkId = parseInt(request.headers['x-chunkid']);                                           // 813
                    }                                                                                                  // 1181
                                                                                                                       //
                    _continueUpload = self._continueUpload(opts.fileId);                                               // 815
                                                                                                                       //
                    if (!_continueUpload) {                                                                            // 816
                      throw new Meteor.Error(408, 'Can\'t continue upload, session expired. Start upload again.');     // 817
                    }                                                                                                  // 1185
                                                                                                                       //
                    ref2 = self._prepareUpload(_.extend(opts, _continueUpload), user.userId, 'HTTP'), result = ref2.result, opts = ref2.opts;
                                                                                                                       //
                    if (opts.eof) {                                                                                    // 821
                      self._handleUpload(result, opts, function () {                                                   // 822
                        var ref3;                                                                                      // 823
                        response.writeHead(200);                                                                       // 823
                                                                                                                       //
                        if (result != null ? (ref3 = result.file) != null ? ref3.meta : void 0 : void 0) {             // 824
                          result.file.meta = fixJSONStringify(result.file.meta);                                       // 824
                        }                                                                                              // 1193
                                                                                                                       //
                        response.end(JSON.stringify(result));                                                          // 825
                      });                                                                                              // 822
                                                                                                                       //
                      return;                                                                                          // 827
                    } else {                                                                                           // 821
                      self.emit('_handleUpload', result, opts, NOOP);                                                  // 829
                    }                                                                                                  // 1199
                                                                                                                       //
                    response.writeHead(204);                                                                           // 831
                    response.end();                                                                                    // 832
                  } else {                                                                                             // 801
                    opts = JSON.parse(body);                                                                           // 835
                    opts.___s = true;                                                                                  // 836
                                                                                                                       //
                    if (self.debug) {                                                                                  // 837
                      console.info("[FilesCollection] [File Start HTTP] " + opts.file.name + " - " + opts.fileId);     // 837
                    }                                                                                                  // 1207
                                                                                                                       //
                    if (opts != null ? (ref3 = opts.file) != null ? ref3.meta : void 0 : void 0) {                     // 838
                      opts.file.meta = fixJSONParse(opts.file.meta);                                                   // 838
                    }                                                                                                  // 1210
                                                                                                                       //
                    result = self._prepareUpload(_.clone(opts), user.userId, 'HTTP Start Method').result;              // 839
                                                                                                                       //
                    if (self.collection.findOne(result._id)) {                                                         // 840
                      throw new Meteor.Error(400, 'Can\'t start upload, data substitution detected!');                 // 841
                    }                                                                                                  // 1214
                                                                                                                       //
                    opts._id = opts.fileId;                                                                            // 842
                    opts.createdAt = new Date();                                                                       // 843
                                                                                                                       //
                    self._preCollection.insert(_.omit(opts, '___s'));                                                  // 844
                                                                                                                       //
                    self._createStream(result._id, result.path, _.omit(opts, '___s'));                                 // 845
                                                                                                                       //
                    if (opts.returnMeta) {                                                                             // 847
                      response.writeHead(200);                                                                         // 848
                      response.end(JSON.stringify({                                                                    // 849
                        uploadRoute: self.downloadRoute + "/" + self.collectionName + "/__upload",                     // 850
                        file: result                                                                                   // 851
                      }));                                                                                             // 849
                    } else {                                                                                           // 847
                      response.writeHead(204);                                                                         // 854
                      response.end();                                                                                  // 855
                    }                                                                                                  // 801
                  }                                                                                                    // 795
                } catch (error1) {                                                                                     // 795
                  error = error1;                                                                                      // 856
                  handleError(error);                                                                                  // 857
                }                                                                                                      // 1233
              });                                                                                                      // 794
            });                                                                                                        // 794
          } else {                                                                                                     // 781
            next();                                                                                                    // 860
          }                                                                                                            // 1238
                                                                                                                       //
          return;                                                                                                      // 861
        }                                                                                                              // 1240
                                                                                                                       //
        if (!self["public"]) {                                                                                         // 863
          if (!!~request._parsedUrl.path.indexOf(self.downloadRoute + "/" + self.collectionName)) {                    // 864
            uri = request._parsedUrl.path.replace(self.downloadRoute + "/" + self.collectionName, '');                 // 865
                                                                                                                       //
            if (uri.indexOf('/') === 0) {                                                                              // 866
              uri = uri.substring(1);                                                                                  // 867
            }                                                                                                          // 1246
                                                                                                                       //
            uris = uri.split('/');                                                                                     // 869
                                                                                                                       //
            if (uris.length === 3) {                                                                                   // 870
              params = {                                                                                               // 871
                query: request._parsedUrl.query ? JSON.parse('{"' + decodeURI(request._parsedUrl.query).replace(/"/g, '\\"').replace(/&/g, '","').replace(/=/g, '":"') + '"}') : {},
                _id: uris[0],                                                                                          // 873
                version: uris[1],                                                                                      // 874
                name: uris[2]                                                                                          // 875
              };                                                                                                       // 872
              http = {                                                                                                 // 876
                request: request,                                                                                      // 876
                response: response,                                                                                    // 876
                params: params                                                                                         // 876
              };                                                                                                       // 876
                                                                                                                       //
              if (self._checkAccess(http)) {                                                                           // 877
                self.download(http, uris[1], self.collection.findOne(uris[0]));                                        // 877
              }                                                                                                        // 870
            } else {                                                                                                   // 870
              next();                                                                                                  // 879
            }                                                                                                          // 864
          } else {                                                                                                     // 864
            next();                                                                                                    // 881
          }                                                                                                            // 863
        } else {                                                                                                       // 863
          if (!!~request._parsedUrl.path.indexOf("" + self.downloadRoute)) {                                           // 883
            uri = request._parsedUrl.path.replace("" + self.downloadRoute, '');                                        // 884
                                                                                                                       //
            if (uri.indexOf('/') === 0) {                                                                              // 885
              uri = uri.substring(1);                                                                                  // 886
            }                                                                                                          // 1274
                                                                                                                       //
            uris = uri.split('/');                                                                                     // 888
            _file = uris[uris.length - 1];                                                                             // 889
                                                                                                                       //
            if (_file) {                                                                                               // 890
              if (!!~_file.indexOf('-')) {                                                                             // 891
                version = _file.split('-')[0];                                                                         // 892
                _file = _file.split('-')[1].split('?')[0];                                                             // 893
              } else {                                                                                                 // 891
                version = 'original';                                                                                  // 895
                _file = _file.split('?')[0];                                                                           // 896
              }                                                                                                        // 1284
                                                                                                                       //
              params = {                                                                                               // 898
                query: request._parsedUrl.query ? JSON.parse('{"' + decodeURI(request._parsedUrl.query).replace(/"/g, '\\"').replace(/&/g, '","').replace(/=/g, '":"') + '"}') : {},
                file: _file,                                                                                           // 900
                _id: _file.split('.')[0],                                                                              // 901
                version: version,                                                                                      // 902
                name: _file                                                                                            // 903
              };                                                                                                       // 899
              http = {                                                                                                 // 904
                request: request,                                                                                      // 904
                response: response,                                                                                    // 904
                params: params                                                                                         // 904
              };                                                                                                       // 904
              self.download(http, version, self.collection.findOne(params._id));                                       // 905
            } else {                                                                                                   // 890
              next();                                                                                                  // 907
            }                                                                                                          // 883
          } else {                                                                                                     // 883
            next();                                                                                                    // 909
          }                                                                                                            // 863
        }                                                                                                              // 1304
      });                                                                                                              // 779
      _methods = {};                                                                                                   // 912
                                                                                                                       //
      _methods[self._methodNames._Remove] = function (selector) {                                                      // 917
        var cursor, user, userFuncs;                                                                                   // 918
        check(selector, Match.OneOf(String, Object));                                                                  // 918
                                                                                                                       //
        if (self.debug) {                                                                                              // 919
          console.info("[FilesCollection] [Unlink Method] [.remove(" + selector + ")]");                               // 919
        }                                                                                                              // 1312
                                                                                                                       //
        if (self.allowClientCode) {                                                                                    // 921
          if (self.onBeforeRemove && _.isFunction(self.onBeforeRemove)) {                                              // 922
            user = false;                                                                                              // 923
            userFuncs = {                                                                                              // 924
              userId: this.userId,                                                                                     // 925
              user: function () {                                                                                      // 926
                if (Meteor.users) {                                                                                    // 926
                  return Meteor.users.findOne(this.userId);                                                            // 1320
                } else {                                                                                               // 926
                  return null;                                                                                         // 1322
                }                                                                                                      // 1323
              }                                                                                                        // 924
            };                                                                                                         // 924
                                                                                                                       //
            if (!self.onBeforeRemove.call(userFuncs, self.find(selector) || null)) {                                   // 929
              throw new Meteor.Error(403, '[FilesCollection] [remove] Not permitted!');                                // 930
            }                                                                                                          // 922
          }                                                                                                            // 1329
                                                                                                                       //
          cursor = self.find(selector);                                                                                // 932
                                                                                                                       //
          if (cursor.count() > 0) {                                                                                    // 933
            self.remove(selector);                                                                                     // 934
            return true;                                                                                               // 935
          } else {                                                                                                     // 933
            throw new Meteor.Error(404, 'Cursor is empty, no files is removed');                                       // 937
          }                                                                                                            // 921
        } else {                                                                                                       // 921
          throw new Meteor.Error(401, '[FilesCollection] [remove] Run code from client is not allowed!');              // 939
        }                                                                                                              // 1339
      };                                                                                                               // 917
                                                                                                                       //
      _methods[self._methodNames._Start] = function (opts, returnMeta) {                                               // 949
        var result;                                                                                                    // 950
        check(opts, {                                                                                                  // 950
          file: Object,                                                                                                // 951
          fileId: String,                                                                                              // 952
          FSName: Match.Optional(String),                                                                              // 953
          chunkSize: Number,                                                                                           // 954
          fileLength: Number                                                                                           // 955
        });                                                                                                            // 950
        check(returnMeta, Match.Optional(Boolean));                                                                    // 958
                                                                                                                       //
        if (self.debug) {                                                                                              // 960
          console.info("[FilesCollection] [File Start Method] " + opts.file.name + " - " + opts.fileId);               // 960
        }                                                                                                              // 1353
                                                                                                                       //
        opts.___s = true;                                                                                              // 961
        result = self._prepareUpload(_.clone(opts), this.userId, 'DDP Start Method').result;                           // 962
                                                                                                                       //
        if (self.collection.findOne(result._id)) {                                                                     // 963
          throw new Meteor.Error(400, 'Can\'t start upload, data substitution detected!');                             // 964
        }                                                                                                              // 1358
                                                                                                                       //
        opts._id = opts.fileId;                                                                                        // 965
        opts.createdAt = new Date();                                                                                   // 966
                                                                                                                       //
        self._preCollection.insert(_.omit(opts, '___s'));                                                              // 967
                                                                                                                       //
        self._createStream(result._id, result.path, _.omit(opts, '___s'));                                             // 968
                                                                                                                       //
        if (returnMeta) {                                                                                              // 970
          return {                                                                                                     // 971
            uploadRoute: self.downloadRoute + "/" + self.collectionName + "/__upload",                                 // 972
            file: result                                                                                               // 973
          };                                                                                                           // 971
        } else {                                                                                                       // 970
          return true;                                                                                                 // 976
        }                                                                                                              // 1370
      };                                                                                                               // 949
                                                                                                                       //
      _methods[self._methodNames._Write] = function (opts) {                                                           // 982
        var _continueUpload, e, ref, result;                                                                           // 983
                                                                                                                       //
        check(opts, {                                                                                                  // 983
          eof: Match.Optional(Boolean),                                                                                // 984
          fileId: String,                                                                                              // 985
          binData: Match.Optional(String),                                                                             // 986
          chunkId: Match.Optional(Number)                                                                              // 987
        });                                                                                                            // 983
                                                                                                                       //
        if (opts.binData) {                                                                                            // 990
          if (typeof Buffer.from === 'function') {                                                                     // 991
            try {                                                                                                      // 992
              opts.binData = Buffer.from(opts.binData, 'base64');                                                      // 993
            } catch (error1) {                                                                                         // 992
              e = error1;                                                                                              // 994
              opts.binData = new Buffer(opts.binData, 'base64');                                                       // 995
            }                                                                                                          // 991
          } else {                                                                                                     // 991
            opts.binData = new Buffer(opts.binData, 'base64');                                                         // 997
          }                                                                                                            // 990
        }                                                                                                              // 1391
                                                                                                                       //
        _continueUpload = self._continueUpload(opts.fileId);                                                           // 999
                                                                                                                       //
        if (!_continueUpload) {                                                                                        // 1000
          throw new Meteor.Error(408, 'Can\'t continue upload, session expired. Start upload again.');                 // 1001
        }                                                                                                              // 1395
                                                                                                                       //
        this.unblock();                                                                                                // 1003
        ref = self._prepareUpload(_.extend(opts, _continueUpload), this.userId, 'DDP'), result = ref.result, opts = ref.opts;
                                                                                                                       //
        if (opts.eof) {                                                                                                // 1006
          try {                                                                                                        // 1007
            return Meteor.wrapAsync(self._handleUpload.bind(self, result, opts))();                                    // 1008
          } catch (error1) {                                                                                           // 1007
            e = error1;                                                                                                // 1009
                                                                                                                       //
            if (self.debug) {                                                                                          // 1010
              console.warn("[FilesCollection] [Write Method] [DDP] Exception:", e);                                    // 1010
            }                                                                                                          // 1405
                                                                                                                       //
            throw e;                                                                                                   // 1011
          }                                                                                                            // 1006
        } else {                                                                                                       // 1006
          self.emit('_handleUpload', result, opts, NOOP);                                                              // 1013
        }                                                                                                              // 1410
                                                                                                                       //
        return true;                                                                                                   // 1014
      };                                                                                                               // 982
                                                                                                                       //
      _methods[self._methodNames._Abort] = function (_id) {                                                            // 1021
        var _continueUpload, ref, ref1, ref2;                                                                          // 1022
                                                                                                                       //
        check(_id, String);                                                                                            // 1022
        _continueUpload = self._continueUpload(_id);                                                                   // 1024
                                                                                                                       //
        if (self.debug) {                                                                                              // 1025
          console.info("[FilesCollection] [Abort Method]: " + _id + " - " + (_continueUpload != null ? (ref = _continueUpload.file) != null ? ref.path : void 0 : void 0));
        }                                                                                                              // 1419
                                                                                                                       //
        if ((ref1 = self._currentUploads) != null ? ref1[_id] : void 0) {                                              // 1027
          self._currentUploads[_id].stop();                                                                            // 1028
                                                                                                                       //
          self._currentUploads[_id].abort();                                                                           // 1029
        }                                                                                                              // 1423
                                                                                                                       //
        if (_continueUpload) {                                                                                         // 1031
          self._preCollection.remove({                                                                                 // 1032
            _id: _id                                                                                                   // 1032
          });                                                                                                          // 1032
                                                                                                                       //
          self.remove({                                                                                                // 1033
            _id: _id                                                                                                   // 1033
          });                                                                                                          // 1033
                                                                                                                       //
          if (_continueUpload != null ? (ref2 = _continueUpload.file) != null ? ref2.path : void 0 : void 0) {         // 1034
            self.unlink({                                                                                              // 1034
              _id: _id,                                                                                                // 1034
              path: _continueUpload.file.path                                                                          // 1034
            });                                                                                                        // 1034
          }                                                                                                            // 1031
        }                                                                                                              // 1437
                                                                                                                       //
        return true;                                                                                                   // 1035
      };                                                                                                               // 1021
                                                                                                                       //
      Meteor.methods(_methods);                                                                                        // 1037
    }                                                                                                                  // 1441
  } /*                                                                                                                 // 498
    @locus Server                                                                                                      //
    @memberOf FilesCollection                                                                                          //
    @name _prepareUpload                                                                                               //
    @summary Internal method. Used to optimize received data and check upload permission                               //
    @returns {Object}                                                                                                  //
     */                                                                                                                //
                                                                                                                       //
  FilesCollection.prototype._prepareUpload = Meteor.isServer ? function (opts, userId, transport) {                    // 1453
    var base, ctx, extension, extensionWithDot, fileName, isUploadAllowed, ref, result;                                // 1047
                                                                                                                       //
    if (opts.eof == null) {                                                                                            // 1455
      opts.eof = false;                                                                                                // 1047
    }                                                                                                                  // 1457
                                                                                                                       //
    if (opts.binData == null) {                                                                                        // 1458
      opts.binData = 'EOF';                                                                                            // 1048
    }                                                                                                                  // 1460
                                                                                                                       //
    if (opts.chunkId == null) {                                                                                        // 1461
      opts.chunkId = -1;                                                                                               // 1049
    }                                                                                                                  // 1463
                                                                                                                       //
    if (opts.FSName == null) {                                                                                         // 1464
      opts.FSName = opts.fileId;                                                                                       // 1050
    }                                                                                                                  // 1466
                                                                                                                       //
    if ((base = opts.file).meta == null) {                                                                             // 1467
      base.meta = {};                                                                                                  // 1468
    }                                                                                                                  // 1469
                                                                                                                       //
    if (this.debug) {                                                                                                  // 1053
      console.info("[FilesCollection] [Upload] [" + transport + "] Got #" + opts.chunkId + "/" + opts.fileLength + " chunks, dst: " + (opts.file.name || opts.file.fileName));
    }                                                                                                                  // 1472
                                                                                                                       //
    fileName = this._getFileName(opts.file);                                                                           // 1055
    ref = this._getExt(fileName), extension = ref.extension, extensionWithDot = ref.extensionWithDot;                  // 1056
    result = opts.file;                                                                                                // 1058
    result.name = fileName;                                                                                            // 1059
    result.meta = opts.file.meta;                                                                                      // 1060
    result.extension = extension;                                                                                      // 1061
    result.ext = extension;                                                                                            // 1062
    result._id = opts.fileId;                                                                                          // 1063
    result.userId = userId || null;                                                                                    // 1064
    result.path = "" + this.storagePath(result) + nodePath.sep + opts.FSName + extensionWithDot;                       // 1065
    result = _.extend(result, this._dataToSchema(result));                                                             // 1066
                                                                                                                       //
    if (this.onBeforeUpload && _.isFunction(this.onBeforeUpload)) {                                                    // 1068
      ctx = _.extend({                                                                                                 // 1069
        file: opts.file                                                                                                // 1070
      }, {                                                                                                             // 1069
        chunkId: opts.chunkId,                                                                                         // 1072
        userId: result.userId,                                                                                         // 1073
        user: function () {                                                                                            // 1074
          if (Meteor.users) {                                                                                          // 1074
            return Meteor.users.findOne(result.userId);                                                                // 1492
          } else {                                                                                                     // 1074
            return null;                                                                                               // 1494
          }                                                                                                            // 1495
        },                                                                                                             // 1071
        eof: opts.eof                                                                                                  // 1075
      });                                                                                                              // 1071
      isUploadAllowed = this.onBeforeUpload.call(ctx, result);                                                         // 1077
                                                                                                                       //
      if (isUploadAllowed !== true) {                                                                                  // 1079
        throw new Meteor.Error(403, _.isString(isUploadAllowed) ? isUploadAllowed : '@onBeforeUpload() returned false');
      } else {                                                                                                         // 1079
        if (opts.___s === true && this.onInitiateUpload && _.isFunction(this.onInitiateUpload)) {                      // 1082
          this.onInitiateUpload.call(ctx, result);                                                                     // 1083
        }                                                                                                              // 1079
      }                                                                                                                // 1068
    }                                                                                                                  // 1507
                                                                                                                       //
    return {                                                                                                           // 1085
      result: result,                                                                                                  // 1085
      opts: opts                                                                                                       // 1085
    };                                                                                                                 // 1085
  } : void 0; /*                                                                                                       // 1046
              @locus Server                                                                                            //
              @memberOf FilesCollection                                                                                //
              @name _finishUpload                                                                                      //
              @summary Internal method. Finish upload, close Writable stream, add record to MongoDB and flush used memory
              @returns {undefined}                                                                                     //
               */                                                                                                      //
  FilesCollection.prototype._finishUpload = Meteor.isServer ? function (result, opts, cb) {                            // 1523
    var self;                                                                                                          // 1096
                                                                                                                       //
    if (this.debug) {                                                                                                  // 1096
      console.info("[FilesCollection] [Upload] [finish(ing)Upload] -> " + result.path);                                // 1096
    }                                                                                                                  // 1527
                                                                                                                       //
    fs.chmod(result.path, this.permissions, NOOP);                                                                     // 1097
    self = this;                                                                                                       // 1098
    result.type = this._getMimeType(opts.file);                                                                        // 1099
    result["public"] = this["public"];                                                                                 // 1100
                                                                                                                       //
    this._updateFileTypes(result);                                                                                     // 1101
                                                                                                                       //
    this.collection.insert(_.clone(result), function (error, _id) {                                                    // 1103
      if (error) {                                                                                                     // 1104
        cb && cb(error);                                                                                               // 1105
                                                                                                                       //
        if (self.debug) {                                                                                              // 1106
          console.error('[FilesCollection] [Upload] [_finishUpload] Error:', error);                                   // 1106
        }                                                                                                              // 1104
      } else {                                                                                                         // 1104
        self._preCollection.update({                                                                                   // 1108
          _id: opts.fileId                                                                                             // 1108
        }, {                                                                                                           // 1108
          $set: {                                                                                                      // 1108
            isFinished: true                                                                                           // 1108
          }                                                                                                            // 1108
        });                                                                                                            // 1108
                                                                                                                       //
        result._id = _id;                                                                                              // 1109
                                                                                                                       //
        if (self.debug) {                                                                                              // 1110
          console.info("[FilesCollection] [Upload] [finish(ed)Upload] -> " + result.path);                             // 1110
        }                                                                                                              // 1550
                                                                                                                       //
        self.onAfterUpload && self.onAfterUpload.call(self, result);                                                   // 1111
        self.emit('afterUpload', result);                                                                              // 1112
        cb && cb(null, result);                                                                                        // 1113
      }                                                                                                                // 1554
    });                                                                                                                // 1103
  } : void 0; /*                                                                                                       // 1095
              @locus Server                                                                                            //
              @memberOf FilesCollection                                                                                //
              @name _handleUpload                                                                                      //
              @summary Internal method to handle upload process, pipe incoming data to Writable stream                 //
              @returns {undefined}                                                                                     //
               */                                                                                                      //
  FilesCollection.prototype._handleUpload = Meteor.isServer ? function (result, opts, cb) {                            // 1567
    var e, self;                                                                                                       // 1126
                                                                                                                       //
    try {                                                                                                              // 1126
      if (opts.eof) {                                                                                                  // 1127
        self = this;                                                                                                   // 1128
                                                                                                                       //
        this._currentUploads[result._id].end(function () {                                                             // 1129
          return bound(function () {                                                                                   // 1573
            self.emit('_finishUpload', result, opts, cb);                                                              // 1130
          });                                                                                                          // 1129
        });                                                                                                            // 1129
      } else {                                                                                                         // 1127
        this._currentUploads[result._id].write(opts.chunkId, opts.binData, cb);                                        // 1133
      }                                                                                                                // 1126
    } catch (error1) {                                                                                                 // 1126
      e = error1;                                                                                                      // 1134
                                                                                                                       //
      if (this.debug) {                                                                                                // 1135
        console.warn("[_handleUpload] [EXCEPTION:]", e);                                                               // 1135
      }                                                                                                                // 1584
                                                                                                                       //
      cb && cb(e);                                                                                                     // 1136
    }                                                                                                                  // 1586
  } : void 0; /*                                                                                                       // 1125
              @locus Anywhere                                                                                          //
              @memberOf FilesCollection                                                                                //
              @name _getMimeType                                                                                       //
              @param {Object} fileData - File Object                                                                   //
              @summary Returns file's mime-type                                                                        //
              @returns {String}                                                                                        //
               */                                                                                                      //
                                                                                                                       //
  FilesCollection.prototype._getMimeType = function (fileData) {                                                       // 1599
    var br, buf, error, ext, fd, mime, ref;                                                                            // 1149
    check(fileData, Object);                                                                                           // 1149
                                                                                                                       //
    if (fileData != null ? fileData.type : void 0) {                                                                   // 1150
      mime = fileData.type;                                                                                            // 1150
    }                                                                                                                  // 1604
                                                                                                                       //
    if (Meteor.isServer && fileData.path && (!mime || !_.isString(mime))) {                                            // 1151
      try {                                                                                                            // 1152
        buf = new Buffer(262);                                                                                         // 1153
        fd = fs.openSync(fileData.path, 'r');                                                                          // 1154
        br = fs.readSync(fd, buf, 0, 262, 0);                                                                          // 1155
        fs.close(fd, NOOP);                                                                                            // 1156
                                                                                                                       //
        if (br < 262) {                                                                                                // 1157
          buf = buf.slice(0, br);                                                                                      // 1157
        }                                                                                                              // 1613
                                                                                                                       //
        ref = fileType(buf), mime = ref.mime, ext = ref.ext;                                                           // 1158
      } catch (error1) {                                                                                               // 1152
        error = error1;                                                                                                // 1159
      }                                                                                                                // 1151
    }                                                                                                                  // 1618
                                                                                                                       //
    if (!mime || !_.isString(mime)) {                                                                                  // 1160
      mime = 'application/octet-stream';                                                                               // 1161
    }                                                                                                                  // 1621
                                                                                                                       //
    return mime;                                                                                                       // 1162
  }; /*                                                                                                                // 1148
     @locus Anywhere                                                                                                   //
     @memberOf FilesCollection                                                                                         //
     @name _getFileName                                                                                                //
     @param {Object} fileData - File Object                                                                            //
     @summary Returns file's name                                                                                      //
     @returns {String}                                                                                                 //
      */                                                                                                               //
                                                                                                                       //
  FilesCollection.prototype._getFileName = function (fileData) {                                                       // 1635
    var fileName;                                                                                                      // 1173
    fileName = fileData.name || fileData.fileName;                                                                     // 1173
                                                                                                                       //
    if (_.isString(fileName) && fileName.length > 0) {                                                                 // 1174
      return (fileData.name || fileData.fileName).replace(/\.\./g, '').replace(/\//g, '');                             // 1175
    } else {                                                                                                           // 1174
      return '';                                                                                                       // 1177
    }                                                                                                                  // 1642
  }; /*                                                                                                                // 1172
     @locus Anywhere                                                                                                   //
     @memberOf FilesCollection                                                                                         //
     @name _getUser                                                                                                    //
     @summary Returns object with `userId` and `user()` method which return user's object                              //
     @returns {Object}                                                                                                 //
      */                                                                                                               //
                                                                                                                       //
  FilesCollection.prototype._getUser = function (http) {                                                               // 1654
    var cookie, mtok, ref, ref1, result, userId;                                                                       // 1187
    result = {                                                                                                         // 1187
      user: function () {                                                                                              // 1188
        return null;                                                                                                   // 1188
      },                                                                                                               // 1188
      userId: null                                                                                                     // 1189
    };                                                                                                                 // 1188
                                                                                                                       //
    if (Meteor.isServer) {                                                                                             // 1191
      if (http) {                                                                                                      // 1192
        mtok = null;                                                                                                   // 1193
                                                                                                                       //
        if (http.request.headers['x-mtok']) {                                                                          // 1194
          mtok = http.request.headers['x-mtok'];                                                                       // 1195
        } else {                                                                                                       // 1194
          cookie = http.request.Cookies;                                                                               // 1197
                                                                                                                       //
          if (cookie.has('x_mtok')) {                                                                                  // 1198
            mtok = cookie.get('x_mtok');                                                                               // 1199
          }                                                                                                            // 1194
        }                                                                                                              // 1672
                                                                                                                       //
        if (mtok) {                                                                                                    // 1201
          userId = (ref = Meteor.server.sessions) != null ? (ref1 = ref[mtok]) != null ? ref1.userId : void 0 : void 0;
                                                                                                                       //
          if (userId) {                                                                                                // 1203
            result.user = function () {                                                                                // 1204
              return Meteor.users.findOne(userId);                                                                     // 1677
            };                                                                                                         // 1204
                                                                                                                       //
            result.userId = userId;                                                                                    // 1205
          }                                                                                                            // 1201
        }                                                                                                              // 1192
      }                                                                                                                // 1191
    } else {                                                                                                           // 1191
      if (typeof Meteor.userId === "function" ? Meteor.userId() : void 0) {                                            // 1207
        result.user = function () {                                                                                    // 1208
          return Meteor.user();                                                                                        // 1208
        };                                                                                                             // 1208
                                                                                                                       //
        result.userId = Meteor.userId();                                                                               // 1209
      }                                                                                                                // 1191
    }                                                                                                                  // 1690
                                                                                                                       //
    return result;                                                                                                     // 1211
  }; /*                                                                                                                // 1186
     @locus Anywhere                                                                                                   //
     @memberOf FilesCollection                                                                                         //
     @name _getExt                                                                                                     //
     @param {String} FileName - File name                                                                              //
     @summary Get extension from FileName                                                                              //
     @returns {Object}                                                                                                 //
      */                                                                                                               //
                                                                                                                       //
  FilesCollection.prototype._getExt = function (fileName) {                                                            // 1704
    var extension;                                                                                                     // 1222
                                                                                                                       //
    if (!!~fileName.indexOf('.')) {                                                                                    // 1222
      extension = (fileName.split('.').pop().split('?')[0] || '').toLowerCase();                                       // 1223
      return {                                                                                                         // 1224
        ext: extension,                                                                                                // 1224
        extension: extension,                                                                                          // 1224
        extensionWithDot: '.' + extension                                                                              // 1224
      };                                                                                                               // 1224
    } else {                                                                                                           // 1222
      return {                                                                                                         // 1226
        ext: '',                                                                                                       // 1226
        extension: '',                                                                                                 // 1226
        extensionWithDot: ''                                                                                           // 1226
      };                                                                                                               // 1226
    }                                                                                                                  // 1719
  }; /*                                                                                                                // 1221
     @locus Anywhere                                                                                                   //
     @memberOf FilesCollection                                                                                         //
     @name _updateFileTypes                                                                                            //
     @param {Object} data - File data                                                                                  //
     @summary Internal method. Classify file based on 'type' field                                                     //
      */                                                                                                               //
                                                                                                                       //
  FilesCollection.prototype._updateFileTypes = function (data) {                                                       // 1731
    data.isVideo = /^video\//i.test(data.type);                                                                        // 1236
    data.isAudio = /^audio\//i.test(data.type);                                                                        // 1237
    data.isImage = /^image\//i.test(data.type);                                                                        // 1238
    data.isText = /^text\//i.test(data.type);                                                                          // 1239
    data.isJSON = /^application\/json$/i.test(data.type);                                                              // 1240
    data.isPDF = /^application\/(x-)?pdf$/i.test(data.type);                                                           // 1241
  }; /*                                                                                                                // 1235
     @locus Anywhere                                                                                                   //
     @memberOf FilesCollection                                                                                         //
     @name _dataToSchema                                                                                               //
     @param {Object} data - File data                                                                                  //
     @summary Internal method. Build object in accordance with default schema from File data                           //
     @returns {Object}                                                                                                 //
      */                                                                                                               //
                                                                                                                       //
  FilesCollection.prototype._dataToSchema = function (data) {                                                          // 1750
    var ds;                                                                                                            // 1253
    ds = {                                                                                                             // 1253
      name: data.name,                                                                                                 // 1254
      extension: data.extension,                                                                                       // 1255
      path: data.path,                                                                                                 // 1256
      meta: data.meta,                                                                                                 // 1257
      type: data.type,                                                                                                 // 1258
      size: data.size,                                                                                                 // 1259
      userId: data.userId || null,                                                                                     // 1260
      versions: {                                                                                                      // 1261
        original: {                                                                                                    // 1262
          path: data.path,                                                                                             // 1263
          size: data.size,                                                                                             // 1264
          type: data.type,                                                                                             // 1265
          extension: data.extension                                                                                    // 1266
        }                                                                                                              // 1263
      },                                                                                                               // 1262
      _downloadRoute: data._downloadRoute || this.downloadRoute,                                                       // 1267
      _collectionName: data._collectionName || this.collectionName                                                     // 1268
    };                                                                                                                 // 1254
                                                                                                                       //
    if (data.fileId) {                                                                                                 // 1271
      ds._id = data.fileId;                                                                                            // 1272
    }                                                                                                                  // 1773
                                                                                                                       //
    this._updateFileTypes(ds);                                                                                         // 1274
                                                                                                                       //
    ds._storagePath = data._storagePath || this.storagePath(_.extend(data, ds));                                       // 1275
    return ds;                                                                                                         // 1276
  }; /*                                                                                                                // 1252
     @locus Server                                                                                                     //
     @memberOf FilesCollection                                                                                         //
     @name write                                                                                                       //
     @param {Buffer} buffer - Binary File's Buffer                                                                     //
     @param {Object} opts - Object with file-data                                                                      //
     @param {String} opts.name - File name, alias: `fileName`                                                          //
     @param {String} opts.type - File mime-type                                                                        //
     @param {Object} opts.meta - File additional meta-data                                                             //
     @param {String} opts.userId - UserId, default *null*                                                              //
     @param {String} opts.fileId - _id, default *null*                                                                 //
     @param {Function} callback - function(error, fileObj){...}                                                        //
     @param {Boolean} proceedAfterUpload - Proceed onAfterUpload hook                                                  //
     @summary Write buffer to FS and add to FilesCollection Collection                                                 //
     @returns {FilesCollection} Instance                                                                               //
      */                                                                                                               //
                                                                                                                       //
  FilesCollection.prototype.write = Meteor.isServer ? function (buffer, opts, callback, proceedAfterUpload) {          // 1797
    var FSName, extension, extensionWithDot, fileId, fileName, ref, result, self, stream;                              // 1295
                                                                                                                       //
    if (opts == null) {                                                                                                // 1799
      opts = {};                                                                                                       // 1294
    }                                                                                                                  // 1801
                                                                                                                       //
    if (this.debug) {                                                                                                  // 1295
      console.info('[FilesCollection] [write()]');                                                                     // 1295
    }                                                                                                                  // 1804
                                                                                                                       //
    if (_.isFunction(opts)) {                                                                                          // 1297
      proceedAfterUpload = callback;                                                                                   // 1298
      callback = opts;                                                                                                 // 1299
      opts = {};                                                                                                       // 1300
    } else if (_.isBoolean(callback)) {                                                                                // 1297
      proceedAfterUpload = callback;                                                                                   // 1302
    } else if (_.isBoolean(opts)) {                                                                                    // 1301
      proceedAfterUpload = opts;                                                                                       // 1304
    }                                                                                                                  // 1813
                                                                                                                       //
    check(opts, Match.Optional(Object));                                                                               // 1306
    check(callback, Match.Optional(Function));                                                                         // 1307
    check(proceedAfterUpload, Match.Optional(Boolean));                                                                // 1308
    fileId = opts.fileId || Random.id();                                                                               // 1310
    FSName = this.namingFunction ? this.namingFunction() : fileId;                                                     // 1311
    fileName = opts.name || opts.fileName ? opts.name || opts.fileName : FSName;                                       // 1312
    ref = this._getExt(fileName), extension = ref.extension, extensionWithDot = ref.extensionWithDot;                  // 1314
    self = this;                                                                                                       // 1316
                                                                                                                       //
    if (opts == null) {                                                                                                // 1822
      opts = {};                                                                                                       // 1317
    }                                                                                                                  // 1824
                                                                                                                       //
    opts.path = "" + this.storagePath(opts) + nodePath.sep + FSName + extensionWithDot;                                // 1318
    opts.type = this._getMimeType(opts);                                                                               // 1319
                                                                                                                       //
    if (opts.meta == null) {                                                                                           // 1827
      opts.meta = {};                                                                                                  // 1320
    }                                                                                                                  // 1829
                                                                                                                       //
    if (opts.size == null) {                                                                                           // 1830
      opts.size = buffer.length;                                                                                       // 1321
    }                                                                                                                  // 1832
                                                                                                                       //
    result = this._dataToSchema({                                                                                      // 1323
      name: fileName,                                                                                                  // 1324
      path: opts.path,                                                                                                 // 1325
      meta: opts.meta,                                                                                                 // 1326
      type: opts.type,                                                                                                 // 1327
      size: opts.size,                                                                                                 // 1328
      userId: opts.userId,                                                                                             // 1329
      extension: extension                                                                                             // 1330
    });                                                                                                                // 1324
    result._id = fileId;                                                                                               // 1332
    stream = fs.createWriteStream(opts.path, {                                                                         // 1334
      flags: 'w',                                                                                                      // 1334
      mode: this.permissions                                                                                           // 1334
    });                                                                                                                // 1334
    stream.end(buffer, function (error) {                                                                              // 1335
      return bound(function () {                                                                                       // 1848
        if (error) {                                                                                                   // 1336
          callback && callback(error);                                                                                 // 1337
        } else {                                                                                                       // 1336
          self.collection.insert(result, function (error, _id) {                                                       // 1339
            var fileRef;                                                                                               // 1340
                                                                                                                       //
            if (error) {                                                                                               // 1340
              callback && callback(error);                                                                             // 1341
                                                                                                                       //
              if (self.debug) {                                                                                        // 1342
                console.warn("[FilesCollection] [write] [insert] Error: " + fileName + " -> " + self.collectionName, error);
              }                                                                                                        // 1340
            } else {                                                                                                   // 1340
              fileRef = self.collection.findOne(_id);                                                                  // 1344
              callback && callback(null, fileRef);                                                                     // 1345
                                                                                                                       //
              if (proceedAfterUpload === true) {                                                                       // 1346
                self.onAfterUpload && self.onAfterUpload.call(self, fileRef);                                          // 1347
                self.emit('afterUpload', fileRef);                                                                     // 1348
              }                                                                                                        // 1865
                                                                                                                       //
              if (self.debug) {                                                                                        // 1349
                console.info("[FilesCollection] [write]: " + fileName + " -> " + self.collectionName);                 // 1349
              }                                                                                                        // 1340
            }                                                                                                          // 1869
          });                                                                                                          // 1339
        }                                                                                                              // 1871
      });                                                                                                              // 1335
    });                                                                                                                // 1335
    return this;                                                                                                       // 1352
  } : void 0; /*                                                                                                       // 1294
              @locus Server                                                                                            //
              @memberOf FilesCollection                                                                                //
              @name load                                                                                               //
              @param {String} url - URL to file                                                                        //
              @param {Object} opts - Object with file-data                                                             //
              @param {String} opts.name - File name, alias: `fileName`                                                 //
              @param {String} opts.type - File mime-type                                                               //
              @param {Object} opts.meta - File additional meta-data                                                    //
              @param {String} opts.userId - UserId, default *null*                                                     //
              @param {String} opts.fileId - _id, default *null*                                                        //
              @param {Function} callback - function(error, fileObj){...}                                               //
              @param {Boolean} proceedAfterUpload - Proceed onAfterUpload hook                                         //
              @summary Download file, write stream to FS and add to FilesCollection Collection                         //
              @returns {FilesCollection} Instance                                                                      //
               */                                                                                                      //
  FilesCollection.prototype.load = Meteor.isServer ? function (url, opts, callback, proceedAfterUpload) {              // 1895
    var FSName, extension, extensionWithDot, fileId, fileName, pathParts, ref, self, storeResult;                      // 1373
                                                                                                                       //
    if (this.debug) {                                                                                                  // 1373
      console.info("[FilesCollection] [load(" + url + ", " + JSON.stringify(opts) + ", callback)]");                   // 1373
    }                                                                                                                  // 1899
                                                                                                                       //
    if (_.isFunction(opts)) {                                                                                          // 1375
      proceedAfterUpload = callback;                                                                                   // 1376
      callback = opts;                                                                                                 // 1377
      opts = {};                                                                                                       // 1378
    } else if (_.isBoolean(callback)) {                                                                                // 1375
      proceedAfterUpload = callback;                                                                                   // 1380
    } else if (_.isBoolean(opts)) {                                                                                    // 1379
      proceedAfterUpload = opts;                                                                                       // 1382
    }                                                                                                                  // 1908
                                                                                                                       //
    check(url, String);                                                                                                // 1384
    check(opts, Match.Optional(Object));                                                                               // 1385
    check(callback, Match.Optional(Function));                                                                         // 1386
    check(proceedAfterUpload, Match.Optional(Boolean));                                                                // 1387
    self = this;                                                                                                       // 1389
                                                                                                                       //
    if (opts == null) {                                                                                                // 1914
      opts = {};                                                                                                       // 1390
    }                                                                                                                  // 1916
                                                                                                                       //
    fileId = opts.fileId || Random.id();                                                                               // 1391
    FSName = this.namingFunction ? this.namingFunction() : fileId;                                                     // 1392
    pathParts = url.split('/');                                                                                        // 1393
    fileName = opts.name || opts.fileName ? opts.name || opts.fileName : pathParts[pathParts.length - 1] || FSName;    // 1394
    ref = this._getExt(fileName), extension = ref.extension, extensionWithDot = ref.extensionWithDot;                  // 1396
                                                                                                                       //
    if (opts.meta == null) {                                                                                           // 1922
      opts.meta = {};                                                                                                  // 1397
    }                                                                                                                  // 1924
                                                                                                                       //
    opts.path = "" + this.storagePath(opts) + nodePath.sep + FSName + extensionWithDot;                                // 1398
                                                                                                                       //
    storeResult = function (result, callback) {                                                                        // 1400
      result._id = fileId;                                                                                             // 1401
      self.collection.insert(result, function (error, _id) {                                                           // 1403
        var fileRef;                                                                                                   // 1404
                                                                                                                       //
        if (error) {                                                                                                   // 1404
          callback && callback(error);                                                                                 // 1405
                                                                                                                       //
          if (self.debug) {                                                                                            // 1406
            console.error("[FilesCollection] [load] [insert] Error: " + fileName + " -> " + self.collectionName, error);
          }                                                                                                            // 1404
        } else {                                                                                                       // 1404
          fileRef = self.collection.findOne(_id);                                                                      // 1408
          callback && callback(null, fileRef);                                                                         // 1409
                                                                                                                       //
          if (proceedAfterUpload === true) {                                                                           // 1410
            self.onAfterUpload && self.onAfterUpload.call(self, fileRef);                                              // 1411
            self.emit('afterUpload', fileRef);                                                                         // 1412
          }                                                                                                            // 1941
                                                                                                                       //
          if (self.debug) {                                                                                            // 1413
            console.info("[FilesCollection] [load] [insert] " + fileName + " -> " + self.collectionName);              // 1413
          }                                                                                                            // 1404
        }                                                                                                              // 1945
      });                                                                                                              // 1403
    };                                                                                                                 // 1400
                                                                                                                       //
    request.get(url).on('error', function (error) {                                                                    // 1417
      return bound(function () {                                                                                       // 1949
        callback && callback(error);                                                                                   // 1418
                                                                                                                       //
        if (self.debug) {                                                                                              // 1419
          return console.error("[FilesCollection] [load] [request.get(" + url + ")] Error:", error);                   // 1952
        }                                                                                                              // 1953
      });                                                                                                              // 1417
    }).on('response', function (response) {                                                                            // 1417
      return bound(function () {                                                                                       // 1956
        response.on('end', function () {                                                                               // 1421
          return bound(function () {                                                                                   // 1958
            var result;                                                                                                // 1422
                                                                                                                       //
            if (self.debug) {                                                                                          // 1422
              console.info("[FilesCollection] [load] Received: " + url);                                               // 1422
            }                                                                                                          // 1962
                                                                                                                       //
            result = self._dataToSchema({                                                                              // 1423
              name: fileName,                                                                                          // 1424
              path: opts.path,                                                                                         // 1425
              meta: opts.meta,                                                                                         // 1426
              type: opts.type || response.headers['content-type'] || self._getMimeType({                               // 1427
                path: opts.path                                                                                        // 1427
              }),                                                                                                      // 1427
              size: opts.size || parseInt(response.headers['content-length'] || 0),                                    // 1428
              userId: opts.userId,                                                                                     // 1429
              extension: extension                                                                                     // 1430
            });                                                                                                        // 1424
                                                                                                                       //
            if (!result.size) {                                                                                        // 1432
              fs.stat(opts.path, function (error, stats) {                                                             // 1433
                return bound(function () {                                                                             // 1976
                  if (error) {                                                                                         // 1434
                    callback && callback(error);                                                                       // 1435
                  } else {                                                                                             // 1434
                    result.versions.original.size = result.size = stats.size;                                          // 1437
                    storeResult(result, callback);                                                                     // 1438
                  }                                                                                                    // 1982
                });                                                                                                    // 1433
              });                                                                                                      // 1433
            } else {                                                                                                   // 1432
              storeResult(result, callback);                                                                           // 1441
            }                                                                                                          // 1987
          });                                                                                                          // 1421
        });                                                                                                            // 1421
      });                                                                                                              // 1420
    }).pipe(fs.createWriteStream(opts.path, {                                                                          // 1417
      flags: 'w',                                                                                                      // 1445
      mode: this.permissions                                                                                           // 1445
    }));                                                                                                               // 1445
    return this;                                                                                                       // 1447
  } : void 0; /*                                                                                                       // 1372
              @locus Server                                                                                            //
              @memberOf FilesCollection                                                                                //
              @name addFile                                                                                            //
              @param {String} path          - Path to file                                                             //
              @param {String} opts          - [Optional] Object with file-data                                         //
              @param {String} opts.type     - [Optional] File mime-type                                                //
              @param {Object} opts.meta     - [Optional] File additional meta-data                                     //
              @param {Object} opts.fileName - [Optional] File name, if not specified file name and extension will be taken from path
              @param {String} opts.userId   - [Optional] UserId, default *null*                                        //
              @param {Function} callback    - [Optional] function(error, fileObj){...}                                 //
              @param {Boolean} proceedAfterUpload - Proceed onAfterUpload hook                                         //
              @summary Add file from FS to FilesCollection                                                             //
              @returns {FilesCollection} Instance                                                                      //
               */                                                                                                      //
  FilesCollection.prototype.addFile = Meteor.isServer ? function (path, opts, callback, proceedAfterUpload) {          // 2015
    var self;                                                                                                          // 1467
                                                                                                                       //
    if (this.debug) {                                                                                                  // 1467
      console.info("[FilesCollection] [addFile(" + path + ")]");                                                       // 1467
    }                                                                                                                  // 2019
                                                                                                                       //
    if (_.isFunction(opts)) {                                                                                          // 1469
      proceedAfterUpload = callback;                                                                                   // 1470
      callback = opts;                                                                                                 // 1471
      opts = {};                                                                                                       // 1472
    } else if (_.isBoolean(callback)) {                                                                                // 1469
      proceedAfterUpload = callback;                                                                                   // 1474
    } else if (_.isBoolean(opts)) {                                                                                    // 1473
      proceedAfterUpload = opts;                                                                                       // 1476
    }                                                                                                                  // 2028
                                                                                                                       //
    if (this["public"]) {                                                                                              // 1478
      throw new Meteor.Error(403, 'Can not run [addFile] on public collection! Just Move file to root of your server, then add record to Collection');
    }                                                                                                                  // 2031
                                                                                                                       //
    check(path, String);                                                                                               // 1479
    check(opts, Match.Optional(Object));                                                                               // 1480
    check(callback, Match.Optional(Function));                                                                         // 1481
    check(proceedAfterUpload, Match.Optional(Boolean));                                                                // 1482
    self = this;                                                                                                       // 1484
    fs.stat(path, function (error, stats) {                                                                            // 1485
      return bound(function () {                                                                                       // 2038
        var extension, extensionWithDot, pathParts, ref, result;                                                       // 1486
                                                                                                                       //
        if (error) {                                                                                                   // 1486
          callback && callback(error);                                                                                 // 1487
        } else if (stats.isFile()) {                                                                                   // 1486
          if (opts == null) {                                                                                          // 2043
            opts = {};                                                                                                 // 1489
          }                                                                                                            // 2045
                                                                                                                       //
          opts.path = path;                                                                                            // 1490
                                                                                                                       //
          if (!opts.fileName) {                                                                                        // 1492
            pathParts = path.split(nodePath.sep);                                                                      // 1493
            opts.fileName = pathParts[pathParts.length - 1];                                                           // 1494
          }                                                                                                            // 2050
                                                                                                                       //
          ref = self._getExt(opts.fileName), extension = ref.extension, extensionWithDot = ref.extensionWithDot;       // 1496
                                                                                                                       //
          if (opts.type == null) {                                                                                     // 2052
            opts.type = self._getMimeType(opts);                                                                       // 1498
          }                                                                                                            // 2054
                                                                                                                       //
          if (opts.meta == null) {                                                                                     // 2055
            opts.meta = {};                                                                                            // 1499
          }                                                                                                            // 2057
                                                                                                                       //
          if (opts.size == null) {                                                                                     // 2058
            opts.size = stats.size;                                                                                    // 1500
          }                                                                                                            // 2060
                                                                                                                       //
          result = self._dataToSchema({                                                                                // 1502
            name: opts.fileName,                                                                                       // 1503
            path: path,                                                                                                // 1504
            meta: opts.meta,                                                                                           // 1505
            type: opts.type,                                                                                           // 1506
            size: opts.size,                                                                                           // 1507
            userId: opts.userId,                                                                                       // 1508
            extension: extension,                                                                                      // 1509
            _storagePath: path.replace("" + nodePath.sep + opts.fileName, ''),                                         // 1510
            fileId: opts.fileId || null                                                                                // 1511
          });                                                                                                          // 1503
          self.collection.insert(result, function (error, _id) {                                                       // 1514
            var fileRef;                                                                                               // 1515
                                                                                                                       //
            if (error) {                                                                                               // 1515
              callback && callback(error);                                                                             // 1516
                                                                                                                       //
              if (self.debug) {                                                                                        // 1517
                console.warn("[FilesCollection] [addFile] [insert] Error: " + fileName + " -> " + self.collectionName, error);
              }                                                                                                        // 1515
            } else {                                                                                                   // 1515
              fileRef = self.collection.findOne(_id);                                                                  // 1519
              callback && callback(null, fileRef);                                                                     // 1520
                                                                                                                       //
              if (proceedAfterUpload === true) {                                                                       // 1521
                self.onAfterUpload && self.onAfterUpload.call(self, fileRef);                                          // 1522
                self.emit('afterUpload', fileRef);                                                                     // 1523
              }                                                                                                        // 2085
                                                                                                                       //
              if (self.debug) {                                                                                        // 1524
                console.info("[FilesCollection] [addFile]: " + fileName + " -> " + self.collectionName);               // 1524
              }                                                                                                        // 1515
            }                                                                                                          // 2089
          });                                                                                                          // 1514
        } else {                                                                                                       // 1488
          callback && callback(new Meteor.Error(400, "[FilesCollection] [addFile(" + path + ")]: File does not exist"));
        }                                                                                                              // 2093
      });                                                                                                              // 1485
    });                                                                                                                // 1485
    return this;                                                                                                       // 1530
  } : void 0; /*                                                                                                       // 1466
              @locus Anywhere                                                                                          //
              @memberOf FilesCollection                                                                                //
              @name findOne                                                                                            //
              @param {String|Object} selector - Mongo-Style selector (http://docs.meteor.com/api/collections.html#selectors)
              @param {Object} options - Mongo-Style selector Options (http://docs.meteor.com/api/collections.html#sortspecifiers)
              @summary Find and return Cursor for matching document Object                                             //
              @returns {FileCursor} Instance                                                                           //
               */                                                                                                      //
                                                                                                                       //
  FilesCollection.prototype.findOne = function (selector, options) {                                                   // 2110
    var doc;                                                                                                           // 1544
                                                                                                                       //
    if (this.debug) {                                                                                                  // 1544
      console.info("[FilesCollection] [findOne(" + JSON.stringify(selector) + ", " + JSON.stringify(options) + ")]");  // 1544
    }                                                                                                                  // 2114
                                                                                                                       //
    check(selector, Match.Optional(Match.OneOf(Object, String, Boolean, Number, null)));                               // 1545
    check(options, Match.Optional(Object));                                                                            // 1546
                                                                                                                       //
    if (!arguments.length) {                                                                                           // 1548
      selector = {};                                                                                                   // 1548
    }                                                                                                                  // 2119
                                                                                                                       //
    doc = this.collection.findOne(selector, options);                                                                  // 1549
                                                                                                                       //
    if (doc) {                                                                                                         // 1550
      return new FileCursor(doc, this);                                                                                // 2122
    } else {                                                                                                           // 1550
      return doc;                                                                                                      // 2124
    }                                                                                                                  // 2125
  }; /*                                                                                                                // 1543
     @locus Anywhere                                                                                                   //
     @memberOf FilesCollection                                                                                         //
     @name find                                                                                                        //
     @param {String|Object} selector - Mongo-Style selector (http://docs.meteor.com/api/collections.html#selectors)    //
     @param {Object}        options  - Mongo-Style selector Options (http://docs.meteor.com/api/collections.html#sortspecifiers)
     @summary Find and return Cursor for matching documents                                                            //
     @returns {FilesCursor} Instance                                                                                   //
      */                                                                                                               //
                                                                                                                       //
  FilesCollection.prototype.find = function (selector, options) {                                                      // 2139
    if (this.debug) {                                                                                                  // 1562
      console.info("[FilesCollection] [find(" + JSON.stringify(selector) + ", " + JSON.stringify(options) + ")]");     // 1562
    }                                                                                                                  // 2142
                                                                                                                       //
    check(selector, Match.Optional(Match.OneOf(Object, String, Boolean, Number, null)));                               // 1563
    check(options, Match.Optional(Object));                                                                            // 1564
                                                                                                                       //
    if (!arguments.length) {                                                                                           // 1566
      selector = {};                                                                                                   // 1566
    }                                                                                                                  // 2147
                                                                                                                       //
    return new FilesCursor(selector, options, this);                                                                   // 1567
  }; /*                                                                                                                // 1561
     @locus Client                                                                                                     //
     @memberOf FilesCollection                                                                                         //
     @name insert                                                                                                      //
     @see https://developer.mozilla.org/en-US/docs/Web/API/FileReader                                                  //
     @param {Object} config - Configuration object with next properties:                                               //
       {File|Object} file           - HTML5 `files` item, like in change event: `e.currentTarget.files[0]`             //
       {Object}      meta           - Additional data as object, use later for search                                  //
       {Boolean}     allowWebWorkers- Allow/Deny WebWorkers usage                                                      //
       {Number|dynamic} streams     - Quantity of parallel upload streams, default: 2                                  //
       {Number|dynamic} chunkSize   - Chunk size for upload                                                            //
       {String}      transport      - Upload transport `http` or `ddp`                                                 //
       {Object}      ddp            - Custom DDP connection. Object returned form `DDP.connect()`                      //
       {Function}    onUploaded     - Callback triggered when upload is finished, with two arguments `error` and `fileRef`
       {Function}    onStart        - Callback triggered when upload is started after all successful validations, with two arguments `error` (always null) and `fileRef`
       {Function}    onError        - Callback triggered on error in upload and/or FileReader, with two arguments `error` and `fileData`
       {Function}    onProgress     - Callback triggered when chunk is sent, with only argument `progress`             //
       {Function}    onBeforeUpload - Callback triggered right before upload is started:                               //
           return true to continue                                                                                     //
           return false to abort upload                                                                                //
     @param {Boolean} autoStart     - Start upload immediately. If set to false, you need manually call .start() method on returned class. Useful to set EventListeners.
     @summary Upload file to server over DDP or HTTP                                                                   //
     @returns {UploadInstance} Instance. UploadInstance has next properties:                                           //
       {ReactiveVar} onPause  - Is upload process on the pause?                                                        //
       {ReactiveVar} state    - active|paused|aborted|completed                                                        //
       {ReactiveVar} progress - Current progress in percentage                                                         //
       {Function}    pause    - Pause upload process                                                                   //
       {Function}    continue - Continue paused upload process                                                         //
       {Function}    toggle   - Toggle continue/pause if upload process                                                //
       {Function}    abort    - Abort upload                                                                           //
       {Function}    readAsDataURL - Current file as data URL, use to create image preview and etc. Be aware of big files, may lead to browser crash
      */                                                                                                               //
                                                                                                                       //
  FilesCollection.prototype.insert = Meteor.isClient ? function (config, autoStart) {                                  // 2185
    if (autoStart == null) {                                                                                           // 2186
      autoStart = true;                                                                                                // 1601
    }                                                                                                                  // 2188
                                                                                                                       //
    return new this._UploadInstance(config, this)[autoStart ? 'start' : 'manual']();                                   // 1602
  } : void 0; /*                                                                                                       // 1601
              @locus Client                                                                                            //
              @memberOf FilesCollection                                                                                //
              @name _UploadInstance                                                                                    //
              @class UploadInstance                                                                                    //
              @summary Internal Class, used in upload                                                                  //
               */                                                                                                      //
  FilesCollection.prototype._UploadInstance = Meteor.isClient ? UploadInstance = function () {                         // 2201
    UploadInstance.prototype.__proto__ = EventEmitter.prototype;                                                       // 2202
                                                                                                                       //
    function UploadInstance(config1, collection) {                                                                     // 1614
      var _file, base, base1, base2, base3, base4, base5, self, wwError;                                               // 1615
                                                                                                                       //
      this.config = config1;                                                                                           // 1614
      this.collection = collection;                                                                                    // 1614
      EventEmitter.call(this);                                                                                         // 1615
                                                                                                                       //
      if (this.collection.debug) {                                                                                     // 1616
        console.info('[FilesCollection] [insert()]');                                                                  // 1616
      }                                                                                                                // 2211
                                                                                                                       //
      self = this;                                                                                                     // 1617
                                                                                                                       //
      if ((base = this.config).ddp == null) {                                                                          // 2213
        base.ddp = this.collection.ddp;                                                                                // 2214
      }                                                                                                                // 2215
                                                                                                                       //
      if ((base1 = this.config).meta == null) {                                                                        // 2216
        base1.meta = {};                                                                                               // 2217
      }                                                                                                                // 2218
                                                                                                                       //
      if ((base2 = this.config).streams == null) {                                                                     // 2219
        base2.streams = 2;                                                                                             // 2220
      }                                                                                                                // 2221
                                                                                                                       //
      if (this.config.streams < 1) {                                                                                   // 1621
        this.config.streams = 2;                                                                                       // 1621
      }                                                                                                                // 2224
                                                                                                                       //
      if ((base3 = this.config).transport == null) {                                                                   // 2225
        base3.transport = 'ddp';                                                                                       // 2226
      }                                                                                                                // 2227
                                                                                                                       //
      if ((base4 = this.config).chunkSize == null) {                                                                   // 2228
        base4.chunkSize = this.collection.chunkSize;                                                                   // 2229
      }                                                                                                                // 2230
                                                                                                                       //
      if ((base5 = this.config).allowWebWorkers == null) {                                                             // 2231
        base5.allowWebWorkers = true;                                                                                  // 2232
      }                                                                                                                // 2233
                                                                                                                       //
      this.config.transport = this.config.transport.toLowerCase();                                                     // 1625
      check(this.config, {                                                                                             // 1627
        file: Match.Any,                                                                                               // 1628
        fileName: Match.Optional(String),                                                                              // 1629
        meta: Match.Optional(Object),                                                                                  // 1630
        type: Match.Optional(String),                                                                                  // 1631
        onError: Match.Optional(Function),                                                                             // 1632
        onAbort: Match.Optional(Function),                                                                             // 1633
        streams: Match.OneOf('dynamic', Number),                                                                       // 1634
        onStart: Match.Optional(Function),                                                                             // 1635
        isBase64: Match.Optional(Boolean),                                                                             // 1636
        transport: Match.OneOf('http', 'ddp'),                                                                         // 1637
        chunkSize: Match.OneOf('dynamic', Number),                                                                     // 1638
        onUploaded: Match.Optional(Function),                                                                          // 1639
        onProgress: Match.Optional(Function),                                                                          // 1640
        onBeforeUpload: Match.Optional(Function),                                                                      // 1641
        allowWebWorkers: Boolean,                                                                                      // 1642
        ddp: Match.Any                                                                                                 // 1643
      });                                                                                                              // 1627
                                                                                                                       //
      if (!this.config.fileName && !this.config.file.name) {                                                           // 1646
        throw new Meteor.Error(400, '"fileName" must me specified for base64 upload!');                                // 1647
      }                                                                                                                // 2255
                                                                                                                       //
      if (this.config.isBase64 === true) {                                                                             // 1649
        check(this.config.file, String);                                                                               // 1650
                                                                                                                       //
        if (!!~this.config.file.indexOf('data:')) {                                                                    // 1651
          this.config.file = this.config.file.replace('data:', '');                                                    // 1652
        }                                                                                                              // 2260
                                                                                                                       //
        if (!!~this.config.file.indexOf(',')) {                                                                        // 1653
          _file = this.config.file.split(',');                                                                         // 1654
          this.fileData = {                                                                                            // 1655
            size: Math.floor(_file[1].replace(/\=/g, '').length / 4 * 3),                                              // 1656
            type: _file[0].split(';')[0],                                                                              // 1657
            name: this.config.fileName,                                                                                // 1658
            meta: this.config.meta                                                                                     // 1659
          };                                                                                                           // 1656
          this.config.file = _file[1];                                                                                 // 1660
        } else if (!this.config.type) {                                                                                // 1653
          throw new Meteor.Error(400, '"type" must me specified for base64 upload! And represent mime-type of the file');
        } else {                                                                                                       // 1661
          this.fileData = {                                                                                            // 1664
            size: Math.floor(this.config.file.replace(/\=/g, '').length / 4 * 3),                                      // 1665
            type: this.config.type,                                                                                    // 1666
            name: this.config.fileName,                                                                                // 1667
            meta: this.config.meta                                                                                     // 1668
          };                                                                                                           // 1665
        }                                                                                                              // 1649
      }                                                                                                                // 2280
                                                                                                                       //
      if (this.config.file) {                                                                                          // 1670
        if (!this.config.isBase64) {                                                                                   // 1671
          this.fileData = {                                                                                            // 1672
            size: this.config.file.size,                                                                               // 1673
            type: this.config.type || this.config.file.type,                                                           // 1674
            name: this.config.fileName || this.config.file.name,                                                       // 1675
            meta: this.config.meta                                                                                     // 1676
          };                                                                                                           // 1673
        }                                                                                                              // 2289
                                                                                                                       //
        if (this.collection.debug) {                                                                                   // 1678
          console.time('insert ' + this.fileData.name);                                                                // 1679
          console.time('loadFile ' + this.fileData.name);                                                              // 1680
        }                                                                                                              // 2293
                                                                                                                       //
        if (this.collection._supportWebWorker && this.config.allowWebWorkers) {                                        // 1682
          try {                                                                                                        // 1683
            this.worker = new Worker(this.collection._webWorkerUrl);                                                   // 1684
          } catch (error1) {                                                                                           // 1683
            wwError = error1;                                                                                          // 1685
            this.worker = false;                                                                                       // 1686
                                                                                                                       //
            if (this.collection.debug) {                                                                               // 1687
              console.warn('[FilesCollection] [insert] [create WebWorker]: Can\'t create WebWorker, fallback to MainThread', wwError);
            }                                                                                                          // 1683
          }                                                                                                            // 1682
        } else {                                                                                                       // 1682
          this.worker = null;                                                                                          // 1689
        }                                                                                                              // 2306
                                                                                                                       //
        this.startTime = {};                                                                                           // 1691
        this.config.debug = this.collection.debug;                                                                     // 1692
        this.currentChunk = 0;                                                                                         // 1693
        this.transferTime = 0;                                                                                         // 1694
        this.trackerComp = null;                                                                                       // 1695
        this.sentChunks = 0;                                                                                           // 1696
        this.fileLength = 1;                                                                                           // 1697
        this.EOFsent = false;                                                                                          // 1698
        this.fileId = Random.id();                                                                                     // 1699
        this.FSName = this.collection.namingFunction ? this.collection.namingFunction(this.fileData) : this.fileId;    // 1700
        this.pipes = [];                                                                                               // 1701
        this.fileData = _.extend(this.fileData, this.collection._getExt(self.fileData.name), {                         // 1703
          mime: this.collection._getMimeType(this.fileData)                                                            // 1703
        });                                                                                                            // 1703
        this.fileData['mime-type'] = this.fileData.mime;                                                               // 1704
        this.result = new this.collection._FileUpload(_.extend(self.config, {                                          // 1706
          fileData: this.fileData,                                                                                     // 1706
          fileId: this.fileId,                                                                                         // 1706
          _Abort: this.collection._methodNames._Abort                                                                  // 1706
        }));                                                                                                           // 1706
                                                                                                                       //
        this.beforeunload = function (e) {                                                                             // 1708
          var message;                                                                                                 // 1709
          message = _.isFunction(self.collection.onbeforeunloadMessage) ? self.collection.onbeforeunloadMessage.call(self.result, self.fileData) : self.collection.onbeforeunloadMessage;
                                                                                                                       //
          if (e) {                                                                                                     // 1710
            e.returnValue = message;                                                                                   // 1710
          }                                                                                                            // 2332
                                                                                                                       //
          return message;                                                                                              // 1711
        };                                                                                                             // 1708
                                                                                                                       //
        this.result.config.beforeunload = this.beforeunload;                                                           // 1712
        window.addEventListener('beforeunload', this.beforeunload, false);                                             // 1713
                                                                                                                       //
        this.result.config._onEnd = function () {                                                                      // 1715
          return self.emitEvent('_onEnd');                                                                             // 2338
        };                                                                                                             // 1715
                                                                                                                       //
        this.addListener('end', this.end);                                                                             // 1717
        this.addListener('start', this.start);                                                                         // 1718
        this.addListener('upload', this.upload);                                                                       // 1719
        this.addListener('sendEOF', this.sendEOF);                                                                     // 1720
        this.addListener('prepare', this.prepare);                                                                     // 1721
        this.addListener('sendChunk', this.sendChunk);                                                                 // 1722
        this.addListener('proceedChunk', this.proceedChunk);                                                           // 1723
        this.addListener('createStreams', this.createStreams);                                                         // 1724
        this.addListener('calculateStats', _.throttle(function () {                                                    // 1726
          var _t, progress;                                                                                            // 1727
                                                                                                                       //
          _t = self.transferTime / self.sentChunks / self.config.streams;                                              // 1727
          self.result.estimateTime.set(_t * (self.fileLength - self.sentChunks));                                      // 1728
          self.result.estimateSpeed.set(self.config.chunkSize / (_t / 1000));                                          // 1729
          progress = Math.round(self.sentChunks / self.fileLength * 100);                                              // 1730
          self.result.progress.set(progress);                                                                          // 1731
          self.config.onProgress && self.config.onProgress.call(self.result, progress, self.fileData);                 // 1732
          self.result.emitEvent('progress', [progress, self.fileData]);                                                // 1733
        }, 250));                                                                                                      // 1726
        this.addListener('_onEnd', function () {                                                                       // 1737
          if (self.result.estimateTimer) {                                                                             // 1738
            Meteor.clearInterval(self.result.estimateTimer);                                                           // 1738
          }                                                                                                            // 2361
                                                                                                                       //
          if (self.worker) {                                                                                           // 1739
            self.worker.terminate();                                                                                   // 1739
          }                                                                                                            // 2364
                                                                                                                       //
          if (self.trackerComp) {                                                                                      // 1740
            self.trackerComp.stop();                                                                                   // 1740
          }                                                                                                            // 2367
                                                                                                                       //
          if (self.beforeunload) {                                                                                     // 1741
            window.removeEventListener('beforeunload', self.beforeunload, false);                                      // 1741
          }                                                                                                            // 2370
                                                                                                                       //
          if (self.result) {                                                                                           // 1742
            return self.result.progress.set(0);                                                                        // 2372
          }                                                                                                            // 2373
        });                                                                                                            // 1737
      } else {                                                                                                         // 1670
        throw new Meteor.Error(500, '[FilesCollection] [insert] Have you forget to pass a File itself?');              // 1744
      }                                                                                                                // 2377
    }                                                                                                                  // 1614
                                                                                                                       //
    UploadInstance.prototype.end = function (error, data) {                                                            // 2380
      if (this.collection.debug) {                                                                                     // 1747
        console.timeEnd('insert ' + this.fileData.name);                                                               // 1747
      }                                                                                                                // 2383
                                                                                                                       //
      this.emitEvent('_onEnd');                                                                                        // 1748
      this.result.emitEvent('uploaded', [error, data]);                                                                // 1749
      this.config.onUploaded && this.config.onUploaded.call(this.result, error, data);                                 // 1750
                                                                                                                       //
      if (error) {                                                                                                     // 1751
        if (this.collection.debug) {                                                                                   // 1752
          console.error('[FilesCollection] [insert] [end] Error:', error);                                             // 1752
        }                                                                                                              // 2390
                                                                                                                       //
        this.result.abort();                                                                                           // 1753
        this.result.state.set('aborted');                                                                              // 1754
        this.result.emitEvent('error', [error, this.fileData]);                                                        // 1755
        this.config.onError && this.config.onError.call(this.result, error, this.fileData);                            // 1756
      } else {                                                                                                         // 1751
        this.result.state.set('completed');                                                                            // 1758
        this.collection.emitEvent('afterUpload', [data]);                                                              // 1759
      }                                                                                                                // 2398
                                                                                                                       //
      this.result.emitEvent('end', [error, data || this.fileData]);                                                    // 1760
      return this.result;                                                                                              // 1761
    };                                                                                                                 // 1746
                                                                                                                       //
    UploadInstance.prototype.sendChunk = function (evt) {                                                              // 2403
      var j, len, opts, p, pad, pipeFunc, ref, ref1, self;                                                             // 1764
      self = this;                                                                                                     // 1764
      opts = {                                                                                                         // 1765
        fileId: this.fileId,                                                                                           // 1766
        binData: evt.data.bin,                                                                                         // 1767
        chunkId: evt.data.chunkId                                                                                      // 1768
      };                                                                                                               // 1766
                                                                                                                       //
      if (this.config.isBase64) {                                                                                      // 1770
        pad = opts.binData.length % 4;                                                                                 // 1771
                                                                                                                       //
        if (pad) {                                                                                                     // 1772
          p = 0;                                                                                                       // 1773
                                                                                                                       //
          while (p < pad) {                                                                                            // 1774
            opts.binData += '=';                                                                                       // 1775
            p++;                                                                                                       // 1776
          }                                                                                                            // 1772
        }                                                                                                              // 1770
      }                                                                                                                // 2420
                                                                                                                       //
      this.emitEvent('data', [evt.data.bin]);                                                                          // 1778
                                                                                                                       //
      if (this.pipes.length) {                                                                                         // 1779
        ref = this.pipes;                                                                                              // 1780
                                                                                                                       //
        for (j = 0, len = ref.length; j < len; j++) {                                                                  // 1780
          pipeFunc = ref[j];                                                                                           // 2425
          opts.binData = pipeFunc(opts.binData);                                                                       // 1781
        }                                                                                                              // 1779
      }                                                                                                                // 2428
                                                                                                                       //
      if (this.fileLength === evt.data.chunkId) {                                                                      // 1783
        if (this.collection.debug) {                                                                                   // 1784
          console.timeEnd('loadFile ' + this.fileData.name);                                                           // 1784
        }                                                                                                              // 2432
                                                                                                                       //
        this.emitEvent('readEnd');                                                                                     // 1785
      }                                                                                                                // 2434
                                                                                                                       //
      if (opts.binData) {                                                                                              // 1787
        if (this.config.transport === 'ddp') {                                                                         // 1788
          this.config.ddp.call(this.collection._methodNames._Write, opts, function (error) {                           // 1789
            self.transferTime += +new Date() - self.startTime[opts.chunkId];                                           // 1790
                                                                                                                       //
            if (error) {                                                                                               // 1791
              if (self.result.state.get() !== 'aborted') {                                                             // 1792
                self.emitEvent('end', [error]);                                                                        // 1793
              }                                                                                                        // 1791
            } else {                                                                                                   // 1791
              ++self.sentChunks;                                                                                       // 1795
                                                                                                                       //
              if (self.sentChunks >= self.fileLength) {                                                                // 1796
                self.emitEvent('sendEOF');                                                                             // 1797
              } else if (self.currentChunk < self.fileLength) {                                                        // 1796
                self.emitEvent('upload');                                                                              // 1799
              }                                                                                                        // 2449
                                                                                                                       //
              self.emitEvent('calculateStats');                                                                        // 1800
            }                                                                                                          // 2451
          });                                                                                                          // 1789
        } else {                                                                                                       // 1788
          HTTP.call('POST', this.collection.downloadRoute + "/" + this.collection.collectionName + "/__upload", {      // 1803
            content: opts.binData,                                                                                     // 1804
            headers: {                                                                                                 // 1805
              'x-mtok': ((ref1 = Meteor.connection) != null ? ref1._lastSessionId : void 0) || null,                   // 1806
              'x-fileid': opts.fileId,                                                                                 // 1807
              'x-chunkid': opts.chunkId,                                                                               // 1808
              'content-type': 'text/plain'                                                                             // 1809
            }                                                                                                          // 1806
          }, function (error) {                                                                                        // 1803
            self.transferTime += +new Date() - self.startTime[opts.chunkId];                                           // 1811
                                                                                                                       //
            if (error) {                                                                                               // 1812
              if ("" + error === "Error: network") {                                                                   // 1813
                self.result.pause();                                                                                   // 1814
              } else {                                                                                                 // 1813
                if (self.result.state.get() !== 'aborted') {                                                           // 1816
                  self.emitEvent('end', [error]);                                                                      // 1817
                }                                                                                                      // 1813
              }                                                                                                        // 1812
            } else {                                                                                                   // 1812
              ++self.sentChunks;                                                                                       // 1819
                                                                                                                       //
              if (self.sentChunks >= self.fileLength) {                                                                // 1820
                self.emitEvent('sendEOF');                                                                             // 1821
              } else if (self.currentChunk < self.fileLength) {                                                        // 1820
                self.emitEvent('upload');                                                                              // 1823
              }                                                                                                        // 2478
                                                                                                                       //
              self.emitEvent('calculateStats');                                                                        // 1824
            }                                                                                                          // 2480
          });                                                                                                          // 1803
        }                                                                                                              // 1787
      }                                                                                                                // 2483
    };                                                                                                                 // 1763
                                                                                                                       //
    UploadInstance.prototype.sendEOF = function () {                                                                   // 2486
      var opts, ref, self;                                                                                             // 1829
                                                                                                                       //
      if (!this.EOFsent) {                                                                                             // 1829
        this.EOFsent = true;                                                                                           // 1830
        self = this;                                                                                                   // 1831
        opts = {                                                                                                       // 1832
          eof: true,                                                                                                   // 1833
          fileId: this.fileId                                                                                          // 1834
        };                                                                                                             // 1833
                                                                                                                       //
        if (this.config.transport === 'ddp') {                                                                         // 1836
          this.config.ddp.call(this.collection._methodNames._Write, opts, function () {                                // 1837
            self.emitEvent('end', arguments);                                                                          // 1838
          });                                                                                                          // 1837
        } else {                                                                                                       // 1836
          HTTP.call('POST', this.collection.downloadRoute + "/" + this.collection.collectionName + "/__upload", {      // 1841
            content: '',                                                                                               // 1842
            headers: {                                                                                                 // 1843
              'x-mtok': ((ref = Meteor.connection) != null ? ref._lastSessionId : void 0) || null,                     // 1844
              'x-eof': '1',                                                                                            // 1845
              'x-fileId': opts.fileId,                                                                                 // 1846
              'content-type': 'text/plain'                                                                             // 1847
            }                                                                                                          // 1844
          }, function (error, result) {                                                                                // 1841
            result = JSON.parse((result != null ? result.content : void 0) || {});                                     // 1849
                                                                                                                       //
            if (result != null ? result.meta : void 0) {                                                               // 1850
              result.meta = fixJSONParse(result.meta);                                                                 // 1850
            }                                                                                                          // 2512
                                                                                                                       //
            self.emitEvent('end', [error, result]);                                                                    // 1851
          });                                                                                                          // 1841
        }                                                                                                              // 1829
      }                                                                                                                // 2516
    };                                                                                                                 // 1828
                                                                                                                       //
    UploadInstance.prototype.proceedChunk = function (chunkId) {                                                       // 2519
      var chunk, fileReader, self;                                                                                     // 1856
      self = this;                                                                                                     // 1856
      chunk = this.config.file.slice(this.config.chunkSize * (chunkId - 1), this.config.chunkSize * chunkId);          // 1857
                                                                                                                       //
      if (this.config.isBase64) {                                                                                      // 1859
        self.emitEvent('sendChunk', [{                                                                                 // 1860
          data: {                                                                                                      // 1861
            bin: chunk,                                                                                                // 1862
            chunkId: chunkId                                                                                           // 1863
          }                                                                                                            // 1861
        }]);                                                                                                           // 1860
      } else {                                                                                                         // 1859
        if (FileReader) {                                                                                              // 1867
          fileReader = new FileReader();                                                                               // 1868
                                                                                                                       //
          fileReader.onloadend = function (evt) {                                                                      // 1870
            var ref, ref1;                                                                                             // 1871
            self.emitEvent('sendChunk', [{                                                                             // 1871
              data: {                                                                                                  // 1872
                bin: ((fileReader != null ? fileReader.result : void 0) || ((ref = evt.srcElement) != null ? ref.result : void 0) || ((ref1 = evt.target) != null ? ref1.result : void 0)).split(',')[1],
                chunkId: chunkId                                                                                       // 1874
              }                                                                                                        // 1872
            }]);                                                                                                       // 1871
          };                                                                                                           // 1870
                                                                                                                       //
          fileReader.onerror = function (e) {                                                                          // 1879
            self.emitEvent('end', [(e.target || e.srcElement).error]);                                                 // 1880
          };                                                                                                           // 1879
                                                                                                                       //
          fileReader.readAsDataURL(chunk);                                                                             // 1883
        } else if (FileReaderSync) {                                                                                   // 1867
          fileReader = new FileReaderSync();                                                                           // 1886
          self.emitEvent('sendChunk', [{                                                                               // 1888
            data: {                                                                                                    // 1889
              bin: fileReader.readAsDataURL(chunk).split(',')[1],                                                      // 1890
              chunkId: chunkId                                                                                         // 1891
            }                                                                                                          // 1889
          }]);                                                                                                         // 1888
        } else {                                                                                                       // 1885
          self.emitEvent('end', ['File API is not supported in this Browser!']);                                       // 1895
        }                                                                                                              // 1859
      }                                                                                                                // 2563
    };                                                                                                                 // 1855
                                                                                                                       //
    UploadInstance.prototype.upload = function () {                                                                    // 2566
      if (this.result.onPause.get()) {                                                                                 // 1899
        return;                                                                                                        // 1900
      }                                                                                                                // 2569
                                                                                                                       //
      if (this.result.state.get() === 'aborted') {                                                                     // 1902
        return this;                                                                                                   // 1903
      }                                                                                                                // 2572
                                                                                                                       //
      if (this.currentChunk <= this.fileLength) {                                                                      // 1905
        ++this.currentChunk;                                                                                           // 1906
                                                                                                                       //
        if (this.worker) {                                                                                             // 1907
          this.worker.postMessage({                                                                                    // 1908
            sc: this.sentChunks,                                                                                       // 1908
            cc: this.currentChunk,                                                                                     // 1908
            cs: this.config.chunkSize,                                                                                 // 1908
            f: this.config.file,                                                                                       // 1908
            ib: this.config.isBase64                                                                                   // 1908
          });                                                                                                          // 1908
        } else {                                                                                                       // 1907
          this.emitEvent('proceedChunk', [this.currentChunk]);                                                         // 1910
        }                                                                                                              // 1905
      }                                                                                                                // 2586
                                                                                                                       //
      this.startTime[this.currentChunk] = +new Date();                                                                 // 1911
    };                                                                                                                 // 1898
                                                                                                                       //
    UploadInstance.prototype.createStreams = function () {                                                             // 2590
      var i, self;                                                                                                     // 1915
      i = 1;                                                                                                           // 1915
      self = this;                                                                                                     // 1916
                                                                                                                       //
      while (i <= this.config.streams) {                                                                               // 1917
        self.emitEvent('upload');                                                                                      // 1918
        i++;                                                                                                           // 1919
      }                                                                                                                // 1917
    };                                                                                                                 // 1914
                                                                                                                       //
    UploadInstance.prototype.prepare = function () {                                                                   // 2600
      var _len, handleStart, opts, ref, ref1, self;                                                                    // 1923
                                                                                                                       //
      self = this;                                                                                                     // 1923
      this.config.onStart && this.config.onStart.call(this.result, null, this.fileData);                               // 1925
      this.result.emitEvent('start', [null, this.fileData]);                                                           // 1926
                                                                                                                       //
      if (this.config.chunkSize === 'dynamic') {                                                                       // 1928
        this.config.chunkSize = this.fileData.size / 1000;                                                             // 1929
                                                                                                                       //
        if (this.config.chunkSize < 327680) {                                                                          // 1930
          this.config.chunkSize = 327680;                                                                              // 1931
        } else if (this.config.chunkSize > 1048576) {                                                                  // 1930
          this.config.chunkSize = 1048576;                                                                             // 1933
        }                                                                                                              // 2611
                                                                                                                       //
        if (this.config.transport === 'http') {                                                                        // 1935
          this.config.chunkSize = Math.round(this.config.chunkSize / 2);                                               // 1936
        }                                                                                                              // 1928
      }                                                                                                                // 2615
                                                                                                                       //
      if (this.config.isBase64) {                                                                                      // 1938
        this.config.chunkSize = Math.floor(this.config.chunkSize / 4) * 4;                                             // 1939
        _len = Math.ceil(this.config.file.length / this.config.chunkSize);                                             // 1940
      } else {                                                                                                         // 1938
        this.config.chunkSize = Math.floor(this.config.chunkSize / 8) * 8;                                             // 1942
        _len = Math.ceil(this.fileData.size / this.config.chunkSize);                                                  // 1943
      }                                                                                                                // 2622
                                                                                                                       //
      if (this.config.streams === 'dynamic') {                                                                         // 1945
        this.config.streams = _.clone(_len);                                                                           // 1946
                                                                                                                       //
        if (this.config.streams > 24) {                                                                                // 1947
          this.config.streams = 24;                                                                                    // 1947
        }                                                                                                              // 2627
                                                                                                                       //
        if (this.config.transport === 'http') {                                                                        // 1949
          this.config.streams = Math.round(this.config.streams / 2);                                                   // 1950
        }                                                                                                              // 1945
      }                                                                                                                // 2631
                                                                                                                       //
      this.fileLength = _len <= 0 ? 1 : _len;                                                                          // 1952
                                                                                                                       //
      if (this.config.streams > this.fileLength) {                                                                     // 1953
        this.config.streams = this.fileLength;                                                                         // 1953
      }                                                                                                                // 2635
                                                                                                                       //
      this.result.config.fileLength = this.fileLength;                                                                 // 1954
      opts = {                                                                                                         // 1956
        file: this.fileData,                                                                                           // 1957
        fileId: this.fileId,                                                                                           // 1958
        chunkSize: this.config.isBase64 ? this.config.chunkSize / 4 * 3 : this.config.chunkSize,                       // 1959
        fileLength: this.fileLength                                                                                    // 1960
      };                                                                                                               // 1957
                                                                                                                       //
      if (this.FSName !== this.fileId) {                                                                               // 1961
        opts.FSName = this.FSName;                                                                                     // 1961
      }                                                                                                                // 2645
                                                                                                                       //
      handleStart = function (error) {                                                                                 // 1963
        if (error) {                                                                                                   // 1964
          if (self.collection.debug) {                                                                                 // 1965
            console.error('[FilesCollection] [_Start] Error:', error);                                                 // 1965
          }                                                                                                            // 2650
                                                                                                                       //
          self.emitEvent('end', [error]);                                                                              // 1966
        } else {                                                                                                       // 1964
          self.result.continueFunc = function () {                                                                     // 1968
            if (self.collection.debug) {                                                                               // 1969
              console.info('[FilesCollection] [insert] [continueFunc]');                                               // 1969
            }                                                                                                          // 2656
                                                                                                                       //
            self.emitEvent('createStreams');                                                                           // 1970
          };                                                                                                           // 1968
                                                                                                                       //
          self.emitEvent('createStreams');                                                                             // 1972
        }                                                                                                              // 2660
      };                                                                                                               // 1963
                                                                                                                       //
      if (this.config.transport === 'ddp') {                                                                           // 1975
        this.config.ddp.call(this.collection._methodNames._Start, opts, handleStart);                                  // 1976
      } else {                                                                                                         // 1975
        if ((ref = opts.file) != null ? ref.meta : void 0) {                                                           // 1978
          opts.file.meta = fixJSONStringify(opts.file.meta);                                                           // 1978
        }                                                                                                              // 2667
                                                                                                                       //
        HTTP.call('POST', this.collection.downloadRoute + "/" + this.collection.collectionName + "/__upload", {        // 1979
          data: opts,                                                                                                  // 1980
          headers: {                                                                                                   // 1981
            'x-start': '1',                                                                                            // 1982
            'x-mtok': ((ref1 = Meteor.connection) != null ? ref1._lastSessionId : void 0) || null                      // 1983
          }                                                                                                            // 1982
        }, handleStart);                                                                                               // 1979
      }                                                                                                                // 2675
    };                                                                                                                 // 1922
                                                                                                                       //
    UploadInstance.prototype.pipe = function (func) {                                                                  // 2678
      this.pipes.push(func);                                                                                           // 1988
      return this;                                                                                                     // 1989
    };                                                                                                                 // 1987
                                                                                                                       //
    UploadInstance.prototype.start = function () {                                                                     // 2683
      var isUploadAllowed, self;                                                                                       // 1992
      self = this;                                                                                                     // 1992
                                                                                                                       //
      if (this.fileData.size <= 0) {                                                                                   // 1993
        this.end(new Meteor.Error(400, 'Can\'t upload empty file'));                                                   // 1994
        return this.result;                                                                                            // 1995
      }                                                                                                                // 2689
                                                                                                                       //
      if (this.config.onBeforeUpload && _.isFunction(this.config.onBeforeUpload)) {                                    // 1997
        isUploadAllowed = this.config.onBeforeUpload.call(_.extend(this.result, this.collection._getUser()), this.fileData);
                                                                                                                       //
        if (isUploadAllowed !== true) {                                                                                // 1999
          return this.end(new Meteor.Error(403, _.isString(isUploadAllowed) ? isUploadAllowed : 'config.onBeforeUpload() returned false'));
        }                                                                                                              // 1997
      }                                                                                                                // 2695
                                                                                                                       //
      if (this.collection.onBeforeUpload && _.isFunction(this.collection.onBeforeUpload)) {                            // 2002
        isUploadAllowed = this.collection.onBeforeUpload.call(_.extend(this.result, this.collection._getUser()), this.fileData);
                                                                                                                       //
        if (isUploadAllowed !== true) {                                                                                // 2004
          return this.end(new Meteor.Error(403, _.isString(isUploadAllowed) ? isUploadAllowed : 'collection.onBeforeUpload() returned false'));
        }                                                                                                              // 2002
      }                                                                                                                // 2701
                                                                                                                       //
      Tracker.autorun(function (computation) {                                                                         // 2007
        self.trackerComp = computation;                                                                                // 2008
                                                                                                                       //
        if (!self.result.onPause.get()) {                                                                              // 2009
          if (Meteor.status().connected) {                                                                             // 2010
            if (self.collection.debug) {                                                                               // 2011
              console.info('[FilesCollection] [insert] [Tracker] [continue]');                                         // 2011
            }                                                                                                          // 2708
                                                                                                                       //
            self.result["continue"]();                                                                                 // 2012
          } else {                                                                                                     // 2010
            if (self.collection.debug) {                                                                               // 2014
              console.info('[FilesCollection] [insert] [Tracker] [pause]');                                            // 2014
            }                                                                                                          // 2713
                                                                                                                       //
            self.result.pause();                                                                                       // 2015
          }                                                                                                            // 2009
        }                                                                                                              // 2716
      });                                                                                                              // 2007
                                                                                                                       //
      if (this.worker) {                                                                                               // 2018
        this.worker.onmessage = function (evt) {                                                                       // 2019
          if (evt.data.error) {                                                                                        // 2020
            if (self.collection.debug) {                                                                               // 2021
              console.warn('[FilesCollection] [insert] [worker] [onmessage] [ERROR:]', evt.data.error);                // 2021
            }                                                                                                          // 2723
                                                                                                                       //
            self.emitEvent('proceedChunk', [evt.data.chunkId]);                                                        // 2022
          } else {                                                                                                     // 2020
            self.emitEvent('sendChunk', [evt]);                                                                        // 2024
          }                                                                                                            // 2727
        };                                                                                                             // 2019
                                                                                                                       //
        this.worker.onerror = function (e) {                                                                           // 2026
          if (self.collection.debug) {                                                                                 // 2027
            console.error('[FilesCollection] [insert] [worker] [onerror] [ERROR:]', e);                                // 2027
          }                                                                                                            // 2732
                                                                                                                       //
          self.emitEvent('end', [e.message]);                                                                          // 2028
        };                                                                                                             // 2026
      }                                                                                                                // 2735
                                                                                                                       //
      if (this.collection.debug) {                                                                                     // 2031
        if (this.worker) {                                                                                             // 2032
          console.info('[FilesCollection] [insert] using WebWorkers');                                                 // 2033
        } else {                                                                                                       // 2032
          console.info('[FilesCollection] [insert] using MainThread');                                                 // 2035
        }                                                                                                              // 2031
      }                                                                                                                // 2742
                                                                                                                       //
      self.emitEvent('prepare');                                                                                       // 2037
      return this.result;                                                                                              // 2038
    };                                                                                                                 // 1991
                                                                                                                       //
    UploadInstance.prototype.manual = function () {                                                                    // 2747
      var self;                                                                                                        // 2041
      self = this;                                                                                                     // 2041
                                                                                                                       //
      this.result.start = function () {                                                                                // 2042
        self.emitEvent('start');                                                                                       // 2043
      };                                                                                                               // 2042
                                                                                                                       //
      this.result.pipe = function (func) {                                                                             // 2045
        self.pipe(func);                                                                                               // 2046
        return this;                                                                                                   // 2047
      };                                                                                                               // 2045
                                                                                                                       //
      return this.result;                                                                                              // 2048
    };                                                                                                                 // 2040
                                                                                                                       //
    return UploadInstance;                                                                                             // 2760
  }() : void 0; /*                                                                                                     // 2762
                @locus Client                                                                                          //
                @memberOf FilesCollection                                                                              //
                @name _FileUpload                                                                                      //
                @class FileUpload                                                                                      //
                @summary Internal Class, instance of this class is returned from `insert()` method                     //
                 */                                                                                                    //
  FilesCollection.prototype._FileUpload = Meteor.isClient ? FileUpload = function () {                                 // 2773
    FileUpload.prototype.__proto__ = EventEmitter.prototype;                                                           // 2774
                                                                                                                       //
    function FileUpload(config1) {                                                                                     // 2060
      var self;                                                                                                        // 2061
      this.config = config1;                                                                                           // 2060
      EventEmitter.call(this);                                                                                         // 2061
      self = this;                                                                                                     // 2062
                                                                                                                       //
      if (!this.config.isBase64) {                                                                                     // 2063
        this.file = _.extend(this.config.file, this.config.fileData);                                                  // 2064
      } else {                                                                                                         // 2063
        this.file = this.config.fileData;                                                                              // 2066
      }                                                                                                                // 2785
                                                                                                                       //
      this.state = new ReactiveVar('active');                                                                          // 2067
      this.onPause = new ReactiveVar(false);                                                                           // 2068
      this.progress = new ReactiveVar(0);                                                                              // 2069
      this.estimateTime = new ReactiveVar(1000);                                                                       // 2070
      this.estimateSpeed = new ReactiveVar(0);                                                                         // 2071
      this.estimateTimer = Meteor.setInterval(function () {                                                            // 2072
        var _currentTime;                                                                                              // 2073
                                                                                                                       //
        if (self.state.get() === 'active') {                                                                           // 2073
          _currentTime = self.estimateTime.get();                                                                      // 2074
                                                                                                                       //
          if (_currentTime > 1000) {                                                                                   // 2075
            self.estimateTime.set(_currentTime - 1000);                                                                // 2076
          }                                                                                                            // 2073
        }                                                                                                              // 2798
      }, 1000);                                                                                                        // 2072
    }                                                                                                                  // 2060
                                                                                                                       //
    FileUpload.prototype.continueFunc = function () {};                                                                // 2802
                                                                                                                       //
    FileUpload.prototype.pause = function () {                                                                         // 2804
      if (this.config.debug) {                                                                                         // 2081
        console.info('[FilesCollection] [insert] [.pause()]');                                                         // 2081
      }                                                                                                                // 2807
                                                                                                                       //
      if (!this.onPause.get()) {                                                                                       // 2082
        this.onPause.set(true);                                                                                        // 2083
        this.state.set('paused');                                                                                      // 2084
        this.emitEvent('pause', [this.file]);                                                                          // 2085
      }                                                                                                                // 2812
    };                                                                                                                 // 2080
                                                                                                                       //
    FileUpload.prototype["continue"] = function () {                                                                   // 2815
      if (this.config.debug) {                                                                                         // 2088
        console.info('[FilesCollection] [insert] [.continue()]');                                                      // 2088
      }                                                                                                                // 2818
                                                                                                                       //
      if (this.onPause.get()) {                                                                                        // 2089
        this.onPause.set(false);                                                                                       // 2090
        this.state.set('active');                                                                                      // 2091
        this.emitEvent('continue', [this.file]);                                                                       // 2092
        this.continueFunc();                                                                                           // 2093
      }                                                                                                                // 2824
    };                                                                                                                 // 2087
                                                                                                                       //
    FileUpload.prototype.toggle = function () {                                                                        // 2827
      if (this.config.debug) {                                                                                         // 2096
        console.info('[FilesCollection] [insert] [.toggle()]');                                                        // 2096
      }                                                                                                                // 2830
                                                                                                                       //
      if (this.onPause.get()) {                                                                                        // 2097
        this["continue"]();                                                                                            // 2097
      } else {                                                                                                         // 2097
        this.pause();                                                                                                  // 2097
      }                                                                                                                // 2835
    };                                                                                                                 // 2095
                                                                                                                       //
    FileUpload.prototype.abort = function () {                                                                         // 2838
      if (this.config.debug) {                                                                                         // 2100
        console.info('[FilesCollection] [insert] [.abort()]');                                                         // 2100
      }                                                                                                                // 2841
                                                                                                                       //
      window.removeEventListener('beforeunload', this.config.beforeunload, false);                                     // 2101
      this.config.onAbort && this.config.onAbort.call(this, this.file);                                                // 2102
      this.emitEvent('abort', [this.file]);                                                                            // 2103
      this.pause();                                                                                                    // 2104
                                                                                                                       //
      this.config._onEnd();                                                                                            // 2105
                                                                                                                       //
      this.state.set('aborted');                                                                                       // 2106
                                                                                                                       //
      if (this.config.debug) {                                                                                         // 2107
        console.timeEnd('insert ' + this.config.fileData.name);                                                        // 2107
      }                                                                                                                // 2850
                                                                                                                       //
      this.config.ddp.call(this.config._Abort, this.config.fileId);                                                    // 2108
    };                                                                                                                 // 2099
                                                                                                                       //
    return FileUpload;                                                                                                 // 2854
  }() : void 0; /*                                                                                                     // 2856
                @locus Anywhere                                                                                        //
                @memberOf FilesCollection                                                                              //
                @name remove                                                                                           //
                @param {String|Object} selector - Mongo-Style selector (http://docs.meteor.com/api/collections.html#selectors)
                @param {Function} callback - Callback with one `error` argument                                        //
                @summary Remove documents from the collection                                                          //
                @returns {FilesCollection} Instance                                                                    //
                 */                                                                                                    //
                                                                                                                       //
  FilesCollection.prototype.remove = function (selector, callback) {                                                   // 2869
    var docs, files, self;                                                                                             // 2122
                                                                                                                       //
    if (selector == null) {                                                                                            // 2871
      selector = {};                                                                                                   // 2121
    }                                                                                                                  // 2873
                                                                                                                       //
    if (this.debug) {                                                                                                  // 2122
      console.info("[FilesCollection] [remove(" + JSON.stringify(selector) + ")]");                                    // 2122
    }                                                                                                                  // 2876
                                                                                                                       //
    check(selector, Match.OneOf(Object, String));                                                                      // 2123
    check(callback, Match.Optional(Function));                                                                         // 2124
                                                                                                                       //
    if (Meteor.isClient) {                                                                                             // 2126
      if (this.allowClientCode) {                                                                                      // 2127
        this.ddp.call(this._methodNames._Remove, selector, callback || NOOP);                                          // 2128
      } else {                                                                                                         // 2127
        callback && callback(new Meteor.Error(401, '[FilesCollection] [remove] Run code from client is not allowed!'));
                                                                                                                       //
        if (this.debug) {                                                                                              // 2131
          console.warn('[FilesCollection] [remove] Run code from client is not allowed!');                             // 2131
        }                                                                                                              // 2127
      }                                                                                                                // 2126
    } else {                                                                                                           // 2126
      files = this.collection.find(selector);                                                                          // 2133
                                                                                                                       //
      if (files.count() > 0) {                                                                                         // 2134
        self = this;                                                                                                   // 2135
        files.forEach(function (file) {                                                                                // 2136
          self.unlink(file);                                                                                           // 2137
        });                                                                                                            // 2136
      } else {                                                                                                         // 2134
        callback && callback(new Meteor.Error(404, 'Cursor is empty, no files is removed'));                           // 2140
        return this;                                                                                                   // 2141
      }                                                                                                                // 2898
                                                                                                                       //
      if (this.onAfterRemove) {                                                                                        // 2143
        self = this;                                                                                                   // 2144
        docs = files.fetch();                                                                                          // 2145
        this.collection.remove(selector, function () {                                                                 // 2147
          callback && callback.apply(this, arguments);                                                                 // 2148
          self.onAfterRemove(docs);                                                                                    // 2149
        });                                                                                                            // 2147
      } else {                                                                                                         // 2143
        this.collection.remove(selector, callback || NOOP);                                                            // 2152
      }                                                                                                                // 2126
    }                                                                                                                  // 2909
                                                                                                                       //
    return this;                                                                                                       // 2153
  }; /*                                                                                                                // 2121
     @locus Anywhere                                                                                                   //
     @memberOf FilesCollection                                                                                         //
     @name update                                                                                                      //
     @see http://docs.meteor.com/#/full/update                                                                         //
     @summary link Mongo.Collection update method                                                                      //
     @returns {Mongo.Collection} Instance                                                                              //
      */                                                                                                               //
                                                                                                                       //
  FilesCollection.prototype.update = function () {                                                                     // 2923
    this.collection.update.apply(this.collection, arguments);                                                          // 2164
    return this.collection;                                                                                            // 2165
  }; /*                                                                                                                // 2163
     @locus Server                                                                                                     //
     @memberOf FilesCollection                                                                                         //
     @name deny                                                                                                        //
     @param {Object} rules                                                                                             //
     @see  https://docs.meteor.com/api/collections.html#Mongo-Collection-deny                                          //
     @summary link Mongo.Collection deny methods                                                                       //
     @returns {Mongo.Collection} Instance                                                                              //
      */                                                                                                               //
                                                                                                                       //
  FilesCollection.prototype.deny = Meteor.isServer ? function (rules) {                                                // 2939
    this.collection.deny(rules);                                                                                       // 2177
    return this.collection;                                                                                            // 2178
  } : void 0; /*                                                                                                       // 2176
              @locus Server                                                                                            //
              @memberOf FilesCollection                                                                                //
              @name allow                                                                                              //
              @param {Object} rules                                                                                    //
              @see https://docs.meteor.com/api/collections.html#Mongo-Collection-allow                                 //
              @summary link Mongo.Collection allow methods                                                             //
              @returns {Mongo.Collection} Instance                                                                     //
               */                                                                                                      //
  FilesCollection.prototype.allow = Meteor.isServer ? function (rules) {                                               // 2955
    this.collection.allow(rules);                                                                                      // 2191
    return this.collection;                                                                                            // 2192
  } : void 0; /*                                                                                                       // 2190
              @locus Server                                                                                            //
              @memberOf FilesCollection                                                                                //
              @name denyClient                                                                                         //
              @see https://docs.meteor.com/api/collections.html#Mongo-Collection-deny                                  //
              @summary Shorthands for Mongo.Collection deny method                                                     //
              @returns {Mongo.Collection} Instance                                                                     //
               */                                                                                                      //
  FilesCollection.prototype.denyClient = Meteor.isServer ? function () {                                               // 2970
    this.collection.deny({                                                                                             // 2204
      insert: function () {                                                                                            // 2205
        return true;                                                                                                   // 2973
      },                                                                                                               // 2205
      update: function () {                                                                                            // 2206
        return true;                                                                                                   // 2976
      },                                                                                                               // 2205
      remove: function () {                                                                                            // 2207
        return true;                                                                                                   // 2979
      }                                                                                                                // 2205
    });                                                                                                                // 2205
    return this.collection;                                                                                            // 2208
  } : void 0; /*                                                                                                       // 2203
              @locus Server                                                                                            //
              @memberOf FilesCollection                                                                                //
              @name allowClient                                                                                        //
              @see https://docs.meteor.com/api/collections.html#Mongo-Collection-allow                                 //
              @summary Shorthands for Mongo.Collection allow method                                                    //
              @returns {Mongo.Collection} Instance                                                                     //
               */                                                                                                      //
  FilesCollection.prototype.allowClient = Meteor.isServer ? function () {                                              // 2995
    this.collection.allow({                                                                                            // 2220
      insert: function () {                                                                                            // 2221
        return true;                                                                                                   // 2998
      },                                                                                                               // 2221
      update: function () {                                                                                            // 2222
        return true;                                                                                                   // 3001
      },                                                                                                               // 2221
      remove: function () {                                                                                            // 2223
        return true;                                                                                                   // 3004
      }                                                                                                                // 2221
    });                                                                                                                // 2221
    return this.collection;                                                                                            // 2224
  } : void 0; /*                                                                                                       // 2219
              @locus Server                                                                                            //
              @memberOf FilesCollection                                                                                //
              @name unlink                                                                                             //
              @param {Object} fileRef - fileObj                                                                        //
              @param {String} version - [Optional] file's version                                                      //
              @param {Function} callback - [Optional] callback function                                                //
              @summary Unlink files and it's versions from FS                                                          //
              @returns {FilesCollection} Instance                                                                      //
               */                                                                                                      //
  FilesCollection.prototype.unlink = Meteor.isServer ? function (fileRef, version, callback) {                         // 3022
    var ref, ref1;                                                                                                     // 2239
                                                                                                                       //
    if (this.debug) {                                                                                                  // 2239
      console.info("[FilesCollection] [unlink(" + fileRef._id + ", " + version + ")]");                                // 2239
    }                                                                                                                  // 3026
                                                                                                                       //
    if (version) {                                                                                                     // 2240
      if (((ref = fileRef.versions) != null ? ref[version] : void 0) && ((ref1 = fileRef.versions[version]) != null ? ref1.path : void 0)) {
        fs.unlink(fileRef.versions[version].path, callback || NOOP);                                                   // 2242
      }                                                                                                                // 2240
    } else {                                                                                                           // 2240
      if (fileRef.versions && !_.isEmpty(fileRef.versions)) {                                                          // 2244
        _.each(fileRef.versions, function (vRef) {                                                                     // 2245
          return bound(function () {                                                                                   // 3034
            fs.unlink(vRef.path, callback || NOOP);                                                                    // 2246
          });                                                                                                          // 2245
        });                                                                                                            // 2245
      } else {                                                                                                         // 2244
        fs.unlink(fileRef.path, callback || NOOP);                                                                     // 2249
      }                                                                                                                // 2240
    }                                                                                                                  // 3041
                                                                                                                       //
    return this;                                                                                                       // 2250
  } : void 0; /*                                                                                                       // 2238
              @locus Server                                                                                            //
              @memberOf FilesCollection                                                                                //
              @name _404                                                                                               //
              @summary Internal method, used to return 404 error                                                       //
              @returns {undefined}                                                                                     //
               */                                                                                                      //
  FilesCollection.prototype._404 = Meteor.isServer ? function (http) {                                                 // 3054
    var text;                                                                                                          // 2261
                                                                                                                       //
    if (this.debug) {                                                                                                  // 2261
      console.warn("[FilesCollection] [download(" + http.request.originalUrl + ")] [_404] File not found");            // 2261
    }                                                                                                                  // 3058
                                                                                                                       //
    text = 'File Not Found :(';                                                                                        // 2262
    http.response.writeHead(404, {                                                                                     // 2263
      'Content-Length': text.length,                                                                                   // 2264
      'Content-Type': 'text/plain'                                                                                     // 2265
    });                                                                                                                // 2264
    http.response.end(text);                                                                                           // 2266
  } : void 0; /*                                                                                                       // 2260
              @locus Server                                                                                            //
              @memberOf FilesCollection                                                                                //
              @name download                                                                                           //
              @param {Object} http    - Server HTTP object                                                             //
              @param {String} version - Requested file version                                                         //
              @param {Object} fileRef - Requested file Object                                                          //
              @summary Initiates the HTTP response                                                                     //
              @returns {undefined}                                                                                     //
               */                                                                                                      //
  FilesCollection.prototype.download = Meteor.isServer ? function (http, version, fileRef) {                           // 3079
    var self, vRef;                                                                                                    // 2281
                                                                                                                       //
    if (version == null) {                                                                                             // 3081
      version = 'original';                                                                                            // 2280
    }                                                                                                                  // 3083
                                                                                                                       //
    if (this.debug) {                                                                                                  // 2281
      console.info("[FilesCollection] [download(" + http.request.originalUrl + ", " + version + ")]");                 // 2281
    }                                                                                                                  // 3086
                                                                                                                       //
    if (fileRef) {                                                                                                     // 2282
      if (_.has(fileRef, 'versions') && _.has(fileRef.versions, version)) {                                            // 2283
        vRef = fileRef.versions[version];                                                                              // 2284
        vRef._id = fileRef._id;                                                                                        // 2285
      } else {                                                                                                         // 2283
        vRef = fileRef;                                                                                                // 2287
      }                                                                                                                // 2282
    } else {                                                                                                           // 2282
      vRef = false;                                                                                                    // 2289
    }                                                                                                                  // 3096
                                                                                                                       //
    if (!vRef || !_.isObject(vRef)) {                                                                                  // 2291
      return this._404(http);                                                                                          // 2292
    } else if (fileRef) {                                                                                              // 2291
      self = this;                                                                                                     // 2294
                                                                                                                       //
      if (this.downloadCallback) {                                                                                     // 2296
        if (!this.downloadCallback.call(_.extend(http, this._getUser(http)), fileRef)) {                               // 2297
          return this._404(http);                                                                                      // 2298
        }                                                                                                              // 2296
      }                                                                                                                // 3105
                                                                                                                       //
      if (this.interceptDownload && _.isFunction(this.interceptDownload)) {                                            // 2300
        if (this.interceptDownload(http, fileRef, version) === true) {                                                 // 2301
          return;                                                                                                      // 2302
        }                                                                                                              // 2300
      }                                                                                                                // 3110
                                                                                                                       //
      fs.stat(vRef.path, function (statErr, stats) {                                                                   // 2304
        return bound(function () {                                                                                     // 3112
          var responseType;                                                                                            // 2305
                                                                                                                       //
          if (statErr || !stats.isFile()) {                                                                            // 2305
            return self._404(http);                                                                                    // 2306
          }                                                                                                            // 3116
                                                                                                                       //
          if (stats.size !== vRef.size && !self.integrityCheck) {                                                      // 2308
            vRef.size = stats.size;                                                                                    // 2308
          }                                                                                                            // 3119
                                                                                                                       //
          if (stats.size !== vRef.size && self.integrityCheck) {                                                       // 2309
            responseType = '400';                                                                                      // 2309
          }                                                                                                            // 3122
                                                                                                                       //
          return self.serve(http, fileRef, vRef, version, null, responseType || '200');                                // 3123
        });                                                                                                            // 2304
      });                                                                                                              // 2304
    } else {                                                                                                           // 2293
      return this._404(http);                                                                                          // 2313
    }                                                                                                                  // 3128
  } : void 0; /*                                                                                                       // 2280
              @locus Server                                                                                            //
              @memberOf FilesCollection                                                                                //
              @name serve                                                                                              //
              @param {Object} http    - Server HTTP object                                                             //
              @param {Object} fileRef - Requested file Object                                                          //
              @param {Object} vRef    - Requested file version Object                                                  //
              @param {String} version - Requested file version                                                         //
              @param {stream.Readable|null} readableStream - Readable stream, which serves binary file data            //
              @param {String} responseType - Response code                                                             //
              @param {Boolean} force200 - Force 200 response code over 206                                             //
              @summary Handle and reply to incoming request                                                            //
              @returns {undefined}                                                                                     //
               */                                                                                                      //
  FilesCollection.prototype.serve = Meteor.isServer ? function (http, fileRef, vRef, version, readableStream, responseType, force200) {
    var array, dispositionEncoding, dispositionName, dispositionType, end, headers, key, partiral, reqRange, self, start, stream, streamErrorHandler, take, text, value;
                                                                                                                       //
    if (version == null) {                                                                                             // 3149
      version = 'original';                                                                                            // 2330
    }                                                                                                                  // 3151
                                                                                                                       //
    if (readableStream == null) {                                                                                      // 3152
      readableStream = null;                                                                                           // 2330
    }                                                                                                                  // 3154
                                                                                                                       //
    if (responseType == null) {                                                                                        // 3155
      responseType = '200';                                                                                            // 2330
    }                                                                                                                  // 3157
                                                                                                                       //
    if (force200 == null) {                                                                                            // 3158
      force200 = false;                                                                                                // 2330
    }                                                                                                                  // 3160
                                                                                                                       //
    self = this;                                                                                                       // 2331
    partiral = false;                                                                                                  // 2332
    reqRange = false;                                                                                                  // 2333
                                                                                                                       //
    if (http.params.query.download && http.params.query.download === 'true') {                                         // 2335
      dispositionType = 'attachment; ';                                                                                // 2336
    } else {                                                                                                           // 2335
      dispositionType = 'inline; ';                                                                                    // 2338
    }                                                                                                                  // 3168
                                                                                                                       //
    dispositionName = "filename=\"" + encodeURIComponent(fileRef.name) + "\"; filename=*UTF-8\"" + encodeURIComponent(fileRef.name) + "\"; ";
    dispositionEncoding = 'charset=utf-8';                                                                             // 2341
    http.response.setHeader('Content-Disposition', dispositionType + dispositionName + dispositionEncoding);           // 2343
                                                                                                                       //
    if (http.request.headers.range && !force200) {                                                                     // 2345
      partiral = true;                                                                                                 // 2346
      array = http.request.headers.range.split(/bytes=([0-9]*)-([0-9]*)/);                                             // 2347
      start = parseInt(array[1]);                                                                                      // 2348
      end = parseInt(array[2]);                                                                                        // 2349
                                                                                                                       //
      if (isNaN(end)) {                                                                                                // 2350
        end = vRef.size - 1;                                                                                           // 2350
      }                                                                                                                // 3179
                                                                                                                       //
      take = end - start;                                                                                              // 2351
    } else {                                                                                                           // 2345
      start = 0;                                                                                                       // 2353
      end = vRef.size - 1;                                                                                             // 2354
      take = vRef.size;                                                                                                // 2355
    }                                                                                                                  // 3185
                                                                                                                       //
    if (partiral || http.params.query.play && http.params.query.play === 'true') {                                     // 2357
      reqRange = {                                                                                                     // 2358
        start: start,                                                                                                  // 2358
        end: end                                                                                                       // 2358
      };                                                                                                               // 2358
                                                                                                                       //
      if (isNaN(start) && !isNaN(end)) {                                                                               // 2359
        reqRange.start = end - take;                                                                                   // 2360
        reqRange.end = end;                                                                                            // 2361
      }                                                                                                                // 3194
                                                                                                                       //
      if (!isNaN(start) && isNaN(end)) {                                                                               // 2362
        reqRange.start = start;                                                                                        // 2363
        reqRange.end = start + take;                                                                                   // 2364
      }                                                                                                                // 3198
                                                                                                                       //
      if (start + take >= vRef.size) {                                                                                 // 2366
        reqRange.end = vRef.size - 1;                                                                                  // 2366
      }                                                                                                                // 3201
                                                                                                                       //
      if (self.strict && (reqRange.start >= vRef.size - 1 || reqRange.end > vRef.size - 1)) {                          // 2368
        responseType = '416';                                                                                          // 2369
      } else {                                                                                                         // 2368
        responseType = '206';                                                                                          // 2371
      }                                                                                                                // 2357
    } else {                                                                                                           // 2357
      responseType = '200';                                                                                            // 2373
    }                                                                                                                  // 3209
                                                                                                                       //
    streamErrorHandler = function (error) {                                                                            // 2375
      http.response.writeHead(500);                                                                                    // 2376
      http.response.end(error.toString());                                                                             // 2377
                                                                                                                       //
      if (self.debug) {                                                                                                // 2378
        console.error("[FilesCollection] [serve(" + vRef.path + ", " + version + ")] [500]", error);                   // 2378
      }                                                                                                                // 3215
    };                                                                                                                 // 2375
                                                                                                                       //
    headers = _.isFunction(self.responseHeaders) ? self.responseHeaders(responseType, fileRef, vRef, version) : self.responseHeaders;
                                                                                                                       //
    if (!headers['Cache-Control']) {                                                                                   // 2383
      http.response.setHeader('Cache-Control', self.cacheControl);                                                     // 2384
    }                                                                                                                  // 3220
                                                                                                                       //
    for (key in meteorBabelHelpers.sanitizeForInObject(headers)) {                                                     // 2386
      value = headers[key];                                                                                            // 3222
      http.response.setHeader(key, value);                                                                             // 2387
    }                                                                                                                  // 2386
                                                                                                                       //
    switch (responseType) {                                                                                            // 2389
      case '400':                                                                                                      // 2389
        if (self.debug) {                                                                                              // 2391
          console.warn("[FilesCollection] [serve(" + vRef.path + ", " + version + ")] [400] Content-Length mismatch!");
        }                                                                                                              // 3229
                                                                                                                       //
        text = 'Content-Length mismatch!';                                                                             // 2392
        http.response.writeHead(400, {                                                                                 // 2393
          'Content-Type': 'text/plain',                                                                                // 2394
          'Content-Length': text.length                                                                                // 2395
        });                                                                                                            // 2394
        http.response.end(text);                                                                                       // 2396
        break;                                                                                                         // 2397
                                                                                                                       //
      case '404':                                                                                                      // 2389
        return self._404(http);                                                                                        // 2399
        break;                                                                                                         // 2400
                                                                                                                       //
      case '416':                                                                                                      // 2389
        if (self.debug) {                                                                                              // 2402
          console.warn("[FilesCollection] [serve(" + vRef.path + ", " + version + ")] [416] Content-Range is not specified!");
        }                                                                                                              // 3243
                                                                                                                       //
        http.response.writeHead(416);                                                                                  // 2403
        http.response.end();                                                                                           // 2404
        break;                                                                                                         // 2405
                                                                                                                       //
      case '200':                                                                                                      // 2389
        if (self.debug) {                                                                                              // 2407
          console.info("[FilesCollection] [serve(" + vRef.path + ", " + version + ")] [200]");                         // 2407
        }                                                                                                              // 3250
                                                                                                                       //
        stream = readableStream || fs.createReadStream(vRef.path);                                                     // 2408
                                                                                                                       //
        if (readableStream) {                                                                                          // 2409
          http.response.writeHead(200);                                                                                // 2409
        }                                                                                                              // 3254
                                                                                                                       //
        stream.on('open', function () {                                                                                // 2410
          http.response.writeHead(200);                                                                                // 2411
        }).on('error', streamErrorHandler).on('end', function () {                                                     // 2410
          http.response.end();                                                                                         // 2415
        });                                                                                                            // 2410
                                                                                                                       //
        if (self.throttle) {                                                                                           // 2417
          stream.pipe(new Throttle({                                                                                   // 2417
            bps: self.throttle,                                                                                        // 2417
            chunksize: self.chunkSize                                                                                  // 2417
          }));                                                                                                         // 2417
        }                                                                                                              // 3265
                                                                                                                       //
        stream.pipe(http.response);                                                                                    // 2418
        break;                                                                                                         // 2419
                                                                                                                       //
      case '206':                                                                                                      // 2389
        if (self.debug) {                                                                                              // 2421
          console.info("[FilesCollection] [serve(" + vRef.path + ", " + version + ")] [206]");                         // 2421
        }                                                                                                              // 3271
                                                                                                                       //
        http.response.setHeader('Content-Range', "bytes " + reqRange.start + "-" + reqRange.end + "/" + vRef.size);    // 2422
        stream = readableStream || fs.createReadStream(vRef.path, {                                                    // 2423
          start: reqRange.start,                                                                                       // 2423
          end: reqRange.end                                                                                            // 2423
        });                                                                                                            // 2423
                                                                                                                       //
        if (readableStream) {                                                                                          // 2424
          http.response.writeHead(206);                                                                                // 2424
        }                                                                                                              // 3279
                                                                                                                       //
        stream.on('open', function () {                                                                                // 2425
          http.response.writeHead(206);                                                                                // 2426
        }).on('error', streamErrorHandler).on('end', function () {                                                     // 2425
          http.response.end();                                                                                         // 2430
        });                                                                                                            // 2425
                                                                                                                       //
        if (self.throttle) {                                                                                           // 2432
          stream.pipe(new Throttle({                                                                                   // 2432
            bps: self.throttle,                                                                                        // 2432
            chunksize: self.chunkSize                                                                                  // 2432
          }));                                                                                                         // 2432
        }                                                                                                              // 3290
                                                                                                                       //
        stream.pipe(http.response);                                                                                    // 2433
        break;                                                                                                         // 2434
    }                                                                                                                  // 2389
  } : void 0; /*                                                                                                       // 2330
              @locus Anywhere                                                                                          //
              @memberOf FilesCollection                                                                                //
              @name link                                                                                               //
              @param {Object} fileRef - File reference object                                                          //
              @param {String} version - Version of file you would like to request                                      //
              @summary Returns downloadable URL                                                                        //
              @returns {String} Empty string returned in case if file not found in DB                                  //
               */                                                                                                      //
                                                                                                                       //
  FilesCollection.prototype.link = function (fileRef, version) {                                                       // 3307
    if (version == null) {                                                                                             // 3308
      version = 'original';                                                                                            // 2447
    }                                                                                                                  // 3310
                                                                                                                       //
    if (this.debug) {                                                                                                  // 2448
      console.info("[FilesCollection] [link(" + (fileRef != null ? fileRef._id : void 0) + ", " + version + ")]");     // 2448
    }                                                                                                                  // 3313
                                                                                                                       //
    check(fileRef, Object);                                                                                            // 2449
    check(version, String);                                                                                            // 2450
                                                                                                                       //
    if (!fileRef) {                                                                                                    // 2451
      return '';                                                                                                       // 2451
    }                                                                                                                  // 3318
                                                                                                                       //
    return formatFleURL(fileRef, version);                                                                             // 2452
  };                                                                                                                   // 2447
                                                                                                                       //
  return FilesCollection;                                                                                              // 3322
}()); /*                                                                                                               // 3324
      @locus Anywhere                                                                                                  //
      @private                                                                                                         //
      @name formatFleURL                                                                                               //
      @param {Object} fileRef - File reference object                                                                  //
      @param {String} version - [Optional] Version of file you would like build URL for                                //
      @summary Returns formatted URL for file                                                                          //
      @returns {String} Downloadable link                                                                              //
       */                                                                                                              //
                                                                                                                       //
formatFleURL = function (fileRef, version) {                                                                           // 2463
  var ext, ref, root;                                                                                                  // 2464
                                                                                                                       //
  if (version == null) {                                                                                               // 3339
    version = 'original';                                                                                              // 2463
  }                                                                                                                    // 3341
                                                                                                                       //
  check(fileRef, Object);                                                                                              // 2464
  check(version, String);                                                                                              // 2465
  root = __meteor_runtime_config__.ROOT_URL.replace(/\/+$/, '');                                                       // 2467
                                                                                                                       //
  if ((ref = fileRef.extension) != null ? ref.length : void 0) {                                                       // 2469
    ext = '.' + fileRef.extension;                                                                                     // 2470
  } else {                                                                                                             // 2469
    ext = '';                                                                                                          // 2472
  }                                                                                                                    // 3349
                                                                                                                       //
  if (fileRef["public"] === true) {                                                                                    // 2474
    return root + (version === 'original' ? fileRef._downloadRoute + "/" + fileRef._id + ext : fileRef._downloadRoute + "/" + version + "-" + fileRef._id + ext);
  } else {                                                                                                             // 2474
    return root + (fileRef._downloadRoute + "/" + fileRef._collectionName + "/" + fileRef._id + "/" + version + "/" + fileRef._id + ext);
  }                                                                                                                    // 3354
};                                                                                                                     // 2463
                                                                                                                       //
if (Meteor.isClient) {                                                                                                 // 2479
  /*                                                                                                                   // 2480
  @locus Client                                                                                                        //
  @TemplateHelper                                                                                                      //
  @name fileURL                                                                                                        //
  @param {Object} fileRef - File reference object                                                                      //
  @param {String} version - [Optional] Version of file you would like to request                                       //
  @summary Get download URL for file by fileRef, even without subscription                                             //
  @example {{fileURL fileRef}}                                                                                         //
  @returns {String}                                                                                                    //
   */Meteor.startup(function () {                                                                                      //
    if (typeof Template !== "undefined" && Template !== null) {                                                        // 2491
      Template.registerHelper('fileURL', function (fileRef, version) {                                                 // 2492
        if (!fileRef || !_.isObject(fileRef)) {                                                                        // 2493
          return void 0;                                                                                               // 2493
        }                                                                                                              // 3374
                                                                                                                       //
        version = !version || !_.isString(version) ? 'original' : version;                                             // 2494
                                                                                                                       //
        if (fileRef._id) {                                                                                             // 2495
          return formatFleURL(fileRef, version);                                                                       // 2496
        } else {                                                                                                       // 2495
          return '';                                                                                                   // 2498
        }                                                                                                              // 3380
      });                                                                                                              // 2492
    }                                                                                                                  // 3382
  });                                                                                                                  // 2490
} /*                                                                                                                   // 3384
  Export the FilesCollection class                                                                                     //
   */                                                                                                                  //
                                                                                                                       //
Meteor.Files = FilesCollection;                                                                                        // 2504
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"event-emitter.jsx":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/ostrio_files/event-emitter.jsx                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                                //
                                                                                                                       //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
module.export({                                                                                                        // 1
  EventEmitter: function () {                                                                                          // 1
    return EventEmitter;                                                                                               // 1
  }                                                                                                                    // 1
});                                                                                                                    // 1
                                                                                                                       //
/*!                                                                                                                    // 1
 * EventEmitter v4.2.11 - git.io/ee                                                                                    //
 * Unlicense - http://unlicense.org/                                                                                   //
 * Oliver Caldwell - http://oli.me.uk/                                                                                 //
 * @preserve                                                                                                           //
 */ /**                                                                                                                //
     * Class for managing events.                                                                                      //
     * Can be extended to provide event functionality in other classes.                                                //
     *                                                                                                                 //
     * @class EventEmitter Manages event registering and emitting.                                                     //
     */function EventEmitter() {} // Shortcuts to improve speed and size                                               //
                                                                                                                       //
                                                                                                                       //
var proto = EventEmitter.prototype;                                                                                    // 17
                                                                                                                       //
var _exports = this;                                                                                                   // 18
                                                                                                                       //
var originalGlobalValue = _exports.EventEmitter; /**                                                                   // 19
                                                  * Finds the index of the listener for the event in its storage array.
                                                  *                                                                    //
                                                  * @param {Function[]} listeners Array of listeners to search through.
                                                  * @param {Function} listener Method to look for.                     //
                                                  * @return {Number} Index of the specified listener, -1 if not found  //
                                                  * @api private                                                       //
                                                  */                                                                   //
                                                                                                                       //
function indexOfListener(listeners, listener) {                                                                        // 29
  var i = listeners.length;                                                                                            // 30
                                                                                                                       //
  while (i--) {                                                                                                        // 31
    if (listeners[i].listener === listener) {                                                                          // 32
      return i;                                                                                                        // 33
    }                                                                                                                  // 34
  }                                                                                                                    // 35
                                                                                                                       //
  return -1;                                                                                                           // 37
} /**                                                                                                                  // 38
   * Alias a method while keeping the context correct, to allow for overwriting of target method.                      //
   *                                                                                                                   //
   * @param {String} name The name of the target method.                                                               //
   * @return {Function} The aliased method                                                                             //
   * @api private                                                                                                      //
   */                                                                                                                  //
                                                                                                                       //
function alias(name) {                                                                                                 // 47
  return function () {                                                                                                 // 48
    function aliasClosure() {                                                                                          // 48
      return this[name].apply(this, arguments);                                                                        // 49
    }                                                                                                                  // 50
                                                                                                                       //
    return aliasClosure;                                                                                               // 48
  }();                                                                                                                 // 48
} /**                                                                                                                  // 51
   * Returns the listener array for the specified event.                                                               //
   * Will initialise the event object and listener arrays if required.                                                 //
   * Will return an object if you use a regex search. The object contains keys for each matched event. So /ba[rz]/ might return an object containing bar and baz. But only if you have either defined them with defineEvent or added some listeners to them.
   * Each property in the object response is an array of listener functions.                                           //
   *                                                                                                                   //
   * @param {String|RegExp} evt Name of the event to return the listeners from.                                        //
   * @return {Function[]|Object} All listener functions for the event.                                                 //
   */                                                                                                                  //
                                                                                                                       //
proto.getListeners = function () {                                                                                     // 62
  function getListeners(evt) {                                                                                         // 62
    var events = this._getEvents();                                                                                    // 63
                                                                                                                       //
    var response = void 0;                                                                                             // 64
    var key = void 0; // Return a concatenated array of all matching events if                                         // 65
    // the selector is a regular expression.                                                                           // 68
                                                                                                                       //
    if (evt instanceof RegExp) {                                                                                       // 69
      response = {};                                                                                                   // 70
                                                                                                                       //
      for (key in meteorBabelHelpers.sanitizeForInObject(events)) {                                                    // 71
        if (events.hasOwnProperty(key) && evt.test(key)) {                                                             // 72
          response[key] = events[key];                                                                                 // 73
        }                                                                                                              // 74
      }                                                                                                                // 75
    } else {                                                                                                           // 76
      response = events[evt] || (events[evt] = []);                                                                    // 77
    }                                                                                                                  // 78
                                                                                                                       //
    return response;                                                                                                   // 80
  }                                                                                                                    // 81
                                                                                                                       //
  return getListeners;                                                                                                 // 62
}(); /**                                                                                                               // 62
      * Takes a list of listener objects and flattens it into a list of listener functions.                            //
      *                                                                                                                //
      * @param {Object[]} listeners Raw listener objects.                                                              //
      * @return {Function[]} Just the listener functions.                                                              //
      */                                                                                                               //
                                                                                                                       //
proto.flattenListeners = function () {                                                                                 // 89
  function flattenListeners(listeners) {                                                                               // 89
    var flatListeners = [];                                                                                            // 90
    var i = void 0;                                                                                                    // 91
                                                                                                                       //
    for (i = 0; i < listeners.length; i += 1) {                                                                        // 93
      flatListeners.push(listeners[i].listener);                                                                       // 94
    }                                                                                                                  // 95
                                                                                                                       //
    return flatListeners;                                                                                              // 97
  }                                                                                                                    // 98
                                                                                                                       //
  return flattenListeners;                                                                                             // 89
}(); /**                                                                                                               // 89
      * Fetches the requested listeners via getListeners but will always return the results inside an object. This is mainly for internal use but others may find it useful.
      *                                                                                                                //
      * @param {String|RegExp} evt Name of the event to return the listeners from.                                     //
      * @return {Object} All listener functions for an event in an object.                                             //
      */                                                                                                               //
                                                                                                                       //
proto.getListenersAsObject = function () {                                                                             // 106
  function getListenersAsObject(evt) {                                                                                 // 106
    var listeners = this.getListeners(evt);                                                                            // 107
    var response = void 0;                                                                                             // 108
                                                                                                                       //
    if (listeners instanceof Array) {                                                                                  // 110
      response = {};                                                                                                   // 111
      response[evt] = listeners;                                                                                       // 112
    }                                                                                                                  // 113
                                                                                                                       //
    return response || listeners;                                                                                      // 115
  }                                                                                                                    // 116
                                                                                                                       //
  return getListenersAsObject;                                                                                         // 106
}(); /**                                                                                                               // 106
      * Adds a listener function to the specified event.                                                               //
      * The listener will not be added if it is a duplicate.                                                           //
      * If the listener returns true then it will be removed after it is called.                                       //
      * If you pass a regular expression as the event name then the listener will be added to all events that match it.
      *                                                                                                                //
      * @param {String|RegExp} evt Name of the event to attach the listener to.                                        //
      * @param {Function} listener Method to be called when the event is emitted. If the function returns true then it will be removed after calling.
      * @return {Object} Current instance of EventEmitter for chaining.                                                //
      */                                                                                                               //
                                                                                                                       //
proto.addListener = function () {                                                                                      // 128
  function addListener(evt, listener) {                                                                                // 128
    var listeners = this.getListenersAsObject(evt);                                                                    // 129
    var listenerIsWrapped = (typeof listener === "undefined" ? "undefined" : (0, _typeof3.default)(listener)) === 'object';
    var key = void 0;                                                                                                  // 131
                                                                                                                       //
    for (key in meteorBabelHelpers.sanitizeForInObject(listeners)) {                                                   // 133
      if (listeners.hasOwnProperty(key) && indexOfListener(listeners[key], listener) === -1) {                         // 134
        listeners[key].push(listenerIsWrapped ? listener : {                                                           // 135
          listener: listener,                                                                                          // 136
          once: false                                                                                                  // 137
        });                                                                                                            // 135
      }                                                                                                                // 139
    }                                                                                                                  // 140
                                                                                                                       //
    return this;                                                                                                       // 142
  }                                                                                                                    // 143
                                                                                                                       //
  return addListener;                                                                                                  // 128
}(); /**                                                                                                               // 128
      * Alias of addListener                                                                                           //
      */                                                                                                               //
                                                                                                                       //
proto.on = alias('addListener'); /**                                                                                   // 148
                                  * Semi-alias of addListener. It will add a listener that will be                     //
                                  * automatically removed after its first execution.                                   //
                                  *                                                                                    //
                                  * @param {String|RegExp} evt Name of the event to attach the listener to.            //
                                  * @param {Function} listener Method to be called when the event is emitted. If the function returns true then it will be removed after calling.
                                  * @return {Object} Current instance of EventEmitter for chaining.                    //
                                  */                                                                                   //
                                                                                                                       //
proto.addOnceListener = function () {                                                                                  // 158
  function addOnceListener(evt, listener) {                                                                            // 158
    return this.addListener(evt, {                                                                                     // 159
      listener: listener,                                                                                              // 160
      once: true                                                                                                       // 161
    });                                                                                                                // 159
  }                                                                                                                    // 163
                                                                                                                       //
  return addOnceListener;                                                                                              // 158
}(); /**                                                                                                               // 158
      * Alias of addOnceListener.                                                                                      //
      */                                                                                                               //
                                                                                                                       //
proto.once = alias('addOnceListener'); /**                                                                             // 168
                                        * Defines an event name. This is required if you want to use a regex to add a listener to multiple events at once. If you don't do this then how do you expect it to know what event to add to? Should it just add to every possible match for a regex? No. That is scary and bad.
                                        * You need to tell it what event names should be matched by a regex.           //
                                        *                                                                              //
                                        * @param {String} evt Name of the event to create.                             //
                                        * @return {Object} Current instance of EventEmitter for chaining.              //
                                        */                                                                             //
                                                                                                                       //
proto.defineEvent = function () {                                                                                      // 177
  function defineEvent(evt) {                                                                                          // 177
    this.getListeners(evt);                                                                                            // 178
    return this;                                                                                                       // 179
  }                                                                                                                    // 180
                                                                                                                       //
  return defineEvent;                                                                                                  // 177
}(); /**                                                                                                               // 177
      * Uses defineEvent to define multiple events.                                                                    //
      *                                                                                                                //
      * @param {String[]} evts An array of event names to define.                                                      //
      * @return {Object} Current instance of EventEmitter for chaining.                                                //
      */                                                                                                               //
                                                                                                                       //
proto.defineEvents = function () {                                                                                     // 188
  function defineEvents(evts) {                                                                                        // 188
    for (var i = 0; i < evts.length; i += 1) {                                                                         // 189
      this.defineEvent(evts[i]);                                                                                       // 190
    }                                                                                                                  // 191
                                                                                                                       //
    return this;                                                                                                       // 192
  }                                                                                                                    // 193
                                                                                                                       //
  return defineEvents;                                                                                                 // 188
}(); /**                                                                                                               // 188
      * Removes a listener function from the specified event.                                                          //
      * When passed a regular expression as the event name, it will remove the listener from all events that match it.
      *                                                                                                                //
      * @param {String|RegExp} evt Name of the event to remove the listener from.                                      //
      * @param {Function} listener Method to remove from the event.                                                    //
      * @return {Object} Current instance of EventEmitter for chaining.                                                //
      */                                                                                                               //
                                                                                                                       //
proto.removeListener = function () {                                                                                   // 203
  function removeListener(evt, listener) {                                                                             // 203
    var listeners = this.getListenersAsObject(evt);                                                                    // 204
    var index = void 0;                                                                                                // 205
    var key = void 0;                                                                                                  // 206
                                                                                                                       //
    for (key in meteorBabelHelpers.sanitizeForInObject(listeners)) {                                                   // 208
      if (listeners.hasOwnProperty(key)) {                                                                             // 209
        index = indexOfListener(listeners[key], listener);                                                             // 210
                                                                                                                       //
        if (index !== -1) {                                                                                            // 212
          listeners[key].splice(index, 1);                                                                             // 213
        }                                                                                                              // 214
      }                                                                                                                // 215
    }                                                                                                                  // 216
                                                                                                                       //
    return this;                                                                                                       // 218
  }                                                                                                                    // 219
                                                                                                                       //
  return removeListener;                                                                                               // 203
}(); /**                                                                                                               // 203
      * Alias of removeListener                                                                                        //
      */                                                                                                               //
                                                                                                                       //
proto.off = alias('removeListener'); /**                                                                               // 224
                                      * Adds listeners in bulk using the manipulateListeners method.                   //
                                      * If you pass an object as the second argument you can add to multiple events at once. The object should contain key value pairs of events and listeners or listener arrays. You can also pass it an event name and an array of listeners to be added.
                                      * You can also pass it a regular expression to add the array of listeners to all events that match it.
                                      * Yeah, this function does quite a bit. That's probably a bad thing.             //
                                      *                                                                                //
                                      * @param {String|Object|RegExp} evt An event name if you will pass an array of listeners next. An object if you wish to add to multiple events at once.
                                      * @param {Function[]} [listeners] An optional array of listener functions to add.
                                      * @return {Object} Current instance of EventEmitter for chaining.                //
                                      */                                                                               //
                                                                                                                       //
proto.addListeners = function () {                                                                                     // 236
  function addListeners(evt, listeners) {                                                                              // 236
    // Pass through to manipulateListeners                                                                             // 237
    return this.manipulateListeners(false, evt, listeners);                                                            // 238
  }                                                                                                                    // 239
                                                                                                                       //
  return addListeners;                                                                                                 // 236
}(); /**                                                                                                               // 236
      * Removes listeners in bulk using the manipulateListeners method.                                                //
      * If you pass an object as the second argument you can remove from multiple events at once. The object should contain key value pairs of events and listeners or listener arrays.
      * You can also pass it an event name and an array of listeners to be removed.                                    //
      * You can also pass it a regular expression to remove the listeners from all events that match it.               //
      *                                                                                                                //
      * @param {String|Object|RegExp} evt An event name if you will pass an array of listeners next. An object if you wish to remove from multiple events at once.
      * @param {Function[]} [listeners] An optional array of listener functions to remove.                             //
      * @return {Object} Current instance of EventEmitter for chaining.                                                //
      */                                                                                                               //
                                                                                                                       //
proto.removeListeners = function () {                                                                                  // 251
  function removeListeners(evt, listeners) {                                                                           // 251
    // Pass through to manipulateListeners                                                                             // 252
    return this.manipulateListeners(true, evt, listeners);                                                             // 253
  }                                                                                                                    // 254
                                                                                                                       //
  return removeListeners;                                                                                              // 251
}(); /**                                                                                                               // 251
      * Edits listeners in bulk. The addListeners and removeListeners methods both use this to do their job. You should really use those instead, this is a little lower level.
      * The first argument will determine if the listeners are removed (true) or added (false).                        //
      * If you pass an object as the second argument you can add/remove from multiple events at once. The object should contain key value pairs of events and listeners or listener arrays.
      * You can also pass it an event name and an array of listeners to be added/removed.                              //
      * You can also pass it a regular expression to manipulate the listeners of all events that match it.             //
      *                                                                                                                //
      * @param {Boolean} remove True if you want to remove listeners, false if you want to add.                        //
      * @param {String|Object|RegExp} evt An event name if you will pass an array of listeners next. An object if you wish to add/remove from multiple events at once.
      * @param {Function[]} [listeners] An optional array of listener functions to add/remove.                         //
      * @return {Object} Current instance of EventEmitter for chaining.                                                //
      */                                                                                                               //
                                                                                                                       //
proto.manipulateListeners = function () {                                                                              // 268
  function manipulateListeners(remove, evt, listeners) {                                                               // 268
    var i = void 0;                                                                                                    // 269
    var single = remove ? this.removeListener : this.addListener;                                                      // 270
    var multiple = remove ? this.removeListeners : this.addListeners; // If evt is an object then pass each of its properties to this method
                                                                                                                       //
    if ((typeof evt === "undefined" ? "undefined" : (0, _typeof3.default)(evt)) === 'object' && !(evt instanceof RegExp)) {
      for (i in meteorBabelHelpers.sanitizeForInObject(evt)) {                                                         // 275
        if (evt.hasOwnProperty(i) && evt[i]) {                                                                         // 276
          // Pass the single listener straight through to the singular method                                          // 277
          if (typeof evt[i] === 'function') {                                                                          // 278
            single.call(this, i, evt[i]);                                                                              // 279
          } else {                                                                                                     // 280
            // Otherwise pass back to the multiple function                                                            // 281
            multiple.call(this, i, evt[i]);                                                                            // 282
          }                                                                                                            // 283
        }                                                                                                              // 284
      }                                                                                                                // 285
    } else {                                                                                                           // 286
      // So evt must be a string                                                                                       // 287
      // And listeners must be an array of listeners                                                                   // 288
      // Loop over it and pass each one to the multiple method                                                         // 289
      i = listeners.length;                                                                                            // 290
                                                                                                                       //
      while (i--) {                                                                                                    // 291
        single.call(this, evt, listeners[i]);                                                                          // 292
      }                                                                                                                // 293
    }                                                                                                                  // 294
                                                                                                                       //
    return this;                                                                                                       // 296
  }                                                                                                                    // 297
                                                                                                                       //
  return manipulateListeners;                                                                                          // 268
}(); /**                                                                                                               // 268
      * Removes all listeners from a specified event.                                                                  //
      * If you do not specify an event then all listeners will be removed.                                             //
      * That means every event will be emptied.                                                                        //
      * You can also pass a regex to remove all events that match it.                                                  //
      *                                                                                                                //
      * @param {String|RegExp} [evt] Optional name of the event to remove all listeners for. Will remove from every event if not passed.
      * @return {Object} Current instance of EventEmitter for chaining.                                                //
      */                                                                                                               //
                                                                                                                       //
proto.removeEvent = function () {                                                                                      // 308
  function removeEvent(evt) {                                                                                          // 308
    var type = typeof evt === "undefined" ? "undefined" : (0, _typeof3.default)(evt);                                  // 309
                                                                                                                       //
    var events = this._getEvents();                                                                                    // 310
                                                                                                                       //
    var key = void 0; // Remove different things depending on the state of evt                                         // 311
                                                                                                                       //
    if (type === 'string') {                                                                                           // 314
      // Remove all listeners for the specified event                                                                  // 315
      delete events[evt];                                                                                              // 316
    } else if (evt instanceof RegExp) {                                                                                // 317
      // Remove all events matching the regex.                                                                         // 318
      for (key in meteorBabelHelpers.sanitizeForInObject(events)) {                                                    // 319
        if (events.hasOwnProperty(key) && evt.test(key)) {                                                             // 320
          delete events[key];                                                                                          // 321
        }                                                                                                              // 322
      }                                                                                                                // 323
    } else {                                                                                                           // 324
      // Remove all listeners in all events                                                                            // 325
      delete this._events;                                                                                             // 326
    }                                                                                                                  // 327
                                                                                                                       //
    return this;                                                                                                       // 329
  }                                                                                                                    // 330
                                                                                                                       //
  return removeEvent;                                                                                                  // 308
}(); /**                                                                                                               // 308
      * Alias of removeEvent.                                                                                          //
      *                                                                                                                //
      * Added to mirror the node API.                                                                                  //
      */                                                                                                               //
                                                                                                                       //
proto.removeAllListeners = alias('removeEvent'); /**                                                                   // 337
                                                  * Emits an event of your choice.                                     //
                                                  * When emitted, every listener attached to that event will be executed.
                                                  * If you pass the optional argument array then those arguments will be passed to every listener upon execution.
                                                  * Because it uses `apply`, your array of arguments will be passed as if you wrote them out separately.
                                                  * So they will not arrive within the array on the other side, they will be separate.
                                                  * You can also pass a regular expression to emit to all events that match it.
                                                  *                                                                    //
                                                  * @param {String|RegExp} evt Name of the event to emit and execute listeners for.
                                                  * @param {Array} [args] Optional array of arguments to be passed to each listener.
                                                  * @return {Object} Current instance of EventEmitter for chaining.    //
                                                  */                                                                   //
                                                                                                                       //
proto.emitEvent = function () {                                                                                        // 351
  function emitEvent(evt, args) {                                                                                      // 351
    var listenersMap = this.getListenersAsObject(evt);                                                                 // 352
    var listeners = void 0;                                                                                            // 353
    var listener = void 0;                                                                                             // 354
    var i = void 0;                                                                                                    // 355
    var key = void 0;                                                                                                  // 356
    var response = void 0;                                                                                             // 357
                                                                                                                       //
    for (key in meteorBabelHelpers.sanitizeForInObject(listenersMap)) {                                                // 359
      if (listenersMap.hasOwnProperty(key)) {                                                                          // 360
        listeners = listenersMap[key].slice(0);                                                                        // 361
        i = listeners.length;                                                                                          // 362
                                                                                                                       //
        while (i--) {                                                                                                  // 364
          // If the listener returns true then it shall be removed from the event                                      // 365
          // The function is executed either with a basic call or an apply if there is an args array                   // 366
          listener = listeners[i];                                                                                     // 367
                                                                                                                       //
          if (listener.once === true) {                                                                                // 369
            this.removeListener(evt, listener.listener);                                                               // 370
          }                                                                                                            // 371
                                                                                                                       //
          response = listener.listener.apply(this, args || []);                                                        // 373
                                                                                                                       //
          if (response === this._getOnceReturnValue()) {                                                               // 375
            this.removeListener(evt, listener.listener);                                                               // 376
          }                                                                                                            // 377
        }                                                                                                              // 378
      }                                                                                                                // 379
    }                                                                                                                  // 380
                                                                                                                       //
    return this;                                                                                                       // 382
  }                                                                                                                    // 383
                                                                                                                       //
  return emitEvent;                                                                                                    // 351
}(); /**                                                                                                               // 351
      * Alias of emitEvent                                                                                             //
      */                                                                                                               //
                                                                                                                       //
proto.trigger = alias('emitEvent'); /**                                                                                // 388
                                     * Subtly different from emitEvent in that it will pass its arguments on to the listeners, as opposed to taking a single array of arguments to pass on.
                                     * As with emitEvent, you can pass a regex in place of the event name to emit to all events that match it.
                                     *                                                                                 //
                                     * @param {String|RegExp} evt Name of the event to emit and execute listeners for.
                                     * @param {...*} Optional additional arguments to be passed to each listener.      //
                                     * @return {Object} Current instance of EventEmitter for chaining.                 //
                                     */                                                                                //
                                                                                                                       //
proto.emit = function () {                                                                                             // 398
  function emit(evt) {                                                                                                 // 398
    var args = Array.prototype.slice.call(arguments, 1);                                                               // 399
    return this.emitEvent(evt, args);                                                                                  // 400
  }                                                                                                                    // 401
                                                                                                                       //
  return emit;                                                                                                         // 398
}(); /**                                                                                                               // 398
      * Sets the current value to check against when executing listeners. If a                                         //
      * listeners return value matches the one set here then it will be removed                                        //
      * after execution. This value defaults to true.                                                                  //
      *                                                                                                                //
      * @param {*} value The new value to check for when executing listeners.                                          //
      * @return {Object} Current instance of EventEmitter for chaining.                                                //
      */                                                                                                               //
                                                                                                                       //
proto.setOnceReturnValue = function () {                                                                               // 411
  function setOnceReturnValue(value) {                                                                                 // 411
    this._onceReturnValue = value;                                                                                     // 412
    return this;                                                                                                       // 413
  }                                                                                                                    // 414
                                                                                                                       //
  return setOnceReturnValue;                                                                                           // 411
}(); /**                                                                                                               // 411
      * Fetches the current value to check against when executing listeners. If                                        //
      * the listeners return value matches this one then it should be removed                                          //
      * automatically. It will return true by default.                                                                 //
      *                                                                                                                //
      * @return {*|Boolean} The current value to check for or the default, true.                                       //
      * @api private                                                                                                   //
      */                                                                                                               //
                                                                                                                       //
proto._getOnceReturnValue = function () {                                                                              // 424
  function _getOnceReturnValue() {                                                                                     // 424
    if (this.hasOwnProperty('_onceReturnValue')) {                                                                     // 425
      return this._onceReturnValue;                                                                                    // 426
    }                                                                                                                  // 427
                                                                                                                       //
    return true;                                                                                                       // 428
  }                                                                                                                    // 429
                                                                                                                       //
  return _getOnceReturnValue;                                                                                          // 424
}(); /**                                                                                                               // 424
      * Fetches the events object and creates one if required.                                                         //
      *                                                                                                                //
      * @return {Object} The events storage object.                                                                    //
      * @api private                                                                                                   //
      */                                                                                                               //
                                                                                                                       //
proto._getEvents = function () {                                                                                       // 437
  function _getEvents() {                                                                                              // 437
    return this._events || (this._events = {});                                                                        // 438
  }                                                                                                                    // 439
                                                                                                                       //
  return _getEvents;                                                                                                   // 437
}(); /**                                                                                                               // 437
      * Reverts the global {@link EventEmitter} to its previous value and returns a reference to this version.         //
      *                                                                                                                //
      * @return {Function} Non conflicting EventEmitter class.                                                         //
      */                                                                                                               //
                                                                                                                       //
EventEmitter.noConflict = function () {                                                                                // 446
  function noConflict() {                                                                                              // 446
    _exports.EventEmitter = originalGlobalValue;                                                                       // 447
    return EventEmitter;                                                                                               // 448
  }                                                                                                                    // 449
                                                                                                                       //
  return noConflict;                                                                                                   // 446
}(); // Expose the class                                                                                               // 446
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json",".coffee",".jsx"]});
var exports = require("./node_modules/meteor/ostrio:files/files.coffee.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['ostrio:files'] = exports, {
  FilesCollection: FilesCollection
});

})();

//# sourceMappingURL=ostrio_files.js.map
